										
                                        /* PROGETTO FINALE */

	 /* In tale progetto viene realizzata l'assegnazione dinamica delle sottoportanti agli
	    utenti: per assegnazione dinamica intendiamo la possibilit che una sottoportante
		possa essere liberata da un utente e successivamente possa essere riacquisita da un
		altro utente. In progetto 20 esiste la possibilit che un utente possa fallire un HO,
		cio che un utente trovi nella BS di destinazione tutte le sottoportanti occupate e
		quindi perda la propria comunicazione. Il modo in cui gli utenti attivi richiedono le
		sottoportanti ed il modo in cui essi decidono di terminare una comunicazione  del 
        tutto randomico. */

     /* La capacit del canale  di 960000 bit al secondo, cio il canale  in grado di far
	    viaggiare 960000 bit al secondo. Tale valore si ottiene dividendo il numero di bit
		informativi presenti in una trama (PACK_SIZE = 384 bit) per la durata temporale di una
		trama (FRAMEDURATION = 400 micro sec). */	       

     /* Ho fatto in modo che fossero presenti meno HO falliti: per ottenere ci ho messo in 
	    attesa le richieste degli utenti che giungono ad una BS quando in essa e nell'altra 
        non c' almeno un certo numero di sottoportanti disponibili (MINIMO). */

     /* Ho modificato l'algoritmo di downlink per sfruttare il Soft HO. */

     
     /* I parametri con cui si effettua la simulazione finale sono: 

	    NCARRIER = 13 sottoportanti (il numero iniziale di utenti  12)
		MINIMO = 3 sottoportanti
		NUMFRAME = 600000 trame (4 minuti di simulazione reale)
		MASSIMA_ATTESA = 9000 trame (cio 3.6 secondi)
		LIMITE = 50000 trame (cio 20 secondi)
	 */       
		   
   	   
/*-------------------------------------------------------------------------------------------*/
                   			  

										 /* INCLUDE */
		
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include "nr.h"


/*-------------------------------------------------------------------------------------------*/


									   /* NUOVE DEFINE */


#define MINIMO 3                    /* numero minimo di sottoportanti che in ciascuna BS deve
									   essere libero per poter assegnare una sottoportante ad 
									   ad un utente che ha fatto richiesta ( il numero di
									   sottoportanti riservate per utenti in HO) */

#define MASSIMA_ATTESA 9000         /* numero massimo di trame che un utente pu attendere
									   prima che gli venga assegnata una sottoportante. Se si
									   oltrepassa tale numero, l'utente richiedente ed il suo 
									   compagno vengono posti nuovamente nel gruppo di coloro
									   che possono effettuare una richiesta (equivale a 3.6 
									   secondi) */

#define NON_ATTIVO	10              /* valore assunto dal campo "utente_attivo" */
#define ATTIVO	20                  /* valore assunto dal campo "utente_attivo" */

#define NON_ATTIVATA 30             /* valore assunto dal campo "Comunicazione" */
#define ATTIVATA 40                 /* valore assunto dal campo "Comunicazione" */
#define DISATTIVATA 50              /* valore assunto dal campo "Comunicazione" */

#define CARRIER_SLOT  29            /* Slot per assegnazione sottoportante (la BS invia una
                                       BroadcastCell indicante, per ciascun utente richiedente,
                                       il numero di sottoportante da acquisire a partire dalla
                                       successiva trama) */

#define ACCESS_SLOT 33              /* Slot durante il quale ciascun utente non avente una
									   sottoportante e che vuole iniziare una comunicazione,
									   invia la propria richiesta alla BS (essendo un canale
									   condiviso ci saranno delle collisioni) */

#define LIMITE 50000                /* serve per sapere se ad un utente attivo si pu togliere
									   la sottoportante (cio dopo 20 secondi di comunicazione,
									   un utente pu randomicamente decidere di concludere la
                                       sua comunicazione. In tal caso va liberata la sua 
                                       sottoportante e quella del suo "compagno"). E' un numero
									   di trame e deve essere pari a 50000 (pari a 20 sec) */

#define ASSENTI 0                   /* serve per sapere se un certo tipo di utente  assente */
#define PRESENTI 1                  /* serve per sapere se un certo tipo di utente 
                                       presente */

#define NO_VALIDO  -1               /* valore assunto dalle componenti del vettore
									   "Mini_Slot[NMAX]" */

#define NO         -1               /* valore assunto dalle componenti del vettore
									   "Richiesta_Sottoportante[NMAX]" */

#define SI			1               /* valore assunto dalle componenti del vettore
									   "Richiesta_Sottoportante[NMAX]" */

#define PRIMO		1               /* valore assunto dal campo "abilitati_al_passo" */
#define SECONDO		2               /* valore assunto dal campo "abilitati_al_passo" */
#define TERZO		3               /* valore assunto dal campo "abilitati_al_passo" */
#define QUARTO		4               /* valore assunto dal campo "abilitati_al_passo" */
#define ULTIMO      5               /* valore assunto dal campo "abilitati_al_passo" */
#define NESSUNO		-2              /* valore assunto dal campo "abilitati_al_passo"
                                       e dal campo "HO_STEP" */

// #define DEBUG                  /* se  "commentata" non vengono eseguite alcune "printf" */

           

/*-------------------------------------------------------------------------------------------*/


                                          /* DEFINE */


#define NCARRIER 13			 /* numero totale di sottoportanti di segnalazione disponibili in
                                ciascuna Base Station */

#define NMAX 250	         /* numero di utenti abbonati al sistema */

#define CLUSTER  2			 /* numero di Base Station (celle) presenti nel sistema */

#define NUMFRAME 450000    	 /* numero di trame che voglio simulare (ad esempio 600000 che
                                equivalgono a 4 minuti di simulazione reale) */
				 
#define DIMFRAME 64			 /* numero di time slot contenuti in una trama */

#define DOWNLINK 32          /* numero di time slot assegnati al downlink */
#define BROADSLOT 1   		 /* Broadcast Slot (slot numero 31) */
#define UP_RESERV 1      	 /*  lo slot di segnalazione */
#define BROADxPORTANTI 30	 /* slot usato per trasmettere la BCGS */

#define DOWN 1000            /* indica lo slot che la BS usa per trasmettere la segnalazione
								agli utenti da essa serviti */

#define SIGN 1000            /* indica lo slot che gli utenti usano per trasmettere la
								segnalazione alla loro BS servente */

#define SUBC 2000			 /* indica lo slot che la BS usa per trasmettere la BCGS (BroadCast
								Cell per la gestione delle sottoportanti) agli utenti da essa
								serviti */							    

#define PACK_SIZE 384            /* Payload of one ATM cell (bit costituenti l'informazione 
                                    pagante) */

#define FRAMEDURATION 400.0e-6   /* durata di una singola trama (in secondi) */
#define slot_duration 6.25e-6    /* durata di un singolo time slot (in secondi) */

#define FREE 1
#define NOT_FREE 0

#define NO_USE 500
#define NO_USER 425
#define NO_KIND 0
#define NO_NEW_DESTINATION_BS 5000

#define DIMISTOGRAMMA 32	/* numero di intervalli usati per l'istogramma dei ritardi subti
                               dai pacchetti per ogni MS (serve per la scrittura dei risultati
                               finali) */	
	
#define MIN_SHO 15			/* minimo numero di trame con doppio collegamento */

#define NO_LINK -1			/* usato per inizializzare la qualit relativa ad un collegamento
                               non esistente */

#define DIMMULTIFRAME 10	/* numero di trame costituenti una multitrama */

#define WINFRAMES 75		/* numero di trame della finestra temporale usata per analizzare 
                               il legame tra pacchetti persi ed utenti presenti nella cella
							   (75 trame equivalgono a 30 ms, cio al massimo ritardo) */

#define MAX_MS_ONE_LINK 20	/* numero di utenti con 1 collegamento che possono essere gestite
							   al massimo da una cella */
 						
#define MAX_MS_TOT 20

/*-------------------------------------------------------------------------------------------*/

                                /* PARAMETRI RELATIVI A UTENTI VOCE  */

#define VOICE 1                     
#define MAX_DEL_VOICE 30.0e-3
#define s0_on_mean 1.0
#define s0_off_mean 1.35
#define s0_on_rate 22.8e+3
#define TALK 1
#define SILENT 0

/*-------------------------------------------------------------------------------------------*/

                    /* PARAMETRI RELATIVI A UTENTI VIDEO H.263 4CIF Foot 3MBPS */

#define VIDEO1MBPS 2                
#define MAX_DEL_VIDEO1MBPS 30e-3
#define PICTURE_FRAME_TIME 0.0333333
#define DIVIDER 5000
#define RATEVIDEO1MBPS 3.0e+6
#define QUANTINT 20
#define CYCLE_VIDEO 2333
#define OSCFACT 2.1431
#define STEPS_PER_TRAN_FRAME 28    
 
/*-------------------------------------------------------------------------------------------*/

                       /* DATA A 64 KBPS PARAMETERS CONSTANT BIT RATE (CBR) */

#define DATA64KBPS 3                
#define MAX_DEL_DATA64KBPS 1.00
#define RATE64KBPS 76.8e+3

/*-------------------------------------------------------------------------------------------*/

                      /* DATA A 2048 KBPS PARAMETERS CONSTANT BIT RATE (CBR) */

#define DATA512KBPS 4               
#define MAX_DEL_DATA512KBPS 1.00
#define RATE512KBPS 2.048e+6

/*-------------------------------------------------------------------------------------------*/


                                    /* VARIABILI GLOBALI */

int frame;
int slot;
int vbs[NMAX];                            /* numero della BS servente iniziale */
int Numero_totale_di_richieste_di_HO = 0;
int HomeLocReg[NMAX];
int contapacklostup[CLUSTER], contapacklostupMSinSHO;

/* variabili che servono per i risultati finali */

int assigned_random_up[CLUSTER], assigned_random_down[CLUSTER];
int appoggioslot;

int maxRealLenght[NCARRIER];
int conta_tot_del_req[CLUSTER];	/* numero di slot richiesti da utenti video e voce */

/* la seguente variabile serve per calcolare, per ogni finestra, il rapporto tra slot assegnati
   ad utenti video e slot assegnati in modo random */

int conta_del_req_slot_ass[CLUSTER], conta_random_slot_ass[CLUSTER]; 

long int assigned[CLUSTER] = {0}, used[CLUSTER] = {0}, non_used[CLUSTER] = {0};   
long int assigned_down[CLUSTER], used_down[CLUSTER], non_used_down[CLUSTER]; 

float matrix[QUANTINT][QUANTINT];    		/* per utenti video H.263 */
float bitrate_vect[QUANTINT];  				/* per utenti video H.263 */

double idum = -1, idum1 = 5;

long double factorial_vect[997];

char c[NMAX+1];  
char NomeFileUscita[60] = "RisultatiSimulazioneConUtenti";     

const char *TIPO[6] = {"NO_TYPE","VOICE","VIDEO","DATA64KBPS","DATA2048KBPS","VARIO"};              
const char Extention[5] = ".txt"; 
                                                                
/*-------------------------------------------------------------------------------------------*/


                                 /* NUOVE VARIABILI GLOBALI */ 
 

int utenti_video_collegati, utenti_voce_collegati;  /* usate in "Notizie_Utenti_New" */
int numero_di_utenti_collegati_inizialmente;        /* serve per i risultati finali */

int Nuova_Sottoportante[NMAX];    /* usata in HO_STEP_2 */
int HO_Fallito[NMAX];             /* usata in HO_STEP_2 */
int Vecchia_Sottoportante[NMAX];  /* usata in HO_STEP_5 */
int Vecchia_BS[NMAX];             /* usata in HO_STEP_5 */

char ScenarioUtenti[60];          /* usata in "Notizie_utenti_new" */

int Utente_soddisfatto[NMAX];     /* usata in "Gestisci_Richieste" */

int Pacchetti_in_BS_vecchia[NMAX];                          /* serve per i risultati finali */
int totHOriusciti=0,totHOfalliti=0;                         /* serve per i risultati finali */

int Numero_totale_di_pacchetti_persi = 0;                   /* serve per i risultati finali */
int Numero_totale_di_richieste = 0;                         /* serve per i risultati finali */
int Numero_di_richieste_subito_accolte = 0;                 /* serve per i risultati finali */

int Numero_totale_di_richieste_fallite_x_eccessiva_attesa = 0;   /* per i risultati finali */
int Pacchetti_persi_x_eccessiva_attesa_nei_BufRic = 0;           /* per i risultati finali */
int Pacchetti_persi_x_eccessiva_attesa_nel_buffer_di_utente = 0; /* per i risultati finali */

int contapacklostdown[CLUSTER], contapacklostdownMSinSHO;        /* per i risultati finali */

int Errore_verificato = NO;                                 /* serve per i risultati finali */

long int tot_pack_sent[NMAX];                               /* serve per i risultati finali */                      
                                                                                                            

/*-------------------------------------------------------------------------------------------*/



							 /* DEFINIZIONE DELLE NUOVE STRUCT */


struct UtentiPresenti    
{
	int Video;
	int Voce;
	int Dati64KBPS;
	int Dati2048KBPS;  
};                   

/*-------------------------------------------------------------------------------------------*/

/* Struttura usata solamente per memorizzare i risultati da scrivere al termine della 
   simulazione */

struct Risultati_utente
{
	int Comunicazione_iniziata;
	int Trama_di_inizio_comunicazione;
	int Trame_di_attesa_per_ottenere_sottoportante;  /* se a fine simulazione rimane pari a
													    NO_VALIDO vuol dire che l'utente  tra
														quelli collegati all'inizio */

	int durata_comunicazione;                        /* se a fine simulazione rimane pari a
													    NO_VALIDO vuol dire che l'utente non 
														ha mai comunicato */
	int HO_effettuati;
	int Comunicazione_terminata_spontaneamente;
	int Comunicazione_terminata_x_HO_fallito;
	int Comunicazione_terminata_x_HO_fallito_dal_compagno;
	int Comunicazione_terminata;
	int Passo_di_HO_in_cui_ha_terminato_la_comunicazione;

	int Attivo_da_subito;
	int Utente_richiedente_con_successo;
	int Richiesta_fallita_x_eccessiva_attesa;
	int Numero_richieste_fallite_x_eccessiva_attesa;

	int Pacchetti_generati;
	int Pacchetti_ricevuti;
	int Pacchetti_generati_ma_persi_x_eccessiva_attesa_nel_suo_buffer;  
	int Pacchetti_generati_ed_inviati_ad_una_BS;
	int Pacchetti_ad_esso_diretti_ma_persi_x_eccessiva_attesa_nel_buffer_di_ricez;
    int Pacchetti_ad_esso_diretti_ma_persi_x_HO;

	int Pacchetti_generati_ma_rimasti_nel_suo_buffer;  /* a fine comunicazione o simulazione */
	int Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez;
	
	int Numero_di_slots_di_uplink_assegnati_in_totale;
	int Numero_di_slots_di_uplink_assegnati_ed_usati;
	int Numero_di_slots_di_uplink_assegnati_ma_non_usati;
	int Numero_di_slots_di_uplink_assegnati_in_modo_random;

	int Numero_di_slots_di_downlink_assegnati_in_totale;
	int Numero_di_slots_di_downlink_assegnati_ed_usati;
	int Numero_di_slots_di_downlink_assegnati_ma_non_usati;
	int Numero_di_slots_di_downlink_assegnati_in_modo_random;

} Risultati[NMAX];  /* vettore contenente i risultati di ciascun utente */


/*-------------------------------------------------------------------------------------------*/

/* Struttura usata solamente per memorizzare i risultati da scrivere al termine della 
   simulazione */

struct Causa_della_terminazione
{
	int in_totale;
	int spontaneamente;
	int x_HO_fallito;

} collegamenti_terminati;    /* serve per i risultati finali */

/*-------------------------------------------------------------------------------------------*/

/* Tale struttura serve per l'assegnazione del canale di downlink ad utenti in Soft HO */

struct In_Soft_HO
{
	int stato;    /* pu valere "SI" o "NO" */
	int utente;
	int altra_portante;
	int altra_BS;
};

/*-------------------------------------------------------------------------------------------*/


                                /* DEFINIZIONE DELLE STRUCT */

struct el_buff
{
	int quality[CLUSTER]; /* indica il livello di qualit del pacchetto */
	int info;
	int num;
	int from;
	int dest;
	int clock;
	int BSclock;
	struct el_buff *next;

}   *punt_buffer[NMAX];	  /* insieme dei buffer di utente */

/*-------------------------------------------------------------------------------------------*/

struct tipoBufInRicez
{
	struct el_buff *buf;
	int lenght;
};

/*-------------------------------------------------------------------------------------------*/

struct state_ps
{
	long int UpDelIst[DIMISTOGRAMMA], TotDelIst[DIMISTOGRAMMA]; /* istogrammi del ritardo di
			                                                       uplink e totale */

	long int pack_arrived; /* numero di pacchetti arrivati alla MS di destinazione (usato per 
			                  la scrittura dei risultati finali) */

	int lastHOreq;	       /* numero di trame trascorse dall'ultima richiesta di HO */

	int ContTwoLinks;      /* numero di trame trascorse dall'inizio del doppio collegamento 
			                  (usato per imporre una limitazione al passaggio da qualit 2 a 
							  qualit 3) */
			                     

	int SoftHOFrames;      /* numero di trame complessivo in cui la MS ha 2 collegamenti */

	int quality_state[CLUSTER];  /* stato di qualit in cui si trova il collegamento tra la MS
			                        e le BS */

	int NumOfLinks;  /* numero di collegamenti che ha l'utente */
			
	int last_pack_number;
	long double maximum_del;
	int max_clock;
	long double mean_delay, whole_mean_delay;
	int max_lenght;
	long pack_gen;
	int pack_lost;
	int kind_of_service;

	int state; 			/* for voice and video H.263 */
	int cycle_state; 	/* for video H.263 */

	float bit_rest;
	int buffer_leng_succ_i,buffer_leng_i,buffer_leng_prec_i,buffer_leng_prec2_i;
	long int pack_sent[CLUSTER];
	short int last_req;
	short int asse;
		
	int slots_to_ask;       /* for all video and voice services */
	int MyOldBS, MyServBS;	/* BS da cui si esce e BS servente */

	int mySubcarrier[CLUSTER], MySubcarrierUse, MySubcUse[NCARRIER]; /* riguardano le
																	    sottoportanti con cui  
																		si inviano le
																		segnalazioni */
	int myNextSubcarrier[CLUSTER];	
	int destinazione;	              /* identificativo  dell'utente di destinazione */
	short int HO_REQ;                 /* richiede l'HO */

	int in_HO;                        /* aggiunto */
	int HO_STEP;                      /* aggiunto */
	int Conta_trame_di_attivita;      /* aggiunto */
	int Comunicazione;                /* aggiunto */
	int Conta_trame_di_attesa;        /* aggiunto */
	int abilitato_al_passo;           /* aggiunto */
	int trama_di_abilitazione;        /* aggiunto */	
	
	int PossibleHOR, HO_Falliti;      /* PossibleHOR  modificato da last */
	int NumOfHO;
	int NewBS;                        /* BS di destinazione per HO */
	int utente_attivo;                /* campo indicante se l'utente  o no in comunicazione */
     		
}  status[NMAX];

/*-------------------------------------------------------------------------------------------*/

struct operation
{
	int reserved;
	int assigned;
};

/*-------------------------------------------------------------------------------------------*/

struct inf
{
	int ps;
	int info;
};

/*-------------------------------------------------------------------------------------------*/

struct from
{
	int sign_vett_prec_x_HO_entrante[NCARRIER];
	int sign_vett_x_HO_entrante[NCARRIER];
	int sign_vett_succ_x_HO_entrante[NCARRIER];
};

/*-------------------------------------------------------------------------------------------*/

struct tab_bs
{
	int assigned;
	int inf;
	int sign;
	int activity;
	int new_entry;
	int sent;
	int pack_lost;
	int pack_lost_x_HO; /* numero di pacchetti persi sul downlink perch viene rilasciato il 
			               collegamento e non  stato svuotato completamente il buffer di 
			               ricezione */
	int kind;
	int SubCarrierOf;
	int HO_REQ;

	int stop_trasm;  /* vale 1 se devo bloccare la trasmissione dei pacchetti sul downlink
					    verso l'utente considerato (ci accade dopo HO, cio quando il 
						collegamento con la vecchia BS  stato rilasciato dall'utente oppure 
						dopo che il suo buffer di ricezione contenuto nella vecchia BS si 
	                    svuotato), vale 0 altrimenti */
};

/*-------------------------------------------------------------------------------------------*/

struct tab_bs_numberMS  /* tabella contenente il numero di MS non in Soft HO, in Soft HO nuove
						   e vecchie */ 
{
	int one_link;
	int two_links_New;
	int two_links_Old;
};

/*-------------------------------------------------------------------------------------------*/

struct FixedStation     /* rappresenta la singola Base Station */
{
	struct tab_bs_numberMS tableMS;	

	int bc_prec_x_Portanti[NCARRIER];	/* Broadcast Cell per la gestone delle sottoportanti */ 
												   
	int bc_x_Portanti[NCARRIER];
	int	bc_succ_x_Portanti[NCARRIER];
	int trasmetti_bc;

	int ciclo_random,ciclo_video,ciclo_data;  /* vanno azzerati all'inizio */

	int bc_prec_i[DIMFRAME];
	int bc_i[DIMFRAME];
	int bc_succ_i[DIMFRAME];

	struct tab_bs table[NCARRIER];

	int bc_succ_i_long;  /* campo usato in calc_broad_succ_i_x_uplink (cosa rappresenta ??) */
			
	int firstdatanoserved;
	int firstvideovocenoserved; /* modificato (prima era firstvideonoserved) */ 
	int videonoserved;
				
	int sign_vett_prec_i[NCARRIER];
	int sign_vett_i[NCARRIER];
	int sign_vett_succ_i[NCARRIER];

	struct from dallaBS[CLUSTER];	/* dalla BS cluster ho ricevuto una richiesta di HO */
											   
	int ChiStaUscendo[NCARRIER];
	int profile_req[CLUSTER];
	int succ_profile_req[CLUSTER];	
	int vettsubcfree[NCARRIER];
	int conta_time_not_free[NCARRIER], Use_of_subc_gross[NCARRIER];
	int newsubcfree, HO_non_realizzati;	

	struct tipoBufInRicez BufRic[NCARRIER];

	struct operation oper_time_succ2_i[DIMFRAME], oper_time_succ_i[DIMFRAME],
		   oper_time_i[DIMFRAME];

	struct inf infopack_prec_i[DIMFRAME],infopack_i[DIMFRAME];

	int Sottoportante_abilitata[NCARRIER];   /* aggiunto (pu valere SI o NO) */	
	
	struct In_Soft_HO Portante_in_SHO[NCARRIER];      /* aggiunto */

} BaseStation[CLUSTER];

/*-------------------------------------------------------------------------------------------*/


					  /* STRUCT UTILI PER SCRIVERE I RISULTATI FINALI */


struct record_tabpacklost	/* singolo campo delle matrici usate per l'output dei pacchetti 
                               persi in uplink in funzione del numero di utenti presenti */
{
	float packet_lost;
	float time;
	float req_assigned;	    /* numero di slot assegnati ad utenti video o voce non in modo
	                           random */

	float random_assigned;	/* numero di slot assegnati in modo random */
};

/*-------------------------------------------------------------------------------------------*/

struct informazioni_sul_downlink	   /* singolo campo delle matrici usate per l'output dei 
									      pacchetti persi in downlink in funzione del numero 
										  di utenti presenti */
{
	float pacchetti_persi;
	float tempo;	
}; 

/*-------------------------------------------------------------------------------------------*/

struct tabpacklost
{
	struct record_tabpacklost single_tabpacklost[NCARRIER+1][NCARRIER+1];

} table_packlost[CLUSTER], global_table_packlost;  /* matrice "(NMAX+1)*(NMAX+1)" usata per
												      scrivere i risultati relativi ad entrambe
													  le BS (cio globali) */ 

/*-------------------------------------------------------------------------------------------*/

struct perdite_di_downlink  /* Nuova */
{
	struct informazioni_sul_downlink tabella[NCARRIER+1][NCARRIER+1];

} Pacchetti_persi_in_downlink[CLUSTER];


/*-------------------------------------------------------------------------------------------*/


							 /* DICHIARAZIONE DELLE NUOVE FUNZIONI */


int Controlla_quanti_utenti_sono_attivi (int num_di_trama, int tutti_non_attivi, int* tot)
{
	int i, contatore = 0;
	int numero = 0;

	for (i=0; i<NMAX; i++)
	{
		if (status[i].utente_attivo == NON_ATTIVO)
			contatore ++;

		if (status[i].utente_attivo == ATTIVO)
			numero ++;
	}

	if (contatore == NMAX)
	{
		tutti_non_attivi = SI;
		num_di_trama = frame;
	}

	*tot += numero;

	return (numero);
}

/*-------------------------------------------------------------------------------------------*/

void Stampa_riga_di_separazione (FILE *pfile)
{
	int i;

	fprintf (pfile, "\n\n");

	for (i=0; i<95; i++)
		fprintf (pfile, "*");
}


/*-------------------------------------------------------------------------------------------*/

void Stampa_informazioni_su_utenti_attivi (FILE *pfile, int num_di_trama, int tutti_non_attivi)
{
	if (tutti_non_attivi == SI)
	{
		fprintf (pfile, "\n\nNELLA TRAMA %d TUTTI GLI UTENTI ERANO NON ATTIVI", num_di_trama);
		Stampa_riga_di_separazione (pfile);
	}
}


/*-------------------------------------------------------------------------------------------*/

void Stampa_risultati_di_uplink_in_funzione_delle_MS (FILE *pfile, int finestre, int *pac_persi_in_up)
{
	int clust;
	int ll, j;
	long double appoggiofloat;
	float appfloat;
	float appfloat4;
	float MSpacklostup;
	float MStime;
	
	fprintf(pfile,"\n\n\n\n\t\t\tLEGAME TRA NUMERO DI MS PRESENTI NELLA CELLA E PACCHETTI PERSI IN UPLINK:\n");

    fprintf(pfile,"\n\nper ogni valore di MS presenti nella cella (totali ed in SHO):"); 
    fprintf(pfile,"\n\nla prima riga indica la percentuale di pacchetti persi in uplink,");
    fprintf(pfile,"\n\nla seconda riga indica il numero di pacchetti persi in uplink,");
    fprintf(pfile,"\n\nla terza riga indica la percentuale di tempo per cui c' stato quel "); 
    fprintf(pfile,"valore di MS nella cella.");
 // fprintf(pfile,"\n\nla quarta riga indica la percentuale di slot di uplink assegnati in modo non random");
 // fprintf(pfile,"\n(dovrebbe aumentare con l'aumentare delle MS totali e diminuire ");   
 // fprintf(pfile,"all'aumentare delle MS in SHO).");

    for (clust=0; clust<CLUSTER; clust++)
	{
		appoggiofloat = 0;
	    appfloat = 0;
	    appfloat4 = 0;

		if (clust == 1)
		{
			Stampa_riga_di_separazione (pfile);
			fprintf(pfile, "\n");
		}

	    fprintf(pfile, "\n\n\nBS %d: \n\nMS attive\t\t\tMS in Soft HO tra quelle attive\n\n\t", 
		        clust);

	    /* nel seguente ciclo for prima c'era NMAX */

	    for (j=0; j<=NCARRIER; j++)
		    fprintf(pfile, "\t%4d", j);

	    fprintf(pfile, "\t TOT\n");

	    /* nel seguente ciclo for prima c'era NMAX */

	    for (ll=0; ll<=NCARRIER; ll++)
		{
			MSpacklostup = 0;
		    MStime = 0;

		    fprintf(pfile, "\n%d\t", ll);

		    for (j=0; j<=ll; j++)

			{	/* prima riga: percentuale di pacchetti persi in uplink */
				
				if ((pac_persi_in_up[clust] != 0) && 
					(table_packlost[clust].single_tabpacklost[ll][j].packet_lost != 0))
					
					fprintf(pfile, "\t%4.1f", 
				            table_packlost[clust].single_tabpacklost[ll][j].packet_lost /
						    (float)pac_persi_in_up[clust]*100.0); 

			    else
					fprintf(pfile, "\t%4.1f", 0.0);

			    if (pac_persi_in_up[clust] != 0)
					
					MSpacklostup += (float)(table_packlost[clust].single_tabpacklost[ll][j].
				                    packet_lost / (float)pac_persi_in_up[clust]*100.0);
			}

		    /* nel seguente ciclo for prima c'era NMAX */

		    for (j=ll+1; j<=NCARRIER; j++)
				fprintf(pfile, "\t\t");

		    fprintf(pfile, "\t%4.1f\n\t", MSpacklostup);

		    for (j=0; j<=ll; j++)

			{	/* seconda riga: numero di pacchetti persi in uplink */
				
				if (table_packlost[clust].single_tabpacklost[ll][j].packet_lost != 0)
					
					fprintf(pfile, "\t%4d", 
				            (int)table_packlost[clust].single_tabpacklost[ll][j].packet_lost);

			    else
					fprintf(pfile, "\t\t");
			}

		    fprintf(pfile, "\n\t");

		    for (j=0; j<=ll; j++)

			{	/* terza riga: percentuale di tempo per cui si ha quel numero di MS presenti */
				
				if (table_packlost[clust].single_tabpacklost[ll][j].time != 0)
					
					fprintf(pfile, "\t%4.1f", table_packlost[clust].single_tabpacklost[ll][j].time/
				            (float)finestre*100.0);   
			    else
					fprintf(pfile, "\t\t");

			    MStime += (float)(table_packlost[clust].single_tabpacklost[ll][j].time
				          /(float)finestre*100.0);
			}

		    /* nel seguente ciclo for prima c'era NMAX */

		    for (j=ll+1; j<=NCARRIER; j++)
				fprintf(pfile, "\t\t");

		    if (MStime != 0)

				fprintf(pfile, "\t%4.1f", MStime);

		    appoggiofloat += MSpacklostup;
		    appfloat += MStime;

		    fprintf(pfile, "\n\t");

		//  for (j=0; j<=ll; j++)

            /* quarta riga: percentuale di slot di uplink assegnati non in modo random rispetto
			   al numero totale di slot assegnati (somma degli slot assegnati in modo random e
			   degli slot assegnati in modo non random) */
		//	{ 
		//		appfloat4 += table_packlost[clust].single_tabpacklost[ll][j].random_assigned;

		//	    if (table_packlost[clust].single_tabpacklost[ll][j].random_assigned != 0)
					
		//			fprintf(pfile, "\t%4.1f", 
		//		            table_packlost[clust].single_tabpacklost[ll][j].req_assigned /
		//				     (table_packlost[clust].single_tabpacklost[ll][j].random_assigned +
		//				      table_packlost[clust].single_tabpacklost[ll][j].req_assigned)*100.0);   
		//	    else
		//			fprintf(pfile, "\t\t");
		//	}
		}      /* fine ciclo for su "ll" */	  
	 

	    fprintf(pfile, "\n\nSOMMA DELLE PERCENTUALI DEI PACCHETTI DI UPLINK PERSI NELLA BS NUMERO %d", clust); 
	    fprintf(pfile, "\n(al variare del numero totale di utenti presenti in una cella e del numero di utenti in\n Soft HO): %5.2f",appoggiofloat);

	    fprintf(pfile, "\n\nSOMMA DELLE PERCENTUALI DI TEMPO NELLA BS NUMERO %d", clust); 
	    fprintf(pfile, "\n(al variare del numero totale di utenti presenti in una cella e del numero di utenti in\n Soft HO): %5.2f",appfloat);
	
	 // fprintf(pfile, "\n\nNUMERO TOTALE DI SLOT DI UPLINK ASSEGNATI IN MODO RANDOM DALLA BS NUMERO %d: %d",
	 //	        clust, (int)appfloat4);

    }   /* fine ciclo for su "clust" */
}

/*-------------------------------------------------------------------------------------------*/

void Stampa_risultati_di_downlink_in_funzione_delle_MS (FILE *pfile, int finestre, int *pac_persi_in_down)
{
	int clust;
	int ll, j;
	long double appoggiofloat;
	float appfloat;	
	float MSpacklostdown;
	float MStime;
	
	fprintf(pfile,"\n\n\n\n\t\t\tLEGAME TRA NUMERO DI MS PRESENTI NELLA CELLA E PACCHETTI PERSI IN DOWNLINK:\n");

    fprintf(pfile,"\n\nper ogni valore di MS presenti nella cella (totali ed in SHO):"); 
    fprintf(pfile,"\n\nla prima riga indica la percentuale di pacchetti persi in downlink,");
    fprintf(pfile,"\n\nla seconda riga indica il numero di pacchetti persi in downlink,");
    fprintf(pfile,"\n\nla terza riga indica la percentuale di tempo per cui c' stato quel "); 
    fprintf(pfile,"valore di MS nella cella.");    

    for (clust=0; clust<CLUSTER; clust++)
	{
		appoggiofloat = 0;
	    appfloat = 0;
		
		if (clust == 1)
		{
			Stampa_riga_di_separazione (pfile);
			fprintf(pfile, "\n");
		}

	    fprintf(pfile, "\n\n\nBS %d: \n\nMS attive\t\t\tMS in Soft HO tra quelle attive\n\n\t", 
		        clust);

	    /* nel seguente ciclo for prima c'era NMAX */

	    for (j=0; j<=NCARRIER; j++)
		    fprintf (pfile, "\t%4d", j);

	    fprintf (pfile, "\t TOT\n");

	    /* nel seguente ciclo for prima c'era NMAX */

	    for (ll=0; ll<=NCARRIER; ll++)
		{
			MSpacklostdown = 0;
		    MStime = 0;

		    fprintf(pfile, "\n%d\t", ll);

		    for (j=0; j<=ll; j++)

			{	/* prima riga: percentuale di pacchetti persi in uplink */
				
				if ((pac_persi_in_down[clust] != 0) && 
					(Pacchetti_persi_in_downlink[clust].tabella[ll][j].pacchetti_persi != 0))
					
					fprintf(pfile, "\t%4.1f", 
				            Pacchetti_persi_in_downlink[clust].tabella[ll][j].pacchetti_persi /
						    (float)pac_persi_in_down[clust]*100.0); 

			    else
					fprintf(pfile, "\t%4.1f", 0.0);

			    if (pac_persi_in_down[clust] != 0)
					
					MSpacklostdown += (float)(Pacchetti_persi_in_downlink[clust].tabella[ll][j].pacchetti_persi
				                              / (float)pac_persi_in_down[clust]*100.0);
			}

		    /* nel seguente ciclo for prima c'era NMAX */

		    for (j=ll+1; j<=NCARRIER; j++)
				fprintf(pfile, "\t\t");

		    fprintf(pfile, "\t%4.1f\n\t", MSpacklostdown);

		    for (j=0; j<=ll; j++)

			{	/* seconda riga: numero di pacchetti persi in uplink */
				
				if (Pacchetti_persi_in_downlink[clust].tabella[ll][j].pacchetti_persi != 0)
					
					fprintf(pfile, "\t%4d", 
				            (int)Pacchetti_persi_in_downlink[clust].tabella[ll][j].pacchetti_persi);

			    else
					fprintf(pfile, "\t\t");
			}

		    fprintf(pfile, "\n\t");

		    for (j=0; j<=ll; j++)

			{	/* terza riga: percentuale di tempo per cui si ha quel numero di MS presenti */
				
				if (Pacchetti_persi_in_downlink[clust].tabella[ll][j].tempo != 0)
					
					fprintf(pfile, "\t%4.1f", Pacchetti_persi_in_downlink[clust].tabella[ll][j].tempo/
				            (float)finestre*100.0);   
			    else
					fprintf(pfile, "\t\t");

			    MStime += (float)(Pacchetti_persi_in_downlink[clust].tabella[ll][j].tempo
				          /(float)finestre*100.0);
			}

		    /* nel seguente ciclo for prima c'era NMAX */

		    for (j=ll+1; j<=NCARRIER; j++)
				fprintf(pfile, "\t\t");

		    if (MStime != 0)

				fprintf(pfile, "\t%4.1f", MStime);

		    appoggiofloat += MSpacklostdown;
		    appfloat += MStime;

		    fprintf(pfile, "\n\t");
		    
		}      /* fine ciclo for su "ll" */	  
	 

	    fprintf(pfile, "\n\nSOMMA DELLE PERCENTUALI DEI PACCHETTI DI DOWNLINK PERSI NELLA BS NUMERO %d", clust); 
	    fprintf(pfile, "\n(al variare del numero totale di utenti presenti in una cella e del numero di utenti in\n Soft HO): %5.2f",appoggiofloat);

	    fprintf(pfile, "\n\nSOMMA DELLE PERCENTUALI DI TEMPO NELLA BS NUMERO %d", clust); 
	    fprintf(pfile, "\n(al variare del numero totale di utenti presenti in una cella e del numero di utenti in\n Soft HO): %5.2f",appfloat);
	    
    }   /* fine ciclo for su "clust" */
}

/*-------------------------------------------------------------------------------------------*/

/* Tale funzione stampa il vettore contenente i risultati finali in funzione del numero medio
   di utenti per cella (un utente in Soft HO  considerato pari a met utente) */

void Stampa_vettore_globale (FILE *pfile, struct record_tabpacklost *vettore, 
							 int pacchetti_persi, int trame)
{
	int ll;
	long double appoggio;

	fprintf(pfile, "\n\n\n\t\tRISULTATI DI UPLINK IN FUNZIONE DEL NUMERO MEDIO DI MS PRESENTI IN UNA CELLA:"); 

	fprintf(pfile, "\n\nper ogni valore di MS presenti  indicata la percentuale del ");  
	fprintf(pfile, "numero di pacchetti di uplink ");
    fprintf(pfile, "\npersi (se  > 0), la percentuale di tempo per cui si ha tale numero di MS e "); 
    fprintf(pfile, "la velocit di\nperdita dei pacchetti di uplink");

	fprintf(pfile, "\n\nMS TOT\t\tPERSI\t\tTEMPO\t\t  PERSI/SEC");

	appoggio = 0.0;

	/* nel seguente ciclo prima c'era NMAX */

	for (ll=0; ll<(2*NCARRIER+1); ll++)  

		if (vettore[ll].time > 0)
		{
			/* a fine ciclo in "appoggio" dovrebbe essere presente il numero totale di 
			   pacchetti persi in uplink */

			appoggio += vettore[ll].packet_lost;  

			fprintf(pfile, "\n%4.1f\t\t%4.1f \t\t%5.2f\t\t\t%4.1f", (float)ll/2.0,
				    vettore[ll].packet_lost / (float)pacchetti_persi * 100.0, 
					vettore[ll].time / 2 / (float)trame * 100.0,
					vettore[ll].packet_lost / (vettore[ll].time * WINFRAMES * FRAMEDURATION)); 
		}

	fprintf(pfile, "\n\nSOMMA DELLE PERCENTUALI: %4.1f", appoggio/(float)pacchetti_persi*100.0);
    fprintf(pfile, "\n\nNUMERO TOTALE DI PACCHETTI PERSI IN UPLINK: %d", (int)appoggio);

	/* a volte il contenuto di "appoggio" non coincide con quello di "totpacklostup" */
	
}


/*-------------------------------------------------------------------------------------------*/

void Stampa_risultati_globali_di_uplink_in_funzione_delle_MS (FILE *pfile, int totpacklostup, int finestre, struct record_tabpacklost *vettore)
{
	int ll, j, clust;
	float MSpacklostup;
	float MStime;
				   

if (totpacklostup != 0)   /*  stato perso sull'uplink almeno un pacchetto */
{
	fprintf(pfile, "\n\n\n\n\t\t\t\tMATRICE RIASSUNTIVA DEI RISULTATI MEDI PER CELLA RELATIVI ALL'UPLINK:");

    fprintf(pfile, "\n\n\nper la MS i-esima");
    fprintf(pfile, "\n\nsulla prima riga c' la percentuale di pacchetti persi in uplink,");   
    fprintf(pfile, "\n\nsulla seconda riga c' la percentuale di tempo per cui si e' avuto quel numero di utenti,");
    fprintf(pfile, "\n\nsulla terza riga c' il numero medio di pacchetti persi al secondo in uplink "); 
    fprintf(pfile, "in quello stato,");
    fprintf(pfile, "\n\nsulla quarta riga c' il numero totale di pacchetti persi in uplink.");    

	fprintf(pfile, "\n\n\nMS attive\t\t\t\tMS in Soft HO tra quelle attive\n\n\t");

	for(j=0; j<=NCARRIER; j++)          /* modificato da NMAX */ 
		fprintf(pfile, "\t\t%4d", j);

	fprintf(pfile, "\t\t TOT\n");

	for (ll=0; ll<=NCARRIER; ll++)       /* modificato da NMAX */
	{
		/* prima riga: percentuale pacchetti persi */

		MSpacklostup = 0;
		MStime = 0;

		fprintf(pfile, "\n%d\t", ll);

		for(j=0; j<=ll; j++)
		{
			for (clust=0; clust < CLUSTER; clust++)

				global_table_packlost.single_tabpacklost[ll][j].packet_lost += 
				                  table_packlost[clust].single_tabpacklost[ll][j].packet_lost;
			
			MSpacklostup += 
				        (float)(global_table_packlost.single_tabpacklost[ll][j].packet_lost /
						       (float)totpacklostup * 100.0);
			
			fprintf(pfile, "\t\t%4.2f", 
				   (global_table_packlost.single_tabpacklost[ll][j].packet_lost /
				   (float)totpacklostup * 100.0)); 
		}

		for(j=ll+1; j<=NCARRIER; j++)             /* modificato da NMAX */
			fprintf(pfile, "\t\t\t");

		fprintf(pfile, "\t\t%4.2f\n\t", MSpacklostup);

		for(j=0; j<=ll; j++)
		{
			/* seconda riga: tempo */

			for (clust=0; clust < CLUSTER; clust++)
				 global_table_packlost.single_tabpacklost[ll][j].time +=
				                       table_packlost[clust].single_tabpacklost[ll][j].time;
			
			MStime += (float)(global_table_packlost.single_tabpacklost[ll][j].time / 
				      (float)finestre * 100.0 / 2.0);
			
			if (global_table_packlost.single_tabpacklost[ll][j].time != 0)

				fprintf(pfile, "\t\t%4.2f", 
				       (global_table_packlost.single_tabpacklost[ll][j].time / 
					   (float)finestre * 100.0 / 2.0));   
			else
				fprintf(pfile, "\t\t\t");
		}

		for(j=ll+1; j<=NCARRIER; j++)               /* modificato da NMAX */
			fprintf(pfile, "\t\t\t");

		if(MStime != 0)
			fprintf(pfile, "\t\t%4.1f\n\t", MStime);

		for(j=0; j<=ll; j++)
		{
			/* terza riga: numero medio di pacchetti persi al secondo */

			if ((global_table_packlost.single_tabpacklost[ll][j].packet_lost != 0) 
				&& (global_table_packlost.single_tabpacklost[ll][j].time>
				   (NUMFRAME/WINFRAMES*1.0e-3)))
				   
				/* almeno lo 0.1% del tempo */

				fprintf(pfile, "\t%5.1e", 
				       (global_table_packlost.single_tabpacklost[ll][j].packet_lost /
					   (global_table_packlost.single_tabpacklost[ll][j].time * WINFRAMES /
					    2.0 * FRAMEDURATION)));   
			else
				fprintf(pfile, "\t\t\t");
		}
		
		fprintf(pfile, "\n\t");

		for(j=0; j<=ll; j++)
		{
			/* quarta riga: numero di pacchetti persi */

			if (global_table_packlost.single_tabpacklost[ll][j].packet_lost != 0)
				fprintf(pfile, "\t\t%5d", 
				       (int)global_table_packlost.single_tabpacklost[ll][j].packet_lost);   
			else
				fprintf(pfile, "\t\t\t");
		}

		fprintf(pfile, "\n\t");
		
	}        /* fine ciclo for su "ll" */

	Stampa_riga_di_separazione (pfile);   

    Stampa_vettore_globale (pfile, vettore, totpacklostup, finestre);
	
}   /* fine if (totpacklostup != 0) */

else

    fprintf(pfile, "\n\nNESSUN PACCHETTO E' STATO PERSO SULL'UPLINK PER ECCESSIVA ATTESA");

}
/*-------------------------------------------------------------------------------------------*/

void Inizializza_alcune_variabili_del_main (int generati, int ricevuti, 
											unsigned long int BSclock,
											unsigned long int Somma_dei_pacchetti_in_attesa,
											unsigned long int Somma_delle_attese,
											unsigned long int pacchetti_non_persi_in_uplink,
											unsigned long int pacchetti_giunti_a_destinazione,
											unsigned long int Somma_dei_ritardi_totali,
											int num_trama, int tutti_non_attivi, int num, int som)
{
	generati = 0;
	ricevuti = 0;	
	BSclock = 0;
	Somma_dei_pacchetti_in_attesa = 0;
	Somma_delle_attese = 0;
	pacchetti_non_persi_in_uplink = 0;
	pacchetti_giunti_a_destinazione = 0;
	Somma_dei_ritardi_totali = 0;
	num_trama = -5;
	tutti_non_attivi = NO;
	num = 0;
	som = 0;
}
		

/*-------------------------------------------------------------------------------------------*/

void Inizializza_alcune_variabili_globali ()
{
	totHOriusciti = 0;                                           /* per i risultati finali */
	totHOfalliti = 0;                                            /* per i risultati finali */

    Numero_totale_di_pacchetti_persi = 0;                        /* per i risultati finali */
    Numero_totale_di_richieste = 0;                              /* per i risultati finali */
    Numero_di_richieste_subito_accolte = 0;                      /* per i risultati finali */

	Numero_totale_di_richieste_fallite_x_eccessiva_attesa = 0;   /* per i risultati finali */ 
    Pacchetti_persi_x_eccessiva_attesa_nei_BufRic = 0;           /* per i risultati finali */
    Pacchetti_persi_x_eccessiva_attesa_nel_buffer_di_utente = 0; /* per i risultati finali */

	Numero_totale_di_richieste_di_HO = 0;                        /* per i risultati finali */
}


/*-------------------------------------------------------------------------------------------*/


void Stampa_tempo_medio_di_attesa_totale (FILE *pfile, unsigned long int tempo, unsigned long int pac)
{
	double media;

	media = (double)(((double)tempo/(double)pac) * slot_duration * 1000);

	fprintf (pfile, "\n\nTEMPO MEDIO DI ATTESA DI UN PACCHETTO GENERATO PER GIUNGERE A DESTINAZIONE: %.3f ms", media);	
}
 
	 
/*-------------------------------------------------------------------------------------------*/

void Stampa_tempo_medio_di_attesa_nel_buffer_di_utente (FILE *pfile, unsigned long int tempo, unsigned long int pac)
{
	double media;

	media = (double)(((double)tempo/(double)pac) * slot_duration * 1000);

	fprintf (pfile, "\n\nTEMPO MEDIO DI ATTESA DI UN PACCHETTO NEL BUFFER DI UTENTE: %.3f ms", media);	
}


/*-------------------------------------------------------------------------------------------*/

void Stampa_tempo_medio_di_attesa_nel_BufRic (FILE *pfile, unsigned long int tempo, unsigned long int pac)
{
	double media;

	media = (double)(((double)tempo/(double)pac) * slot_duration * 1000);

	fprintf (pfile, "\n\n\nTEMPO MEDIO DI ATTESA DI UN PACCHETTO NEL BUFFER DI RICEZIONE: %.3f ms", media);	
}


/*-------------------------------------------------------------------------------------------*/

void Elimina_eventuale_pacchetto (struct el_buff *pacc, int altra_port, int altra_bs)
{
	int trovato;	
	struct el_buff *inizio;
	struct el_buff *corrente;
	struct el_buff *precedente;
	struct el_buff *generatore;

	inizio = BaseStation[altra_bs].BufRic[altra_port].buf;

	generatore = (struct el_buff *)malloc(sizeof(struct el_buff));
	generatore->next = inizio;

	precedente = generatore;
	corrente = inizio;
	trovato = NO;

	while ((corrente != NULL) && (trovato != SI))
	{
		if ((corrente->num == pacc->num) && (corrente->dest == pacc->dest) && (corrente->from == pacc->from))
			trovato = SI;

		else
		{
			precedente = corrente;
			corrente = corrente->next;			
		}
	}

	if (trovato == SI)  /* in puntatore  presente l'indirizzo del pacchetto da eliminare */
	{
		precedente->next = corrente->next;
		free (corrente);
	}

	inizio = generatore->next;
	free (generatore);

	if (trovato == SI)
	{
		BaseStation[altra_bs].BufRic[altra_port].buf = inizio;
		BaseStation[altra_bs].BufRic[altra_port].lenght --;
	}
}

/*-------------------------------------------------------------------------------------------*/

void Elimina_alcuni_pacchetti_in_BS (int a_partire, int x, int bs, int portante)
{
	struct el_buff *puntatore;
	struct el_buff *punt;
	struct el_buff *precedente;
	struct el_buff *appoggio;
	int contatore;

	contatore = 1;
	puntatore = BaseStation[bs].BufRic[portante].buf;
	precedente = BaseStation[bs].BufRic[portante].buf;

	if (a_partire + x - 1 > BaseStation[bs].BufRic[portante].lenght)
	{
		printf ("\n\nErrore in Elimina_alcuni_pacchetti_in_BS:");
		printf ("\nsi deve eliminare un numero di pacchetti superiore a quello possibile");
		getchar ();
	}

	if (x > BaseStation[bs].BufRic[portante].lenght)
	{
		printf ("\n\nErrore in Elimina_alcuni_pacchetti_in_BS:");
		printf ("\nsi deve eliminare un numero di pacchetti superiore a quello di pacchetti\n presenti nel buffer");
		getchar ();
	}

	if (x == BaseStation[bs].BufRic[portante].lenght)
	{
		/* devo eliminare tutti i pacchetti presenti nel buffer di ricezione */

		BaseStation[bs].BufRic[portante].lenght = 0;

		while (BaseStation[bs].BufRic[portante].buf != NULL)
		{
			punt = BaseStation[bs].BufRic[portante].buf;
			BaseStation[bs].BufRic[portante].buf = BaseStation[bs].BufRic[portante].buf->next;
			free (punt);
		}
	}	

	if (x < BaseStation[bs].BufRic[portante].lenght)
	{
	   /* al termine dei seguenti cicli while in "puntatore" c' l'indirizzo del pacchetto dal
	      quale deve cominciare l'eliminazione degli "x" pacchetti ("x"  sicuramente > 0) ed 
		  in "precedente" c' l'indirizzo del precedente al suddetto pacchetto */

		while ((contatore != a_partire) && (puntatore != NULL))
		{
			puntatore = puntatore->next;
		    contatore ++;
		}

		contatore = 1;

		if (a_partire > 1)
		{
			while ((contatore != (a_partire-1)) && (precedente != NULL))
			{
				precedente = precedente->next;
		        contatore ++;
			}
		}

        while (x > 0)  /* finch ci sono pacchetti da eliminare */
		{
			appoggio = puntatore->next;
			free (puntatore);
			puntatore = appoggio;
			x --;
			BaseStation[bs].BufRic[portante].lenght --;
		}

		precedente->next = appoggio;	/* collegamento */

		if (BaseStation[bs].BufRic[portante].lenght == 0)
			BaseStation[bs].BufRic[portante].buf = NULL;
	}
}

					                                
/*-------------------------------------------------------------------------------------------*/

/* Tale funzione copia i campi di un pacchetto in quelli di un altro */

void Riempi_campi_del_pacchetto_creato (struct el_buff *punt_vecchio, struct el_buff *punt_nuovo)
{
	int bs;

	punt_nuovo->info = punt_vecchio->info;
	punt_nuovo->dest = punt_vecchio->dest;
	punt_nuovo->num = punt_vecchio->num;
	punt_nuovo->from = punt_vecchio->from;
	punt_nuovo->clock = punt_vecchio->clock;
	punt_nuovo->BSclock = punt_vecchio->BSclock;
	punt_nuovo->next = punt_vecchio->next;

	for (bs=0; bs<CLUSTER; bs++)
		punt_nuovo->quality[bs] = punt_vecchio->quality[bs];
}

/*-------------------------------------------------------------------------------------------*/

/* Tale funzione copia un buffer di ricezione (vecchio) in un altro (nuovo), cio pone in
   "BaseStation[nuovaBS].BufRic[newCarrier].buf" l'indirizzo di un buffer uguale a quello
   contenuto nella vecchia BS */

void Copia_Buffer_di_ricezione (int vecchiaBS, int nuovaBS, int oldCarrier, int newCarrier)
{	
	struct el_buff *punt_old;
	struct el_buff *punt_new;

	punt_old = BaseStation[vecchiaBS].BufRic[oldCarrier].buf;     /* vecchio buffer */

	if (punt_old != NULL)
	{
		/* creazione del primo pacchetto del nuovo buffer */

        BaseStation[nuovaBS].BufRic[newCarrier].buf = (struct el_buff *)malloc(sizeof(struct el_buff));

        punt_new = BaseStation[nuovaBS].BufRic[newCarrier].buf;

	    Riempi_campi_del_pacchetto_creato (punt_old, punt_new);  /* primo pacchetto del buffer */

	    punt_old = punt_old->next;  /* ora punta al secondo pacchetto del vecchio buffer */

	    while (punt_old != NULL)
		{
			punt_new->next = (struct el_buff *)malloc(sizeof(struct el_buff));

		    punt_new = punt_new->next;

		    Riempi_campi_del_pacchetto_creato (punt_old, punt_new);

		    punt_old = punt_old->next;  /* ora punta al successivo pacchetto del vecchio buffer */
		}

        BaseStation[nuovaBS].BufRic[newCarrier].lenght = BaseStation[vecchiaBS].BufRic[oldCarrier].lenght;

	}
	else
	{
		BaseStation[nuovaBS].BufRic[newCarrier].lenght = 0;
		BaseStation[nuovaBS].BufRic[newCarrier].buf = NULL;
	}
}

/*-------------------------------------------------------------------------------------------*/

struct el_buff *Duplica_pacchetto (struct el_buff *punt_vecchio)
{
	struct el_buff *punt_nuovo;

	punt_nuovo = (struct el_buff *)malloc(sizeof(struct el_buff));

	Riempi_campi_del_pacchetto_creato (punt_vecchio, punt_nuovo);

	return (punt_nuovo);

}


/*-------------------------------------------------------------------------------------------*/

void Inizializza_Causa_della_terminazione (struct Causa_della_terminazione chiamate_terminate)
{
	 chiamate_terminate.in_totale = 0;
	 chiamate_terminate.spontaneamente = 0;
	 chiamate_terminate.x_HO_fallito = 0;
}


/*-------------------------------------------------------------------------------------------*/

void Stampa_percentuali (FILE *pfile, struct Causa_della_terminazione chiamate_terminate)
{
	int i;
	int iniziate = 0;
	float spontanee;
	float per_fallimento;
	float totali;
	float percentuale; 	    
	float fallite_x_eccessiva_attesa;
	float attesa_massima_in_secondi;
	float Numero_di_richieste_messe_in_attesa;	

	/* calcolo delle percentuali di comunicazioni terminate spontaneamente e a causa di HO
	   fallito */

	for (i=0; i<NMAX; i++)
		if (Risultati[i].Comunicazione_iniziata == SI)
			iniziate ++;

	iniziate = iniziate/2;  /* numero di comunicazioni iniziate */		

	if (chiamate_terminate.in_totale != 0)
	{
		totali = (float) chiamate_terminate.in_totale;
		spontanee = (float) chiamate_terminate.spontaneamente;
		per_fallimento = (float) chiamate_terminate.x_HO_fallito;

		percentuale = (spontanee/totali)* (float)100;

		fprintf(pfile,"\n\n\n\n\t\t\t\t\tSUDDIVISIONE PERCENTUALE DELLE COMUNICAZIONI TERMINATE:");

		fprintf(pfile,"\n\n\nnumero totale di comunicazioni iniziate: %d", iniziate);

		fprintf(pfile,"\n\nnumero totale di comunicazioni terminate: %d",
			    chiamate_terminate.in_totale);

		fprintf(pfile,"\n\npercentuale di comunicazioni terminate spontaneamente: %.3f",
			    percentuale);

		percentuale = (per_fallimento/totali)* (float)100;

		fprintf(pfile,"\n\npercentuale di comunicazioni terminate a causa del fallimento di un HO: %.3f",
			    percentuale);
		
		Stampa_riga_di_separazione (pfile);		
	}
	else
	{
		fprintf(pfile,"\n\n\n\t\t\t\t\tINFORMAZIONI SUL NUMERO DI COMUNICAZIONI INIZIATE:");

		fprintf(pfile,"\n\n\nnumero totale di comunicazioni iniziate: %d", iniziate);

		fprintf(pfile,"\n\nnumero totale di comunicazioni terminate: 0");

		Stampa_riga_di_separazione (pfile);
	}
    
	/* stampa della percentuale di richieste fallite a causa dell'eccessiva attesa (pi di 3.6
	   secondi) */

	if (Numero_totale_di_richieste != 0)
	{
		fprintf (pfile, "\n\n\n\t\t\t\t\t\t\t\tPERCENTUALE DI RICHIESTE FALLITE:");

		fprintf (pfile, "\n\n\nIn totale sono state effettuate %d richieste di assegnazione di sottoportante",
                 Numero_totale_di_richieste);		

		totali = (float) Numero_totale_di_richieste;

		Numero_di_richieste_messe_in_attesa = (totali - (float) Numero_di_richieste_subito_accolte);

		percentuale = ((float) Numero_di_richieste_subito_accolte/totali) * (float)100;

		fprintf (pfile, "\n\nPercentuale di richieste che sono state subito soddisfatte: %.3f", percentuale);

		percentuale = (Numero_di_richieste_messe_in_attesa/totali) * (float)100;

		fprintf (pfile, "\n\nPercentuale di richieste che, non essendo state subito soddisfatte, sono state messe in attesa:\n%.3f", percentuale);

		fallite_x_eccessiva_attesa = (float) Numero_totale_di_richieste_fallite_x_eccessiva_attesa;

		percentuale = (fallite_x_eccessiva_attesa/totali) * (float)100;

		attesa_massima_in_secondi = (float) (MASSIMA_ATTESA * FRAMEDURATION);	

		fprintf (pfile, "\n\nPercentuale di richieste fallite a causa dell'eccessiva attesa (maggiore di %.1f sec): %.3f",
			     attesa_massima_in_secondi, percentuale);

		Stampa_riga_di_separazione (pfile);
	}
}

	
/*-------------------------------------------------------------------------------------------*/

/* Tale funzione esegue il calcolo delle percentuali di pacchetti persi in trasmissione per
   ritardo e in ricezione per ritardo */

void Stampa_alcune_percentuali_sui_pacchetti (FILE *pfile)
{
	float totali;
	float percentuale; 
	float persi_in_up = 0;
	float persi_in_down = 0;

	if (Numero_totale_di_pacchetti_persi != 0)
	{
		totali = (float) Numero_totale_di_pacchetti_persi;

		persi_in_up = (float) Pacchetti_persi_x_eccessiva_attesa_nel_buffer_di_utente;
		persi_in_down = (float) Pacchetti_persi_x_eccessiva_attesa_nei_BufRic;

		fprintf (pfile, "\n\n\t\t\t\tSUDDIVISIONE PERCENTUALE DEI PACCHETTI PERSI PER ECCESSIVO RITARDO:");

		fprintf (pfile, "\n\n\nNUMERO TOTALE DI PACCHETTI PERSI PER ECCESSIVA ATTESA NEI BUFFERS: %d", Numero_totale_di_pacchetti_persi);

		percentuale = (persi_in_up/totali)* (float)100;
		fprintf (pfile, "\n\nPERCENTUALE DI PACCHETTI PERSI IN UPLINK PER ECCESSIVA ATTESA: %.3f", percentuale);
        
        percentuale = (persi_in_down/totali)* (float)100;
		fprintf (pfile, "\n\nPERCENTUALE DI PACCHETTI PERSI IN DOWNLINK PER ECCESSIVA ATTESA: %.3f",percentuale);	    
	}
	else	
		fprintf (pfile, "\n\nNON E' STATO PERSO ALCUN PACCHETTO A CAUSA DI ECCESSIVA ATTESA NEI BUFFERS");
}	


/*-------------------------------------------------------------------------------------------*/


/* Tale funzione serve per stampare alcuni risultati finali */

void Stampa_informazioni_sui_time_slots (FILE *pfile)
{
	int clust;			

    for (clust=0; clust<CLUSTER; clust++)
	{
		if (clust == 1)
			Stampa_riga_di_separazione (pfile);

		fprintf(pfile,"\n\n\nTIME SLOTS RELATIVI ALLA BS NUMERO %d:",clust);		    

	    fprintf(pfile,"\n\nSlots di uplink assegnati: %d", assigned[clust]);
        fprintf(pfile,"\n\nSlots di uplink realmente usati: %d", used[clust]);

	    fprintf(pfile,"\n\nSlots di uplink assegnati ma non usati: %d", non_used[clust]);
	    fprintf(pfile,"\n\nSlots di uplink assegnati in modo random: %d", 
		        assigned_random_up[clust]);

		fprintf(pfile,"\n");

	    fprintf(pfile,"\n\nSlots di downlink assegnati: %d", assigned_down[clust]);
        fprintf(pfile,"\n\nSlots di downlink realmente usati: %d", used_down[clust]);

	    fprintf(pfile,"\n\nSlots di downlink assegnati ma non usati: %d", non_used_down[clust]);
	    fprintf(pfile,"\n\nSlots di downlink assegnati in modo random: %d", 
		        assigned_random_down[clust]);    
	}

	fprintf(pfile,"\n\n\nNUMERO DI SLOT DI UPLINK ASSEGNATI A MS IN SOFT HO QUANDO NON SI ");
    fprintf(pfile,"SAREBBE DOVUTO: %d", appoggioslot);
}

/*-------------------------------------------------------------------------------------------*/

void Stampa_informazioni_finali (FILE *pfile, int gen, int persi_in_up, double RitardoMedioInTrasmissione, double RitardoMedioTotalePacchettiRicevuti)
{	  
	long double appfloat;

	fprintf(pfile,"\n\n\n\t\t\t\t\t\t\t\t\tRISULTATI DEFINITIVI");

	appfloat = ((long double)Numero_totale_di_pacchetti_persi/(long double)gen*100);
	
	fprintf(pfile, "\n\n\nPERCENTUALE MEDIA DI PACCHETTI PERSI SULL'INTERO COLLEGAMENTO PER ECCESSIVA ATTESA: %.2lf", appfloat);

	appfloat = ((long double)persi_in_up/(long double)gen*100);

	fprintf(pfile, "\n\nPERCENTUALE MEDIA DI PACCHETTI PERSI PRIMA DELLA TRASMISSIONE SUL CANALE DI UPLINK: %.2lf", appfloat);

	fprintf (pfile, "\n\nRITARDO MEDIO IN TRASMISSIONE (UPLINK): %.2f", RitardoMedioInTrasmissione);           
	fprintf (pfile, "\n\nRITARDO MEDIO TRA GENERAZIONE E RICEZIONE (UPLINK + DOWNLINK): %.2f", RitardoMedioTotalePacchettiRicevuti);

}


/*-------------------------------------------------------------------------------------------*/

void Stampa_informazioni_sui_pacchetti (FILE *pfile, int generati, int ricevuti, int persi_up)
{
	long double appfloat;
	
	fprintf(pfile,"\n");

    fprintf(pfile,"\n\nNUMERO TOTALE DI PACCHETTI GENERATI:\t %d ", generati);
    fprintf(pfile,"\n\nNUMERO TOTALE DI PACCHETTI RICEVUTI:\t %d ", ricevuti);

    appfloat = ((long double)(generati-ricevuti)/(long double)generati*100);

    fprintf(pfile, "\n\nPERCENTUALE MEDIA DI PACCHETTI PERSI IN TOTALE: %.3lf (eccessiva attesa + rimanenze)", appfloat);

	appfloat = ((long double)Numero_totale_di_pacchetti_persi/(long double)generati*100);
	
	fprintf(pfile, "\n\nPERCENTUALE MEDIA DI PACCHETTI PERSI SULL'INTERO COLLEGAMENTO PER ECCESSIVA ATTESA: %.3lf", appfloat);

	appfloat = ((long double)persi_up/(long double)generati*100);

	fprintf(pfile, "\n\nPERCENTUALE MEDIA DI PACCHETTI PERSI PRIMA DELLA TRASMISSIONE SUL CANALE DI UPLINK: %.3lf", appfloat);
}

/*-------------------------------------------------------------------------------------------*/

void Stampa_pacchetti_persi_in_uplink_e_downlink (FILE *pfile, int tot_persi, int *persi,
									              int tot_persi_in_up_da_MSinSHO,
												  int tot_persi_in_down_da_MSinSHO) 
{
	int clust;
	
	fprintf(pfile, "\n\nNUMERO TOTALE DI PACCHETTI PERSI SULL'UPLINK A CAUSA DI ECCESSIVA ATTESA: %d (%d)",Pacchetti_persi_x_eccessiva_attesa_nel_buffer_di_utente, tot_persi);

	fprintf(pfile, "\n\nNUMERO TOTALE DI PACCHETTI PERSI SUL DOWNLINK A CAUSA DI ECCESSIVA ATTESA: %d", 
		    Pacchetti_persi_x_eccessiva_attesa_nei_BufRic);	

    fprintf(pfile, "\n\nNUMERO DI PACCHETTI PERSI SULL'UPLINK A CAUSA DI ECCESSIVA ATTESA DA UTENTI IN SOFT HO: %d",
		    tot_persi_in_up_da_MSinSHO);

	fprintf(pfile, "\n\nNUMERO DI PACCHETTI PERSI SUL DOWNLINK A CAUSA DI ECCESSIVA ATTESA DA UTENTI IN SOFT HO: %d",
		    tot_persi_in_down_da_MSinSHO);

    for (clust=0; clust < CLUSTER; clust++)
	{
		fprintf(pfile, "\n\nNUMERO DI PACCHETTI PERSI SULL'UPLINK NELLA BS NUMERO %d: %d",
			    clust, persi[clust]);	
	}
}

/*-------------------------------------------------------------------------------------------*/

/* Tale funzione stampa il numero di pacchetti ricevuti fuori sequenza da ogni utente (serve
   per i risultati finali) */

void Stampa_pacchetti_ricevuti_fuori_sequenza (FILE *pfile, int *out_of_sequenza)
{
	int ll;
	int segnale = 0;
	
	fprintf(pfile, "\n\nNUMERO DI PACCHETTI RICEVUTI FUORI SEQUENZA DA CIASCUN UTENTE: ");

    for (ll=0; ll<NMAX; ll++)
	{
		if (out_of_sequenza[ll] > 0)
		{
			fprintf(pfile, "\n\nMS %3d: pacchetti ricevuti fuori sequenza = %d", ll, out_of_sequenza[ll]);
		    segnale = 1;
		}
	}
	
	if (segnale == 0)
		fprintf(pfile, "0");
}

/*-------------------------------------------------------------------------------------------*/

void Stampa_informazioni_su_HO (FILE *pfile)
{
	float percentuale = 0.0;

	fprintf(pfile,"\n\n\n\t\t\t\t\t\t\t\tINFORMAZIONI SUGLI HAND OVER");
	
	fprintf(pfile,"\n\n\nNumero totale di richieste di HO effettuate: %d", Numero_totale_di_richieste_di_HO);
 
    fprintf(pfile,"\n\nNumero totale di richieste di HO fallite: %d", totHOfalliti);

    fprintf(pfile,"\n\nNumero di HO falliti nel trasferimento dalla BS numero 0 alla BS numero 1: %d", 
            BaseStation[0].HO_non_realizzati);
      
    fprintf(pfile,"\nNumero di HO falliti nel trasferimento dalla BS numero 1 alla BS numero 0: %d", 
            BaseStation[1].HO_non_realizzati);

    fprintf(pfile,"\n\nNumero di HO realizzati con successo: %d", totHOriusciti);      

    fprintf(pfile,"\n\nProbabilita' che una richiesta di HO vada a buon fine: %.5f",
		    (float)totHOriusciti/((float)NUMFRAME * (float)NCARRIER));

    if((totHOriusciti + totHOfalliti) != 0)
	{
		percentuale = (float) ((float)totHOfalliti/((float)totHOriusciti + (float)totHOfalliti) * (float)100);

	    fprintf(pfile,"\n\nPercentuale dei fallimenti di HO: %.3f", percentuale);	
	}
}

/*-------------------------------------------------------------------------------------------*/

/* Tale funzione serve per calcolare e stampare il numero medio di trame in cui, durante un 
   HO, si sono avuti 2 collegamenti */

void Stampa_il_numero_medio_di_trame_con_due_collegamenti (FILE *pfile, int HO_riusciti)
{
	long double appoggiofloat = 0.0;
	int utente;

    for (utente=0; utente < NMAX; utente++)
		appoggiofloat += status[utente].SoftHOFrames;

    if (HO_riusciti != 0)
	{
		appoggiofloat = appoggiofloat/HO_riusciti;
	
	    fprintf(pfile, "\n\nNumero medio di trame con due collegamenti durante un HO: %.2f",
                appoggiofloat);
	}
}


/*-------------------------------------------------------------------------------------------*/

/* Tale funzione calcola e stampa su file la durata media di una comunicazione (in secondi).
   Non vengono prese in considerazione le coppie di utenti ancora in attivit al termine della 
   comunicazione (serve per i risultati finali) */

void Stampa_durata_media (FILE *pfile)
{
	int i;
	int numeratore = 0;
	int denominatore = 0;
	int trame = 0;
	float durata_media = 0.0;         /* durata media di una comunicazione (in secondi) */

	for (i=0; i<NMAX; i++)
	{
		/* considero solamente gli utenti che sono stati attivi e che hanno terminato la
		   comunicazione */

		if ((Risultati[i].durata_comunicazione != NO_VALIDO) 
			&& (status[i].utente_attivo == NON_ATTIVO))
		{
			numeratore += Risultati[i].durata_comunicazione;
			denominatore ++;
		}
	}

	if (denominatore != 0)
	{
		trame = numeratore/denominatore;                  /* durata media in trame */
		
		durata_media = (float) (trame * FRAMEDURATION);   /* durata media in secondi */

	    fprintf(pfile, "\n\nDURATA MEDIA DI UNA COMUNICAZIONE: %.3f SECONDI",
			    durata_media);
	}
	else
		fprintf(pfile, "\n\nNON E' POSSIBILE CALCOLARE LA DURATA MEDIA DI UNA COMUNICAZIONE");
}


/*-------------------------------------------------------------------------------------------*/

/* Tale funzione calcola e stampa il tempo medio (in secondi) che il generico utente 
   richiedente ha dovuto attendere prima che gli venisse assegnata una sottoportante di
   segnalazione */

void Stampa_tempo_di_attesa_medio (FILE *pfile)
{
	int i;
	int numeratore = 0;
	int denominatore = 0;
	int trame = 0;
	float attesa_media = 0.0;         /* attesa media prima di ottenere una sottoportante
	                                     (in secondi) */

	for (i=0; i<NMAX; i++)
	{
		/* considero solamente gli utenti che sono stati attivi e che hanno effettuato una 
		   richiesta di sottoportante */

		if (Risultati[i].Utente_richiedente_con_successo == SI) 
			
		{
			numeratore += Risultati[i].Trame_di_attesa_per_ottenere_sottoportante;
			denominatore ++;
		}
	}

	if (denominatore != 0)
	{
		trame = numeratore/denominatore;                  /* attesa media in trame */
		
		attesa_media = (float) (trame * FRAMEDURATION);   /* attesa media in secondi */

	    fprintf(pfile, "\n\nTEMPO MEDIO DI ATTESA PER OTTENERE UNA SOTTOPORTANTE: %.3f SECONDI",
			    attesa_media);

		Stampa_riga_di_separazione (pfile);
	}
	else
	{
		fprintf(pfile, "\n\nNESSUN UTENTE HA FATTO RICHIESTA DI SOTTOPORTANTE");

		Stampa_riga_di_separazione (pfile);
	}
}


/*-------------------------------------------------------------------------------------------*/

/* Tale funzione conta e restituisce il numero di pacchetti presenti nel buffer di ricezione
   associato nella BS numero "bs" alla sottoportante numero "carrier" */

int Conta_pacchetti_nel_buffer_di_ricezione (int bs, int carrier)  /* funzione non usata */
{
	struct el_buff *puntatore;        /* puntatore ad un pacchetto */	
	int numero_pacchetti = 0;

    puntatore = BaseStation[bs].BufRic[carrier].buf;  /* indirizzo del buffer di ricezione */

	while (puntatore != NULL)
	{
		puntatore = puntatore->next;
		numero_pacchetti ++; 
	}

	return (numero_pacchetti);

}

/*-------------------------------------------------------------------------------------------*/

/* Tale funzione conta e restituisce il numero dei pacchetti presenti nel buffer dell'utente
   numero "utente" */

int Conta_pacchetti_nel_buffer_di_utente (int utente)
{
	struct el_buff *puntatore;        /* puntatore ad un pacchetto */	
	int numero_pacchetti = 0;

    puntatore = punt_buffer[utente];  /* indirizzo del buffer dell'utente numero utente */

	while (puntatore != NULL)
	{
		puntatore = puntatore->next;
		numero_pacchetti ++; 
	}

	return (numero_pacchetti);

}

/*-------------------------------------------------------------------------------------------*/

/* Tale funzione serve a tener conto dei pacchetti rimasti nei buffer (di utente e ricezione)
   degli utenti che sono attivi a fine simulazione ed  usata nella scrittura dei risultati
   finali */

void Aggiorna_alcuni_dati ()
{
	int stat;
	int BSservente, sottoportante, BSnuova, nuova_sottoportante;	
	
	for (stat=0; stat<NMAX; stat++)  
	{
		totHOriusciti += status[stat].NumOfHO;
	    totHOfalliti += status[stat].HO_Falliti;

	    if (status[stat].utente_attivo == ATTIVO)
		{
			Risultati[stat].Pacchetti_generati_ma_rimasti_nel_suo_buffer = 
			    Conta_pacchetti_nel_buffer_di_utente (stat);

		    if ((status[stat].in_HO == NO) && (status[stat].HO_STEP == NESSUNO)) /* non in HO */
			{
				BSservente = status[stat].MyServBS;                           
                sottoportante = status[stat].mySubcarrier[BSservente];

			    Risultati[stat].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez =
				    BaseStation[BSservente].BufRic[sottoportante].lenght;
			}

		    if ((status[stat].in_HO == NO) && (status[stat].HO_STEP == 5))  /* in HO_STEP_5 */
			{
				BSnuova = status[stat].MyServBS;					
	            nuova_sottoportante = status[stat].mySubcarrier[BSnuova];
            
			    Risultati[stat].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez =
				    Pacchetti_in_BS_vecchia[stat];

			    Risultati[stat].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez +=
				    BaseStation[BSnuova].BufRic[nuova_sottoportante].lenght;
			}

		    if (status[stat].HO_STEP == 1)		/* in HO_STEP_1 */				
			{
				BSservente = status[stat].MyServBS;
                sottoportante = status[stat].mySubcarrier[BSservente];  
			
	            Risultati[stat].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez =
				    BaseStation[BSservente].BufRic[sottoportante].lenght;
			}

		    if (((status[stat].HO_STEP == 21) || (status[stat].HO_STEP == 22))  /* in HO_STEP_2 */
			    && (HO_Fallito[stat] == NO))
			{ 
				BSservente = status[stat].MyServBS;
                sottoportante = status[stat].mySubcarrier[BSservente];		
			
	            Risultati[stat].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez =
				    BaseStation[BSservente].BufRic[sottoportante].lenght;
			}

		    if (status[stat].HO_STEP == 3) 	   /* in HO_STEP_3 */				
			{
				BSnuova = status[stat].MyServBS;
                nuova_sottoportante = status[stat].mySubcarrier[BSnuova];

	            Risultati[stat].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez =
				    Pacchetti_in_BS_vecchia[stat]; 

			    Risultati[stat].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez +=
				    BaseStation[BSnuova].BufRic[nuova_sottoportante].lenght;  /* agg */
			}

		    if (status[stat].HO_STEP == 4)     /* in HO_STEP_4 */
			{
				BSnuova = status[stat].MyServBS;
                nuova_sottoportante = status[stat].mySubcarrier[BSnuova];
			
	            Risultati[stat].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez =
				    Pacchetti_in_BS_vecchia[stat];   

			    Risultati[stat].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez +=
				    BaseStation[BSnuova].BufRic[nuova_sottoportante].lenght;			    
			}
		}
	}
}

/*-------------------------------------------------------------------------------------------*/

void Stampa_dati_sulla_mobility (FILE *pfile, int mobility)
{
	if (mobility == 1)
	{
		fprintf(pfile,"\n\n\n\t\t\t\t\t\t\t\tINFORMAZIONI SULLA MOBILITA'");
		fprintf(pfile,"\n\n\nAREA DI SOVRAPPOSIZIONE TRA CELLE: PICCOLA");
		fprintf(pfile,"\n\nGRADO DI MOBILITA': BASSO (cio probabilit di HO pari a 0.00015)");
	}

	if (mobility == 2)
	{
		fprintf(pfile,"\n\n\n\t\t\t\t\t\t\t\tINFORMAZIONI SULLA MOBILITA'");
		fprintf(pfile,"\n\n\nAREA DI SOVRAPPOSIZIONE TRA CELLE: PICCOLA");
		fprintf(pfile,"\n\nGRADO DI MOBILITA': MEDIO (cio probabilit di HO pari a 0.0015)");
	}

	if (mobility == 3)
	{
		fprintf(pfile,"\n\n\n\t\t\t\t\t\t\t\tINFORMAZIONI SULLA MOBILITA'");
		fprintf(pfile,"\n\n\nAREA DI SOVRAPPOSIZIONE TRA CELLE: MEDIA");
		fprintf(pfile,"\n\nGRADO DI MOBILITA': BASSO (cio probabilit di HO pari a 0.00015)");
	}

	if (mobility == 4)
	{
		fprintf(pfile,"\n\n\n\t\t\t\t\t\t\t\tINFORMAZIONI SULLA MOBILITA'");
		fprintf(pfile,"\n\n\nAREA DI SOVRAPPOSIZIONE TRA CELLE: MEDIA");
		fprintf(pfile,"\n\nGRADO DI MOBILITA': MEDIO (cio probabilit di HO pari a 0.0015)");
	}

	if (mobility == 5)
	{
		fprintf(pfile,"\n\n\n\t\t\t\t\t\t\t\tINFORMAZIONI SULLA MOBILITA'");
		fprintf(pfile,"\n\n\nAREA DI SOVRAPPOSIZIONE TRA CELLE: MEDIA");
		fprintf(pfile,"\n\nGRADO DI MOBILITA': ALTO (cio probabilit di HO pari a 0.005)");
	}

	if (mobility == 6)
	{
		fprintf(pfile,"\n\n\n\t\t\t\t\t\t\t\tINFORMAZIONI SULLA MOBILITA'");
		fprintf(pfile,"\n\n\nAREA DI SOVRAPPOSIZIONE TRA CELLE: GRANDE");
		fprintf(pfile,"\n\nGRADO DI MOBILITA': BASSO (cio probabilit di HO pari a 0.00015)");
	}

	if (mobility == 7)
	{
		fprintf(pfile,"\n\n\n\t\t\t\t\t\t\t\tINFORMAZIONI SULLA MOBILITA'");
		fprintf(pfile,"\n\n\nAREA DI SOVRAPPOSIZIONE TRA CELLE: GRANDE");
		fprintf(pfile,"\n\nGRADO DI MOBILITA': MEDIO (cio probabilit di HO pari a 0.0015)");
	}
}


/*-------------------------------------------------------------------------------------------*/

/* Tale funzione stampa alcuni risultati iniziali di natura generale */

void Stampa_risultati_iniziali (FILE *pfile, int TIMEOFHO, int TIMEOFSOFTHO, int som)
{
	int ll;
	int clust;
	int ContaQuantiUtentiTipo[6] = {0};
	long double appoggiofloat;
	long double costint;
	float max_attesa;
	float durata_simulazione;
	float tempo_minimo;
	float media = 0;

	appoggiofloat = ((numero_di_utenti_collegati_inizialmente * 100)/(2 * NCARRIER));
	durata_simulazione = (float) (NUMFRAME * FRAMEDURATION);
	max_attesa = (float) (MASSIMA_ATTESA * FRAMEDURATION);
	tempo_minimo = (float) (LIMITE * FRAMEDURATION);
	media = ((float)som/((float)(NUMFRAME*2)));
	
	fprintf(pfile,"\n\t\t\t\t\t\t******* FILE CONTENENTE I RISULTATI FINALI *******\n\n\n");    

    fprintf(pfile,"\t\t\tRISULTATI DI UNA SIMULAZIONE RELATIVA A %d TRAME CIOE' A %.3f SECONDI\n", NUMFRAME, durata_simulazione);

	fprintf(pfile,"\n\nNUMERO MEDIO IPOTIZZATO DI UTENTI PRESENTI IN UNA CELLA: %d", (NCARRIER-MINIMO));

	fprintf(pfile,"\n\nNUMERO MEDIO REALE DI UTENTI PRESENTI IN UNA CELLA: %.2f", media);
	
	fprintf(pfile,"\n\nPARAMETRI DEL SOFT HO: TIMEOFHO = %d, TIMEOFSOFTHO = %d", TIMEOFHO, TIMEOFSOFTHO);

    fprintf(pfile,"\n\nNUMERO INIZIALE DI UTENTI ATTIVI IN CIASCUNA BS: %d",
	 	    numero_di_utenti_collegati_inizialmente/2);

    fprintf(pfile,"\n\nVALORI DELLE DEFINE MAX_MS_ONE_LINK E MAX_MS_TOT: %d E %d", MAX_MS_ONE_LINK, MAX_MS_TOT);     

    fprintf(pfile,"\n\nPERCENTUALE DI SOTTOPORTANTI OCCUPATE INIZIALMENTE: %.2f", appoggiofloat);

	fprintf(pfile,"\n\nNUMERO DI SOTTOPORTANTI PRESENTI IN CIASCUNA BS: %d", NCARRIER);

	fprintf(pfile,"\n\nTEMPO MASSIMO DI ATTESA PER L'ASSEGNAZIONE DI UNA SOTTOPORTANTE: %.1f SECONDI", max_attesa);
    fprintf(pfile,"\n\nTEMPO MINIMO ENTRO IL QUALE UNA COMUNICAZIONE NON PUO' TERMINARE SPONTANEAMENTE: %.1f SECONDI", tempo_minimo);

    for (ll=0; ll<NMAX; ll++)
	{
		switch(c[ll])  /* c[NMAX]  una variabile globale */
		{
		case('a'):ContaQuantiUtentiTipo[1]++; break;  /* voice */
	    case('b'):ContaQuantiUtentiTipo[2]++; break;  /* video */
	    case('c'):ContaQuantiUtentiTipo[3]++; break;  /* dati */
	    case('d'):ContaQuantiUtentiTipo[4]++; break;  /* dati */
	    case('e'):ContaQuantiUtentiTipo[5]++; break;  /* vario */
		}
	}

    for(ll=1; ll<=2; ll++)  /* modificato: prima ll arrivava fino a 5 */
	{
		fprintf(pfile,"\n\nNUMERO DI UTENTI DI TIPO %s ABBONATI: %d", TIPO[ll], ContaQuantiUtentiTipo[ll]);
	    ContaQuantiUtentiTipo[ll] = 0;
	}

	fprintf(pfile,"\n\nNUMERO DI UTENTI INIZIALMENTE COLLEGATI: %d", numero_di_utenti_collegati_inizialmente);

	Stampa_riga_di_separazione (pfile);
	
	fprintf(pfile,"\n\n\n\t\t\t\t\t\t\tINFORMAZIONI SULL'USO DELLE SOTTOPORTANTI");

    for (clust=0; clust<CLUSTER; clust++)
	{
		fprintf(pfile,"\n\n\nPER LA BS NUMERO %d\n\nSOTTOPORTANTE ->  PERCENTUALI D'USO NETTA    LORDA\n",
		        clust);
		
		for(ll=0; ll<NCARRIER; ll++)
		{
			appoggiofloat = ((long double)BaseStation[clust].Use_of_subc_gross[ll]*100.00)/
			                (long double)NUMFRAME;

		    if (BaseStation[clust].conta_time_not_free[ll] != 0)
				costint = ((long double)BaseStation[clust].Use_of_subc_gross[ll]*100.00)/
			               (long double)BaseStation[clust].conta_time_not_free[ll];
		    else 
				costint = 0;

		    fprintf (pfile,"\n\t%2d ->\t\t\t\t\t\t\t%.3f \t%.3f", ll, costint, appoggiofloat);			
		}                           	   		
	}
}

/*-------------------------------------------------------------------------------------------*/

/* Tale funzione serve per stampare alcuni risultati per ciscun utente abbonato che ha iniziato
   una comunicazione */

void Stampa_risultati_per_ciascuna_MS (FILE *pfile, int generati, int persi_in_up)
{
	long double appoggiofloat;
	long int contist;
	float durata;
	float attesa;
	int ll, appdest, clust;
	double RitardoMedioInTrasmissione = 0;           /* Aggiunto */
	double RitardoMedioTotalePacchettiRicevuti = 0;  /* Aggiunto */
	int flag = 0;
	
	fprintf(pfile,"\n\n\n\t\t\t\t\t\t\t\tRISULTATI RELATIVI A CIASCUNA MS");

    for (ll=0; ll<NMAX; ll++)
	{
		appoggiofloat = ((long double)status[ll].MySubcarrierUse/NUMFRAME);

	    for (clust=0; clust < CLUSTER; clust++)
		    tot_pack_sent[ll] += status[ll].pack_sent[clust];	

	    appdest = status[ll].destinazione;        
	
	    fprintf(pfile,"\n\n\nMS NUMERO %d (CONNESSA CON LA MS NUMERO %d):", ll, appdest);
		
		if (status[ll].kind_of_service == 2)
			fprintf(pfile,"\n\nTipo di servizio: VIDEO");

		if (status[ll].kind_of_service == 1)
			fprintf(pfile,"\n\nTipo di servizio: VOCE");

	    if (Risultati[ll].Comunicazione_iniziata == SI)
		    fprintf(pfile,"\n\nLa comunicazione tra gli utenti %d e %d  iniziata nella trama %d", ll,
		            appdest, Risultati[ll].Trama_di_inizio_comunicazione); 		
	    else 
		    fprintf(pfile,"\n\nLa comunicazione tra gli utenti %d e %d non  mai iniziata", ll,
		            appdest);

		if ((Risultati[ll].Comunicazione_iniziata == SI) && (Risultati[ll].Comunicazione_terminata == SI))
		{
			durata = (float) ((Risultati[ll].durata_comunicazione) * FRAMEDURATION);

			fprintf(pfile,"\n\nLa comunicazione tra gli utenti %d e %d  durata %d trame, equivalenti a %.3f secondi", 
		            ll, appdest, Risultati[ll].durata_comunicazione, durata);
		}

		if ((Risultati[ll].Comunicazione_iniziata == SI) && (Risultati[ll].Comunicazione_terminata == NO))
		{
			fprintf(pfile,"\n\nLa comunicazione tra gli utenti %d e %d, al termine della simulazione, non era terminata",
                    ll, appdest);

			durata = (float) ((Risultati[ll].durata_comunicazione) * FRAMEDURATION);

			fprintf(pfile,"\n(tali utenti erano in collegamento da %d trame, equivalenti a %.3f secondi)",
				    Risultati[ll].durata_comunicazione, durata);
		}

	    if (status[ll].utente_attivo == ATTIVO)
		    fprintf(pfile,"\n\nL'utente %d a fine simulazione era ancora ATTIVO", ll);

        if ((status[ll].utente_attivo == NON_ATTIVO) &&
		    (Risultati[ll].durata_comunicazione != NO_VALIDO))
		    fprintf(pfile,"\n\nL'utente %d a fine simulazione non era pi ATTIVO", ll);

	    if ((status[ll].utente_attivo == NON_ATTIVO) &&
		    (Risultati[ll].durata_comunicazione == NO_VALIDO))
		    fprintf(pfile,"\n\nL'utente %d non  mai stato ATTIVO", ll);

	    if (status[appdest].utente_attivo == ATTIVO)
		    fprintf(pfile,"\n\nL'utente %d a fine simulazione era ancora ATTIVO", appdest);

        if ((status[appdest].utente_attivo == NON_ATTIVO) &&
		    (Risultati[appdest].durata_comunicazione != NO_VALIDO))
		    fprintf(pfile,"\n\nL'utente %d a fine simulazione non era pi ATTIVO", appdest);

	    if ((status[appdest].utente_attivo == NON_ATTIVO) &&
		    (Risultati[appdest].durata_comunicazione == NO_VALIDO))
		    fprintf(pfile,"\n\nL'utente %d non  mai stato ATTIVO", appdest);

		if ((Risultati[ll].Richiesta_fallita_x_eccessiva_attesa = SI) && (Risultati[ll].Numero_richieste_fallite_x_eccessiva_attesa == 1))
		
			fprintf(pfile,"\n\nL'utente %d ha fallito la richiesta di assegnazione di sottoportante %d volta per eccessiva\nattesa",
				    ll, Risultati[ll].Numero_richieste_fallite_x_eccessiva_attesa);

		if ((Risultati[ll].Richiesta_fallita_x_eccessiva_attesa = SI) && (Risultati[ll].Numero_richieste_fallite_x_eccessiva_attesa > 1))
		
			fprintf(pfile,"\n\nL'utente %d ha fallito la richiesta di assegnazione di sottoportante %d volte per eccessiva\nattesa",
				    ll, Risultati[ll].Numero_richieste_fallite_x_eccessiva_attesa);
	
	    if (Risultati[ll].Comunicazione_iniziata == SI)        /* iniziata */
		{
			if ((Risultati[ll].Attivo_da_subito == NO) && (Risultati[ll].Utente_richiedente_con_successo == SI))
			{
				attesa = (float) ((Risultati[ll].Trame_di_attesa_per_ottenere_sottoportante) * FRAMEDURATION);

				fprintf(pfile,"\n\nL'utente numero %d, prima di ottenere la sottoportante, ha atteso %d trame cio %.3f sec",
					    ll, Risultati[ll].Trame_di_attesa_per_ottenere_sottoportante, attesa);
			}

		    if (Risultati[ll].Attivo_da_subito == SI) 
			{
				fprintf(pfile,"\n\nAll'inizio della simulazione l'utente numero %d era gi ATTIVO", ll);
			}			

            if (Risultati[ll].Comunicazione_terminata_spontaneamente == SI)
			    fprintf(pfile,"\n\nL'utente numero %d ha terminato spontaneamente la comunicazione", ll);

            if (Risultati[ll].Comunicazione_terminata_x_HO_fallito == SI)
			    fprintf(pfile,"\n\nL'utente numero %d ha terminato la comunicazione a causa del fallimento di un HO", ll);

		    if (Risultati[ll].Comunicazione_terminata_x_HO_fallito_dal_compagno == SI)
			    fprintf(pfile,"\n\nL'utente numero %d ha terminato la comunicazione in quanto il compagno ha fallito un HO", ll);

		    if (Risultati[ll].Comunicazione_terminata == SI)  /*  terminata */
			{
				if (Risultati[ll].Passo_di_HO_in_cui_ha_terminato_la_comunicazione == 1)
				{
					fprintf(pfile,"\n\nL'utente numero %d ha terminato la comunicazione e aveva terminato il passo 1 di HO", ll);
				}

			    if ((Risultati[ll].Passo_di_HO_in_cui_ha_terminato_la_comunicazione == 2) &&
					(Risultati[ll].Comunicazione_terminata_x_HO_fallito == NO))
				{
					fprintf(pfile,"\n\nL'utente numero %d ha terminato la comunicazione e aveva terminato il passo 2 di HO", ll);
				}

			    if (Risultati[ll].Passo_di_HO_in_cui_ha_terminato_la_comunicazione == 3)
				{
					fprintf(pfile,"\n\nL'utente numero %d ha terminato la comunicazione e aveva terminato il passo 3 di HO", ll);
				}

			    if (Risultati[ll].Passo_di_HO_in_cui_ha_terminato_la_comunicazione == 4)
				{
					fprintf(pfile,"\n\nL'utente numero %d ha terminato la comunicazione e aveva terminato il passo 4 di HO", ll);
				}

			    if (Risultati[ll].Passo_di_HO_in_cui_ha_terminato_la_comunicazione == 5)
				{
					fprintf(pfile,"\n\nL'utente numero %d ha terminato la comunicazione e aveva terminato il passo 5 di HO", ll);
				}

			    if (Risultati[ll].Passo_di_HO_in_cui_ha_terminato_la_comunicazione == NESSUNO)
				{
					fprintf(pfile,"\n\nL'utente numero %d ha terminato la comunicazione e non era in HO", ll);
				}

			    if ((Risultati[ll].Comunicazione_terminata_x_HO_fallito == SI) &&
					(Risultati[ll].Passo_di_HO_in_cui_ha_terminato_la_comunicazione == 2))
				{
					fprintf(pfile,"\n\nL'utente numero %d ha terminato la comunicazione perch ha fallito un HO", ll);
				}
			}

		    if (Risultati[ll].Comunicazione_terminata == NO) /* non  terminata */			
			{
				if ((status[ll].in_HO == NO) && (status[ll].HO_STEP == NESSUNO))
				{
					fprintf(pfile,"\n\nL'utente numero %d a fine simulazione era ATTIVO e non era in HO",ll);
				}

			    if (status[ll].HO_STEP == 1)
				{
					fprintf(pfile,"\n\nL'utente numero %d a fine simulazione era ATTIVO e aveva terminato il passo 1 di HO", ll);
				}

			    if (((status[ll].HO_STEP == 21) || (status[ll].HO_STEP == 22))
				    && (HO_Fallito[ll] == NO))
				{
					fprintf(pfile,"\n\nL'utente numero %d a fine simulazione era ATTIVO e aveva terminato il passo 2 di HO", ll);
				}

			    if (status[ll].HO_STEP == 3)
				{
					fprintf(pfile,"\n\nL'utente numero %d a fine simulazione era ATTIVO e aveva terminato il passo 3 di HO", ll);
				}

			    if (status[ll].HO_STEP == 4)
				{
					fprintf(pfile,"\n\nL'utente numero %d a fine simulazione era ATTIVO e aveva terminato il passo 4 di HO", ll);
				}

			    if ((status[ll].in_HO == NO) && (status[ll].HO_STEP == 5))
				{
					fprintf(pfile,"\n\nL'utente numero %d a fine simulazione era ATTIVO e aveva terminato il passo 5 di HO", ll);
				}
			}
	
	        fprintf(pfile,"\n\nPACCHETTI \tgenerati: %ld",Risultati[ll].Pacchetti_generati);	
	        fprintf(pfile,"\n\n\t\t\tpersi in uplink per eccessiva attesa: %d",Risultati[ll].Pacchetti_generati_ma_persi_x_eccessiva_attesa_nel_suo_buffer);	    
		    fprintf(pfile,"\n\n\t\t\trimasti nel suo buffer di utente: %d",Risultati[ll].Pacchetti_generati_ma_rimasti_nel_suo_buffer);	
	        fprintf(pfile,"\n\n\t\t\ttrasmessi (verso la MS %d): %ld", appdest, Risultati[ll].Pacchetti_generati_ed_inviati_ad_una_BS);

	        fprintf(pfile,"\n\n\t\t\teffettivamente arrivati (alla MS %d): %ld ", appdest, status[ll].pack_arrived);
		    fprintf(pfile,"\n\t\t\t(infatti %ld pacchetti sono rimasti nei buffer di ricezione,", Risultati[appdest].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez);    
            fprintf(pfile,"\n\t\t\t %ld pacchetti sono stati eliminati da tali buffer per eccessiva attesa e", Risultati[appdest].Pacchetti_ad_esso_diretti_ma_persi_x_eccessiva_attesa_nel_buffer_di_ricez);
			fprintf(pfile,"\n\t\t\t %ld pacchetti sono stati persi in downlink per HO)", Risultati[appdest].Pacchetti_ad_esso_diretti_ma_persi_x_HO);

            fprintf(pfile,"\n\n\t\t\tnon ricevuti perch rimasti nei buffer di ricezione: %d", Risultati[ll].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez);
	
	        fprintf(pfile,"\n\n\t\t\tricevuti: %ld",Risultati[ll].Pacchetti_ricevuti);	
	    
	        fprintf(pfile,"\n\n\t\t\tpersi in downlink per un'eccessiva attesa di servizio: %d",
		            Risultati[ll].Pacchetti_ad_esso_diretti_ma_persi_x_eccessiva_attesa_nel_buffer_di_ricez);	
	
	        fprintf(pfile,"\n\n\t\t\tpersi in downlink per HO: %d", Risultati[ll].Pacchetti_ad_esso_diretti_ma_persi_x_HO);
	
	        fprintf(pfile,"\n\nRitardo medio in trasmissione: %.3f ms",status[ll].mean_delay * 1.0e+3); 
	        fprintf(pfile,"\nRitardo medio totale dei pacchetti ricevuti: %.3f ms",
		            status[ll].whole_mean_delay * 1.0e+3);

			if (flag == 0)
			{
				RitardoMedioInTrasmissione += status[ll].mean_delay * 1.0e+3;
				RitardoMedioTotalePacchettiRicevuti += status[ll].whole_mean_delay * 1.0e+3;
				flag = 1;
			}
			else
			{
				RitardoMedioInTrasmissione = (RitardoMedioInTrasmissione + status[ll].mean_delay * 1.0e+3)/2;
                RitardoMedioTotalePacchettiRicevuti = (RitardoMedioTotalePacchettiRicevuti + status[ll].whole_mean_delay * 1.0e+3)/2;
			}
	
	        fprintf(pfile,"\n\nNumero di HO realizzati con successo: %d",Risultati[ll].HO_effettuati);

	        fprintf(pfile,"\n\nPercentuale di tempo per cui usa le sottoportanti assegnate: %.2f",
		            appoggiofloat * 100.0);

	        fprintf (pfile, "\n\nPacchetti trasmessi sull'uplink verso BS 0 ed 1: %ld %ld", 
		             status[ll].pack_sent[0], status[ll].pack_sent[1]);		

	        fprintf (pfile,"\n\nIstogramma dei ritardi di uplink (ms) subti dai pacchetti trasmessi"); 
            fprintf (pfile," dall'utente %d:\n", ll); 

	        for (contist=1; contist < DIMISTOGRAMMA; contist++)
			{
				if (contist < DIMISTOGRAMMA-1)
				{
					fprintf (pfile, "(%2d,%2d]: %4d\t", contist-1, contist, 
				             status[ll].UpDelIst[contist]);

			        if (contist%10 == 0)
				        fprintf (pfile, "\n");
				}

		        else
					fprintf (pfile, "(%2d,..): %4d", contist-1, status[ll].UpDelIst[contist]);
			}

	        fprintf (pfile, "\n\nIstogramma dei ritardi totali (ms) subti dai pacchetti trasmessi"); 
            fprintf (pfile, " dall'utente %d:\n", ll);

	        for (contist=1; contist < DIMISTOGRAMMA; contist++)
			{
				if (contist < DIMISTOGRAMMA-1)
				{
					fprintf (pfile, "(%2d,%2d]: %4d\t", contist-1, contist,
				             status[ll].TotDelIst[contist]);

			        if (contist%10 == 0)
				        fprintf (pfile, "\n");
				}

		        else
			        fprintf (pfile, "(%2d,..): %4d", contist-1, status[ll].TotDelIst[contist]);
			}

		    Stampa_riga_di_separazione (pfile);

        }  /* fine if */

	    else
		{
			fprintf (pfile, "\n\nPer l'utente numero %d non ci sono altre informazioni", ll);

		    Stampa_riga_di_separazione (pfile);
		}
  
    }   /* fine ciclo for */  

	Stampa_informazioni_finali (pfile, generati, persi_in_up, RitardoMedioInTrasmissione, RitardoMedioTotalePacchettiRicevuti);

    Stampa_riga_di_separazione (pfile);
}

/*-------------------------------------------------------------------------------------------*/

void Inizializza_Risultati ()
{
	int i;

	for (i=0; i<NMAX; i++)
	{
		Risultati[i].Comunicazione_iniziata = NO;
	    Risultati[i].Trama_di_inizio_comunicazione = NO_VALIDO;
	    Risultati[i].Trame_di_attesa_per_ottenere_sottoportante = NO_VALIDO;
	    Risultati[i].durata_comunicazione = NO_VALIDO;
	    Risultati[i].HO_effettuati = 0;
	    Risultati[i].Comunicazione_terminata_spontaneamente = NO;
	    Risultati[i].Comunicazione_terminata_x_HO_fallito = NO;
	    Risultati[i].Comunicazione_terminata_x_HO_fallito_dal_compagno = NO;
        Risultati[i].Comunicazione_terminata = NO;
		Risultati[i].Passo_di_HO_in_cui_ha_terminato_la_comunicazione = NESSUNO;

        Risultati[i].Attivo_da_subito = NO;
	    Risultati[i].Utente_richiedente_con_successo = NO;
		Risultati[i].Richiesta_fallita_x_eccessiva_attesa = NO;
		Risultati[i].Numero_richieste_fallite_x_eccessiva_attesa = 0;

	    Risultati[i].Pacchetti_generati = 0;
	    Risultati[i].Pacchetti_ricevuti = 0;
	    Risultati[i].Pacchetti_generati_ma_persi_x_eccessiva_attesa_nel_suo_buffer = 0;  
	    Risultati[i].Pacchetti_generati_ed_inviati_ad_una_BS = 0;
	    Risultati[i].Pacchetti_ad_esso_diretti_ma_persi_x_eccessiva_attesa_nel_buffer_di_ricez = 0;
		Risultati[i].Pacchetti_ad_esso_diretti_ma_persi_x_HO = 0;

		Risultati[i].Pacchetti_generati_ma_rimasti_nel_suo_buffer = 0;  
	    Risultati[i].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez = 0;
	
	    Risultati[i].Numero_di_slots_di_uplink_assegnati_in_totale = 0;
	    Risultati[i].Numero_di_slots_di_uplink_assegnati_ed_usati = 0;
	    Risultati[i].Numero_di_slots_di_uplink_assegnati_ma_non_usati = 0;
	    Risultati[i].Numero_di_slots_di_uplink_assegnati_in_modo_random = 0;

	    Risultati[i].Numero_di_slots_di_downlink_assegnati_in_totale = 0;
	    Risultati[i].Numero_di_slots_di_downlink_assegnati_ed_usati = 0;
	    Risultati[i].Numero_di_slots_di_downlink_assegnati_ma_non_usati = 0;
	    Risultati[i].Numero_di_slots_di_downlink_assegnati_in_modo_random = 0;
	}

}   


/*-------------------------------------------------------------------------------------------*/


/* Tale funzione restituisce il numero di sottoportanti disponibili nella BS numero bs */


int Conta_sottoportanti_libere (int bs)
{
	int cnt;
	int contasottoportanti = 0;

	for (cnt=0; cnt<NCARRIER; cnt++)
		if (BaseStation[bs].vettsubcfree[cnt] == FREE)
			contasottoportanti ++;

	return (contasottoportanti);
}


/*-------------------------------------------------------------------------------------------*/

void Messaggio_Liberazione (int trama, int BS, int portante, int user)
{
	printf ("\n\nTrama %d: nella BS numero %d e' stata tolta la sottoportante numero %d",
			trama, BS, portante);
	printf ("\n\t  all'utente numero %d", user);
}

                              
/*-------------------------------------------------------------------------------------------*/

/* Tale funzione genera casualmente, tra gli utenti attivi da almeno 50000 trame e che non sono
   in HO, i numeri degli utenti che terminano la comunicazione e liberano la loro sottoportante
   (e quella del loro "compagno"). Gli utenti che terminano la comunicazione vengono segnati 
   nel vettore Termina_comunicazione[NMAX] (variabile locale) */ 

void Decidi_Utenti_In_Questa_Trama (int *Termina_comunicazione)                                                       
{
	int i, j=0;
	int valore = 10000;
	float x;

    for (i=0; i<NMAX; i++)
	{
		if ((status[i].utente_attivo == ATTIVO) && (status[i].in_HO == NO)
			&& (status[i].HO_STEP == NESSUNO) && (status[i].Conta_trame_di_attivita >= LIMITE))
		{
			x = (((float) rand()/(float) RAND_MAX) * valore);
			j = x < 0.25 ? SI : NO;					
 
            Termina_comunicazione[i] = j;  				

		}
	}
	
	for (i=0; i<NMAX; i++)
	{
		if (Termina_comunicazione[i] == SI)      /* variabile globale */
		{
			collegamenti_terminati.spontaneamente ++;  /* aggiunto */
			collegamenti_terminati.in_totale ++;       /* aggiunto */

			j = ((i%2) == 0 ? (i+1) : (i-1));    /* numero di utente con cui  accoppiato 
			                                        l'utente numero i ("compagno") */			
	        Termina_comunicazione[j] = NO;

			Risultati[i].Comunicazione_terminata_spontaneamente = SI;
			Risultati[j].Comunicazione_terminata_spontaneamente = SI;
			
			Risultati[i].Comunicazione_terminata = SI;
			Risultati[j].Comunicazione_terminata = SI;

#ifdef DEBUG

			printf("\n\nTrama %d: l'utente numero %d, appartenente alla BS numero %d, ",
				   frame, i, status[i].MyServBS );
			printf("ha deciso\n\t  di terminare la comunicazione");
			
#endif
		}
	}
}


/*-------------------------------------------------------------------------------------------*/

/* Tale funzione viene chiamata al termine di ogni trama e serve per aggiornare i contatori */

void Aggiorna_contatori (int dim)                       
{
	int i;

	for (i=0; i<dim; i++)	
		if(status[i].utente_attivo == ATTIVO)
		{
			status[i].Conta_trame_di_attivita ++;
			Risultati[i].durata_comunicazione ++;
		}
}

/*-------------------------------------------------------------------------------------------*/


/* Tale funzione serve per svuotare il buffer di ricezione associato nella BS numero bs 
   all'utente che utilizza la sottoportante numero carrier */

int Svuota_BufRic (int bs, int carrier)                
{
	struct el_buff *puntapp, *da_eliminare;

	if (carrier == NO_USER)
	{ 
		printf ("\n\nERRORE: esiste una sottoportante pari a NO_USER");
		getchar();
	}
	
	if ((BaseStation[bs].BufRic[carrier].buf != NULL) && (carrier != NO_USER))
	{
		puntapp = BaseStation[bs].BufRic[carrier].buf;
		
		while (puntapp != NULL)
		{
			da_eliminare = puntapp;                           
	        puntapp = puntapp->next;           
	        free (da_eliminare);
		}

        BaseStation[bs].BufRic[carrier].buf = NULL;
        BaseStation[bs].BufRic[carrier].lenght = 0;
		return 1;

	}
	else if (BaseStation[bs].BufRic[carrier].buf == NULL)
		return 1;

	return 0;
}


/*-------------------------------------------------------------------------------------------*/


/* tale funzione inizializza il profilo di utente relativo alla sottoportante numero carrier 
   della BS numero bs */ 

void Inizializza_Profilo (int bs, int carrier)          
{
	BaseStation[bs].table[carrier].assigned=0;
    BaseStation[bs].table[carrier].inf=0;
    BaseStation[bs].table[carrier].sign=0;
    BaseStation[bs].table[carrier].activity=0;
    BaseStation[bs].table[carrier].new_entry=0;
    BaseStation[bs].table[carrier].pack_lost=0;
    BaseStation[bs].table[carrier].pack_lost_x_HO=0;
    BaseStation[bs].table[carrier].kind= NO_KIND;
    BaseStation[bs].table[carrier].SubCarrierOf=NO_USER;
    BaseStation[bs].table[carrier].sent=0;
    BaseStation[bs].table[carrier].HO_REQ=0;
    BaseStation[bs].table[carrier].stop_trasm=1;    /* trasmissione di downlink bloccata */                 
}


/*-------------------------------------------------------------------------------------------*/


/* tale funzione inizializza alcuni campi della Base Station numero bs relativi alla sua
   sottoportante numero carrier */

void Inizializza_BS (int bs, int carrier)               
{
    BaseStation[bs].sign_vett_i[carrier]=0;                          /* ????? */
	BaseStation[bs].sign_vett_prec_i[carrier]=0;                     /* ????? */
	BaseStation[bs].sign_vett_succ_i[carrier]=0;    
	
    BaseStation[bs].vettsubcfree[carrier] = FREE;  
    BaseStation[bs].newsubcfree = carrier;	

	BaseStation[bs].Sottoportante_abilitata[carrier] = NO;

	BaseStation[bs].Portante_in_SHO[carrier].stato = NO;
	BaseStation[bs].Portante_in_SHO[carrier].utente = NO_USER;
	BaseStation[bs].Portante_in_SHO[carrier].altra_portante = NO_USER;
	BaseStation[bs].Portante_in_SHO[carrier].altra_BS = NO_USER;

    BaseStation[bs].bc_prec_x_Portanti[carrier] = NO_USER;           /* ????? */
    BaseStation[bs].bc_x_Portanti[carrier] = NO_USER;                /* ????? */
    BaseStation[bs].bc_succ_x_Portanti[carrier] = NO_USER;           /* ????? */  

    BaseStation[bs].ChiStaUscendo[carrier] = NO_NEW_DESTINATION_BS;  /* ????? */
}

/*-------------------------------------------------------------------------------------------*/

/* Tale funzione provvede a togliere la sottoportante all'utente numero "compagno" */

void Gestisci_Compagno (int compagno)
{	
	int servBS, altraBS, vecchiaBS, nuovaBS;
	int subcarr, new_subcarr, old_subcarr;
	
    if ((status[compagno].in_HO == NO) && (status[compagno].HO_STEP == NESSUNO) 
		&& (status[compagno].utente_attivo == ATTIVO))	

	{   /* l'utente numero "compagno" non  in HO */
		
		servBS = status[compagno].MyServBS;                           
        subcarr = status[compagno].mySubcarrier[servBS];

		Risultati[compagno].Pacchetti_generati_ma_rimasti_nel_suo_buffer =
				Conta_pacchetti_nel_buffer_di_utente (compagno);  /* agg */
			
	    Risultati[compagno].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez =
				BaseStation[servBS].BufRic[subcarr].lenght; /* agg */		
				

        /* svuotamento del buffer di ricezione associato all'utente numero "compagno" nella BS
		   numero servBS */         
		
		if (Svuota_BufRic (servBS, subcarr) == 0)
		{
			printf ("\n\nNon e' stato svuotato il buffer di ricezione");
			getchar();
		}		

        /* inizializzazione del profilo di utente relativo alla sottoportante numero subcarr 
		   della BS numero servBS */ 

        Inizializza_Profilo (servBS, subcarr);
        
		BaseStation[servBS].tableMS.one_link --;

        Inizializza_BS (servBS, subcarr);
				
	    status[compagno].utente_attivo = NON_ATTIVO;
		status[compagno].Comunicazione = DISATTIVATA;
		status[compagno].abilitato_al_passo = NESSUNO;

		status[compagno].NumOfLinks = 0;                   /* aggiunto */
		status[compagno].quality_state[servBS] = NO_LINK;  /* aggiunto */
		status[compagno].mySubcarrier[servBS] = NO_USER;   /* aggiunto */

#ifdef DEBUG

		Messaggio_Liberazione (frame, servBS, subcarr, compagno);
		
#endif

	}
	
	else    
	{
		if ((status[compagno].in_HO == NO) && (status[compagno].HO_STEP == 5) 
			&& (status[compagno].utente_attivo == ATTIVO))

		{   /* HO_STEP_5 (l'utente "compagno" ha terminato il passo 5) */
			
			nuovaBS = status[compagno].MyServBS;       
            vecchiaBS = Vecchia_BS[compagno];                    /* variabile globale */
					
	        new_subcarr = status[compagno].mySubcarrier[nuovaBS];
            old_subcarr = Vecchia_Sottoportante[compagno];       /* variabile globale */

			Risultati[compagno].Passo_di_HO_in_cui_ha_terminato_la_comunicazione = 5;

			Risultati[compagno].Pacchetti_generati_ma_rimasti_nel_suo_buffer =
				Conta_pacchetti_nel_buffer_di_utente (compagno);   /* agg */
			
	        Risultati[compagno].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez =
		 		Pacchetti_in_BS_vecchia[compagno];   /* agg */

		//	Risultati[compagno].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez +=
		//		BaseStation[nuovaBS].BufRic[new_subcarr].lenght; /* agg */			

			/* svuotamento del buffer di ricezione dell'utente numero "compagno" nella BS
			   numero vecchiaBS */

			if (Svuota_BufRic (vecchiaBS, old_subcarr) == 0)                 /* aggiunto */
			{
				printf ("\n\nNon e' stato svuotato il buffer di ricezione");
				getchar();
			}			

            /* inizializzazione del profilo di utente relativo alla sottoportante numero
			   old_subcarr della BS numero vecchiaBS */ 

            Inizializza_Profilo (vecchiaBS, old_subcarr);             

            Inizializza_BS (vecchiaBS, old_subcarr);

			/* svuotamento del buffer di ricezione dell'utente numero "compagno" nella BS
			   numero nuovaBS */

			if (Svuota_BufRic (nuovaBS, new_subcarr) == 0)                 /* aggiunto */
			{
				printf ("\n\nNon e' stato svuotato il buffer di ricezione");
				getchar();
			}

            /* inizializzazione del profilo di utente relativo alla sottoportante numero 
			   new_subcarr della BS numero nuovaBS */ 

            Inizializza_Profilo (nuovaBS, new_subcarr);
					
			BaseStation[nuovaBS].tableMS.one_link --;

            Inizializza_BS (nuovaBS, new_subcarr);             
	    
            status[compagno].myNextSubcarrier[nuovaBS] = NO_USER;    /* ?? */ 

		    status[compagno].utente_attivo = NON_ATTIVO;
			status[compagno].Comunicazione = DISATTIVATA;
			status[compagno].abilitato_al_passo = NESSUNO;
            
			status[compagno].NumOfLinks = 0;                      /* aggiunto */
		    status[compagno].quality_state[nuovaBS] = NO_LINK;    /* aggiunto */
		    status[compagno].mySubcarrier[nuovaBS] = NO_USER;     /* aggiunto */
			
#ifdef DEBUG

			Messaggio_Liberazione (frame, nuovaBS, new_subcarr, compagno);

#endif
			
		}
	}
		
	/* l'utente numero "compagno" sta per iniziare l'HO oppure  in HO ( in uno dei primi 4
	   passi di HO). Se l'utente numero "compagno"  in HO_STEP_i, vuol dire che esso ha
	   terminato l'HO_STEP_i ma non ha ancora iniziato il successivo passo di HO */
	
	if ((status[compagno].in_HO == SI) && (status[compagno].utente_attivo == ATTIVO))  /* A */
	{
		
		if (status[compagno].HO_STEP == 1)							
					
		{   /* HO_STEP_1 (l'utente "compagno" ha terminato il passo 1) */
			
			servBS = status[compagno].MyServBS;
            subcarr = status[compagno].mySubcarrier[servBS];    
            altraBS = (servBS == 0 ? (1) : (0)); 

			Risultati[compagno].Passo_di_HO_in_cui_ha_terminato_la_comunicazione = 1;

			Risultati[compagno].Pacchetti_generati_ma_rimasti_nel_suo_buffer =
				Conta_pacchetti_nel_buffer_di_utente (compagno);  /* agg */
			
	        Risultati[compagno].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez =
				BaseStation[servBS].BufRic[subcarr].lenght; /* agg */			

            /* svuotamento del buffer di ricezione associato all'utente numero "compagno" nella
               BS numero servBS */            
			
			if (Svuota_BufRic (servBS, subcarr) == 0)
			{
				printf ("\n\nNon e' stato svuotato il buffer di ricezione");
				getchar();
			}			
         
            /* inizializzazione del profilo di utente relativo alla sottoportante numero 
			   subcarr della BS numero servBS */ 

            Inizializza_Profilo (servBS, subcarr);

            BaseStation[servBS].tableMS.one_link --;
					
		    Inizializza_BS (servBS, subcarr); 

            BaseStation[servBS].succ_profile_req[altraBS] --;
					
			status[compagno].utente_attivo = NON_ATTIVO;
		    status[compagno].Comunicazione = DISATTIVATA;
			status[compagno].abilitato_al_passo = NESSUNO;
            
			status[compagno].NumOfLinks = 0;                   /* aggiunto */
		    status[compagno].quality_state[servBS] = NO_LINK;  /* aggiunto */
		    status[compagno].mySubcarrier[servBS] = NO_USER;   /* aggiunto */
			
#ifdef DEBUG

			Messaggio_Liberazione (frame, servBS, subcarr, compagno);

#endif

		}
		
		if (((status[compagno].HO_STEP == 21) || (status[compagno].HO_STEP == 22))
			&& (HO_Fallito[compagno] == NO))

		{   /* l'utente numero "compagno"  in HO_STEP_2 e non ha fallito l'HO (l'utente
			   "compagno" ha terminato il passo 2 e non ha fallito l'HO) */
			
			servBS = status[compagno].MyServBS;
            subcarr = status[compagno].mySubcarrier[servBS];

            altraBS = (servBS == 0 ? (1) : (0));

            new_subcarr = Nuova_Sottoportante[compagno];

			Risultati[compagno].Passo_di_HO_in_cui_ha_terminato_la_comunicazione = 2;

			Risultati[compagno].Pacchetti_generati_ma_rimasti_nel_suo_buffer =
				Conta_pacchetti_nel_buffer_di_utente (compagno);  /* agg */
			
	        Risultati[compagno].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez =
				BaseStation[servBS].BufRic[subcarr].lenght; /* agg */			

            /* svuotamento del buffer di ricezione associato all'utente numero "compagno" nella
               BS numero servBS */            
			
			if (Svuota_BufRic (servBS, subcarr) == 0)
			{
				printf ("\n\nNon e' stato svuotato il buffer di ricezione");
				getchar();
			}			

            /* inizializzazione del profilo di utente relativo alla sottoportante numero 
			   subcarr della BS numero servBS */ 

            Inizializza_Profilo (servBS, subcarr);
    
            BaseStation[servBS].tableMS.one_link --;

            Inizializza_BS (servBS, subcarr); 

            /* inizializzazione del profilo di utente relativo alla sottoportante numero
			   new_subcarr della BS numero altraBS */ 

            Inizializza_Profilo (altraBS, new_subcarr); 
   
            Inizializza_BS (altraBS, new_subcarr); 

            if(status[compagno].HO_STEP == 21)
				BaseStation[altraBS].bc_x_Portanti[new_subcarr] = NO_USER;

            if(status[compagno].HO_STEP == 22)
				BaseStation[altraBS].bc_succ_x_Portanti[new_subcarr] = NO_USER;
					
		    status[compagno].utente_attivo = NON_ATTIVO;
		    status[compagno].Comunicazione = DISATTIVATA;
			status[compagno].abilitato_al_passo = NESSUNO; 
			
			status[compagno].NumOfLinks = 0;                    /* aggiunto */
		    status[compagno].quality_state[servBS] = NO_LINK;   /* aggiunto */
		    status[compagno].mySubcarrier[servBS] = NO_USER;    /* aggiunto */
			
#ifdef DEBUG
			
			Messaggio_Liberazione (frame, servBS, subcarr, compagno);

#endif

		}
			
	    if (status[compagno].HO_STEP == 3)  
					
		{   /* HO_STEP_3 (l'utente "compagno" ha terminato il passo 3) */
			
			nuovaBS = status[compagno].MyServBS;
            vecchiaBS = status[compagno].MyOldBS;

            new_subcarr = status[compagno].myNextSubcarrier[nuovaBS];
            old_subcarr = status[compagno].mySubcarrier[vecchiaBS];

			Risultati[compagno].Passo_di_HO_in_cui_ha_terminato_la_comunicazione = 3;

			Risultati[compagno].Pacchetti_generati_ma_rimasti_nel_suo_buffer =
				Conta_pacchetti_nel_buffer_di_utente (compagno);   /* agg */
			
	        Risultati[compagno].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez =
				Pacchetti_in_BS_vecchia[compagno]; /* agg */
			
		//	Risultati[compagno].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez +=
		//		BaseStation[nuovaBS].BufRic[new_subcarr].lenght; /* agg */	

            /* svuotamento del buffer di ricezione associato all'utente numero "compagno" nella
			   BS numero vecchiaBS */             

			if (Svuota_BufRic (vecchiaBS, old_subcarr) == 0)
			{
				printf ("\n\nNon e' stato svuotato il buffer di ricezione");
				getchar();
			}
			
			/* svuotamento del buffer di ricezione associato all'utente numero "compagno" nella
			   BS numero nuovaBS */             

			if (Svuota_BufRic (nuovaBS, new_subcarr) == 0)
			{
				printf ("\n\nNon e' stato svuotato il buffer di ricezione");
				getchar();
			}	

            /* inizializzazione del profilo di utente relativo alla sottoportante numero 
			   old_subcarr della BS numero vecchiaBS */ 

            Inizializza_Profilo (vecchiaBS, old_subcarr);

            BaseStation[vecchiaBS].tableMS.one_link --;

            Inizializza_BS (vecchiaBS, old_subcarr);

            /* inizializzazione del profilo di utente relativo alla sottoportante numero
			   new_subcarr della BS numero nuovaBS */ 

            Inizializza_Profilo (nuovaBS, new_subcarr);

            Inizializza_BS (nuovaBS, new_subcarr);

            status[compagno].NumOfHO --;
            status[compagno].myNextSubcarrier[nuovaBS] = NO_USER;    /* ??  */ 
					
			status[compagno].utente_attivo = NON_ATTIVO;
		    status[compagno].Comunicazione = DISATTIVATA;
			status[compagno].abilitato_al_passo = NESSUNO;
            
			status[compagno].NumOfLinks = 0;                       /* aggiunto */
		    status[compagno].quality_state[vecchiaBS] = NO_LINK;   /* aggiunto */
		    status[compagno].mySubcarrier[vecchiaBS] = NO_USER;    /* aggiunto */
			
#ifdef DEBUG

			Messaggio_Liberazione (frame, vecchiaBS, old_subcarr, compagno);

			printf ("\n\nTrama %d: nella BS numero %d viene resa di nuovo disponibile la sottoportante numero %d",
				    frame, nuovaBS, new_subcarr);

#endif
		}
		
		if (status[compagno].HO_STEP == 4) 

		{   /* HO_STEP_4 (l'utente "compagno" ha terminato il passo 4) */
			
			nuovaBS = status[compagno].MyServBS;
            vecchiaBS = status[compagno].MyOldBS;

            new_subcarr = status[compagno].mySubcarrier[nuovaBS];
            old_subcarr = status[compagno].mySubcarrier[vecchiaBS]; 

			Risultati[compagno].Passo_di_HO_in_cui_ha_terminato_la_comunicazione = 4;

			Risultati[compagno].Pacchetti_generati_ma_rimasti_nel_suo_buffer =
				Conta_pacchetti_nel_buffer_di_utente (compagno);   /* agg */
			
	        Risultati[compagno].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez =
				Pacchetti_in_BS_vecchia[compagno];   /* agg */			

		//	Risultati[compagno].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez +=
		//		BaseStation[nuovaBS].BufRic[new_subcarr].lenght; /* agg */				

            /* svuotamento del buffer di ricezione associato all'utente numero "compagno" nella
			   BS numero vecchiaBS */             

			if (Svuota_BufRic (vecchiaBS, old_subcarr) == 0)
			{
				printf ("\n\nNon e' stato svuotato il buffer di ricezione");
				getchar();
			}
			
			/* svuotamento del buffer di ricezione associato all'utente numero "compagno" nella
			   BS numero nuovaBS */             

			if (Svuota_BufRic (nuovaBS, new_subcarr) == 0)
			{
				printf ("\n\nNon e' stato svuotato il buffer di ricezione");
				getchar();
			}	

            /* inizializzazione del profilo di utente relativo alla sottoportante numero
			   old_subcarr della BS numero vecchiaBS */ 

            Inizializza_Profilo (vecchiaBS, old_subcarr);

            BaseStation[vecchiaBS].tableMS.two_links_Old --;

            Inizializza_BS (vecchiaBS, old_subcarr);

            /* inizializzazione del profilo di utente relativo alla sottoportante numero
			   new_subcarr della BS numero nuovaBS */ 

            Inizializza_Profilo (nuovaBS, new_subcarr);

	        BaseStation[nuovaBS].tableMS.two_links_New --;

            Inizializza_BS (nuovaBS, new_subcarr);

            status[compagno].NumOfHO --;
            status[compagno].myNextSubcarrier[nuovaBS] = NO_USER;   /* ?? */ 
					
			status[compagno].utente_attivo = NON_ATTIVO;
		    status[compagno].Comunicazione = DISATTIVATA;
			status[compagno].abilitato_al_passo = NESSUNO; 
			
			status[compagno].NumOfLinks = 0;                      /* aggiunto */
		    status[compagno].quality_state[vecchiaBS] = NO_LINK;  /* aggiunto */
		    status[compagno].mySubcarrier[vecchiaBS] = NO_USER;   /* aggiunto */

			status[compagno].quality_state[nuovaBS] = NO_LINK;    /* aggiunto */
		    status[compagno].mySubcarrier[nuovaBS] = NO_USER;     /* aggiunto */
			
#ifdef DEBUG

			Messaggio_Liberazione (frame, vecchiaBS, old_subcarr, compagno);

			Messaggio_Liberazione (frame, nuovaBS, new_subcarr, compagno);

#endif

		}

    }     /* fine if A */

}


/*-------------------------------------------------------------------------------------------*/


/* Tale funzione, in base ai dati contenuti nel vettore "Termina_comunicazione[NMAX]", provvede
   a liberare le sottoportanti degli utenti che hanno terminato la comunicazione */

void Libera_Sottoportanti (int *Termina_comunicazione)                            
{
	int i, j=0;
	int clust; 
	int subcarr; 
	
	for (i=0; i<NMAX; i++)               /* inizio ciclo for su i */
	{
		if ((Termina_comunicazione[i] == SI) && (status[i].utente_attivo == ATTIVO))
			   
       /* Termina_comunicazione[NMAX]  una variabile locale alla funzione 
	      "Procedura_di_fine_Comunicazione_e_Liberazione_Sottoportante ()" */ 

       /* l'utente numero i non  in HO ed  attivo da almeno 50000 trame, pertanto posso 
	      togliergli la sottoportante e poi la tolgo anche al "compagno". Entrambi gli utenti
		  non potranno pi richiedere una sottoportante (ci  reso possibile dal valore
		  "DISATTIVATA" del campo "Comunicazione" e dal valore "NESSUNO" del campo
		  "abilitato_al_passo") */

		{
			clust = status[i].MyServBS;         
            subcarr = status[i].mySubcarrier[clust];

            status[i].abilitato_al_passo = NESSUNO;
			status[i].utente_attivo = NON_ATTIVO;
			status[i].Comunicazione = DISATTIVATA;  /* l'utente numero i non pu pi richiedere
													   una sottoportante */		

			status[i].NumOfLinks = 0;                      /* aggiunto */
			status[i].quality_state[clust] = NO_LINK;      /* aggiunto */
			status[i].mySubcarrier[clust] = NO_USER;       /* aggiunto */			

			Risultati[i].Pacchetti_generati_ma_rimasti_nel_suo_buffer =
				Conta_pacchetti_nel_buffer_di_utente (i);  /* agg */
			
	        Risultati[i].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez =
				BaseStation[clust].BufRic[subcarr].lenght; /* agg */			
  
            /* svuotamento del buffer di ricezione associato all'utente numero i nella BS
			   numero clust */

            if (Svuota_BufRic (clust, subcarr) == 0)
			{
				printf ("\n\nNon e' stato svuotato il buffer di ricezione");
				getchar();
			}			
   
            /* inizializzazione del profilo di utente relativo alla sottoportante numero
			   subcarr della BS numero clust */ 

            Inizializza_Profilo (clust, subcarr);
  
            BaseStation[clust].tableMS.one_link --;

            Inizializza_BS (clust, subcarr);
			
#ifdef DEBUG

			Messaggio_Liberazione (frame, clust, subcarr, i);
#endif

   			/* gestione dell'utente numero j (utente accoppiato all'utente numero i) */   

            j = ((i%2) == 0 ? (i+1) : (i-1));    /* numero di utente con cui  accoppiato 
                                                    l'utente i (utente "compagno") */ 
			
			Gestisci_Compagno (j);   /* viene tolta la sottoportante (o le sottoportanti)
									    all'utente "compagno" dell'utente numero i */

            
		}  /* fine if */		

	}  /* fine ciclo for su i */

}
 

/*-------------------------------------------------------------------------------------------*/


/* Tale funzione stabilisce quali sono gli utenti attivi non in HO che desiderano terminare la
   loro comunicazione. Le sottoportanti di tali utenti e dei loro "compagni" vengono poi
   liberate, cio vengono poste nel gruppo delle sottoportanti disponibili. Osserviamo che un
   utente che abbia terminato una comunicazione, non potr pi richiedere una sottoportante
   (ci per dare la possibilit a tutti gli utenti di effettuare una comunicazione). Tale
   funzione  chiamata a fine trama (prima degli aggiornamenti) */

void Procedura_di_fine_Comunicazione_e_Liberazione_Sottoportante ()
{
	int i;
	int Termina_comunicazione[NMAX];           /* variabile locale */

	for (i=0; i<NMAX; i++)
		Termina_comunicazione[i] = NO;        /* inizializzo a "NO" le componenti */	 

	Decidi_Utenti_In_Questa_Trama (Termina_comunicazione);     /* vengono decisi gli utenti
															      attivi e non in HO che 
										                          intendono interrompere la 
	                                                              comunicazione */

	/* agli utenti che hanno deciso di interrompere la comunicazione e ai loro "compagni", 
	   vengono tolte le sottoportanti di segnalazione. Tali sottoportanti vengono, quindi,
	   liberate. Forse, invece di inizializzare tutti i campi,  sufficiente fare le seguenti 
	   assegnazioni:	                              
	                              status[i].utente_attivo = NON_ATTIVO;
                                  status[i].Comunicazione = DISATTIVATA;
								  BaseStation[].vettsubcfree[] = FREE;
	                              BaseStation[].Sottoportante_abilitata[] = NO; */

	Libera_Sottoportanti (Termina_comunicazione); 
}


/*-------------------------------------------------------------------------------------------*/

/* Tale funzione toglie la sottoportante di un utente che, giunto al passo 2 della procedura di
   HO, non ha trovato una sottoportante disponibile nella BS di destinazione */

void Gestisci_Utente_che_ha_fallito_HO (int utente, int bs, int subcarr)
{
	Risultati[utente].Pacchetti_generati_ma_rimasti_nel_suo_buffer =
				Conta_pacchetti_nel_buffer_di_utente (utente);  /* agg */
			
	Risultati[utente].Pacchetti_ad_esso_diretti_ma_rimasti_nei_buffer_di_ricez =
				BaseStation[bs].BufRic[subcarr].lenght; /* agg */

    Risultati[utente].Passo_di_HO_in_cui_ha_terminato_la_comunicazione = 2;
	Risultati[utente].Comunicazione_terminata_x_HO_fallito = SI; /* aggiunto */
	Risultati[utente].Comunicazione_terminata = SI;
	
	collegamenti_terminati.x_HO_fallito ++;  /* aggiunto */
	collegamenti_terminati.in_totale ++;     /* aggiunto */

    /* svuotamento del buffer di ricezione associato all'utente numero "utente" nella BS
	   numero bs (BS di origine) */
	
	if (Svuota_BufRic (bs, subcarr) == 0)
	{
		printf ("\n\nNon e' stato svuotato il buffer di ricezione");
		getchar();
	}	

    /* inizializzazione del profilo di utente relativo alla sottoportante numero subcarr della
	   BS numero bs (BS di origine) */ 

    Inizializza_Profilo (bs, subcarr);        

    BaseStation[bs].tableMS.one_link --;

    Inizializza_BS (bs, subcarr);
	
	status[utente].HO_Falliti ++;
	status[utente].NewBS = NO_NEW_DESTINATION_BS;
						
	status[utente].utente_attivo = NON_ATTIVO;
	status[utente].Comunicazione = DISATTIVATA;
	status[utente].abilitato_al_passo = NESSUNO;

	status[utente].NumOfLinks = 0;                      /* aggiunto */
	status[utente].quality_state[bs] = NO_LINK;         /* aggiunto */
	status[utente].mySubcarrier[bs] = NO_USER;          /* aggiunto */ 
	
#ifdef DEBUG

	printf ("\n\nTrama %d: nella BS numero %d e' stata tolta la sottoportante numero %d\n all'utente numero %d in quanto esso ha fallito un HO",
		    frame, bs, subcarr, utente);

#endif
	
}


/*-------------------------------------------------------------------------------------------*/


/* Tale funzione, chiamata durante "CalcBroadCastCell_x_Downlink", cerca un utente di tipo dati
   all'interno di una Base Station e, se lo trova, restituisce il numero di sottoportante a cui
   tale utente  associato (se non trova nessun utente dati, restituisce il valore -1) */


int CercaUtenteDati(struct tab_bs table[], int indicesottoportante, int bs)        

{
	int contatore = 0;	

	while (contatore != NCARRIER)
	{
		indicesottoportante++;

		indicesottoportante = (indicesottoportante % NCARRIER);    /* non appena la variabile
																      "indicesottoportante"
																	  diventa pari ad NCARRIER
																	  essa viene posta a 0 
																	  (ci garantisce la
																	  circolarit) */

		if (((table[indicesottoportante].kind == DATA64KBPS) || 
			(table[indicesottoportante].kind == DATA512KBPS)) 
			&& (BaseStation[bs].Sottoportante_abilitata[indicesottoportante] == SI))
			
			return (indicesottoportante);

		contatore++;																		    
	}	

	return (-1);
}


/*-------------------------------------------------------------------------------------------*/

void init_UtentiPresenti (struct UtentiPresenti *utenti)  
{
	utenti->Video = ASSENTI;
	utenti->Voce = ASSENTI;
	utenti->Dati64KBPS = ASSENTI;
	utenti->Dati2048KBPS = ASSENTI;	
}


/*-------------------------------------------------------------------------------------------*/


/* Tale funzione, chiamata durante "CalcBroadCastCell_x_Downlink", cerca un utente di tipo
   video all'interno di una Base Station e, se lo trova, restituisce il numero di sottoportante
   a cui tale utente  associato (se non trova nessun utente video allora restituisce il valore
   -1) */

int CercaUtenteVideo(struct tab_bs table[], int indicesottoportante, int bs)     

{
	int contatore = 0;	

	while (contatore != NCARRIER)
	{
		indicesottoportante ++;

		indicesottoportante = (indicesottoportante % NCARRIER);    /* non appena la variabile
																      "indicesottoportante"
																	  diventa pari ad NCARRIER
																	  essa viene posta a 0 
																	  (ci garantisce la
																	  circolarit) */

		if ((table[indicesottoportante].kind == VIDEO1MBPS) 
			&& (BaseStation[bs].Sottoportante_abilitata[indicesottoportante] == SI))			
			
			return (indicesottoportante);

		contatore ++;																		    
	}	

	return (-1);
}


/*-------------------------------------------------------------------------------------------*/


/* Tale funzione, chiamata durante "CalcBroadCastCell_x_Downlink", cerca un utente di tipo
   video o di tipo voce all'interno di una Base Station e, se lo trova, restituisce il numero
   di sottoportante a cui tale utente  associato (se non trova nessun utente video e nessun
   utente voce, allora restituisce il valore -1) */


int CercaUtenteVideoVoce (struct tab_bs table[], int indicesottoportante, int bs) 
{
	int contatore = 0;	

	while (contatore != NCARRIER)
	{
		indicesottoportante ++;

		indicesottoportante = (indicesottoportante % NCARRIER);    /* non appena la variabile
																      "indicesottoportante"
																	  diventa pari ad NCARRIER
																	  essa viene posta a 0 
																	  (ci garantisce la
																	  circolarit) */

		if (((table[indicesottoportante].kind == VIDEO1MBPS) || 
			(table[indicesottoportante].kind == VOICE)) &&
			(BaseStation[bs].Sottoportante_abilitata[indicesottoportante] == SI))
			
			return (indicesottoportante);

		contatore ++;																		    
	}	

	return (-1);
}

/*-------------------------------------------------------------------------------------------*/

/* Tale funzione restituisce il numero dell'utente che attende da pi tempo l'assegnazione di
   una sottoportante di segnalazione (se ci sono utenti che attendono dallo stesso numero di
   trame, viene restituito il numero di utente pi elevato) */

int utente_con_tempo_di_attesa_max ()
{
	int i;
	int tempo_di_attesa_max = 0;
	int utente_potenziale = -1;

	for (i=0; i<NMAX; i++)
	{
		/* tra tutti gli utenti richiedenti che si trovano al QUARTO passo, si cerca quello
		   che si trova in tale passo da pi trame */

		if ((status[i].abilitato_al_passo == QUARTO) 
			&& (status[i].Conta_trame_di_attesa >= tempo_di_attesa_max) 
			&& (Utente_soddisfatto[i] == NO)
			&& (frame == (status[i].trama_di_abilitazione + 1)))
		{
			tempo_di_attesa_max = status[i].Conta_trame_di_attesa;

			utente_potenziale = i;
		}
	}
	
	Utente_soddisfatto[utente_potenziale] = SI;   /* l'utente viene marcato */

	return (utente_potenziale);
}

/*-------------------------------------------------------------------------------------------*/

/* Tale funzione calcola e restituisce il numero della sottoportante "prima libera" nella BS
   numero bs (se in tale BS tutte le sottoportanti sono occupate allora la funzione restituisce
   il valore NCARRIER) */

int Calcola_prima_libera (int bs)
{
	int i;
	int prima_libera = NCARRIER;
	

	/* questo ciclo for individua la nuova sottoportante libera nella BS numero bs */

	BaseStation[bs].newsubcfree = NCARRIER;

	for (i=0; i<NCARRIER; i++)
	{
		if (BaseStation[bs].vettsubcfree[i] == FREE)           /* sottoportante libera */

			if (BaseStation[bs].table[i].SubCarrierOf == NO_USER)    /* non assegnata ad un 
																	    utente in HO */				
			{
				prima_libera = i;
				// break;

				i = NCARRIER;         /* uscita anticipata dal ciclo for */
			}
	}
	
#ifdef DEBUG

	if (prima_libera == NCARRIER)     /* nella BS numero bs non  stata trovata nessuna
		                                 sottoportante libera */
	{
		printf("\n\nQUARTO PASSO");

		printf("\nTrama numero %d: nessuna sottoportante e' disponibile per la BS %d\n", 
		        frame, bs);
	}

#endif

	return (prima_libera);
}


/*-------------------------------------------------------------------------------------------*/

/* tale funzione assegna all'utente numero "utente_i" la sottoportante numero "car_i" della BS
   numero "BS_i" (osserviamo per che l'utente rimane non attivo e la sottoportante rimane
   disabilitata) */

void Assegna_Sottoportanti (int utente_i, int BS_i, int car_i)
							
{

#ifdef DEBUG

	printf ("\n\nTrama %d: QUARTO PASSO", frame); 
	printf ("\nNella BS numero %d e' stata assegnata all'utente %d la sottoportante %d",
		      BS_i, utente_i, car_i);
	getchar();

#endif

	BaseStation[BS_i].tableMS.one_link ++;	

//	BaseStation[BS_i].bc_prec_x_Portanti[car_i] = NO_USER;
//	BaseStation[BS_i].bc_x_Portanti[car_i] = NO_USER;
//	BaseStation[BS_i].bc_succ_x_Portanti[car_i] = NO_USER;	

    BaseStation[BS_i].sign_vett_prec_i[car_i] = 0;
	BaseStation[BS_i].sign_vett_i[car_i] = 0;
	BaseStation[BS_i].sign_vett_succ_i[car_i] = 0;	

	BaseStation[BS_i].vettsubcfree[car_i] = NOT_FREE;
	
	BaseStation[BS_i].ChiStaUscendo[car_i] = NO_NEW_DESTINATION_BS;
	
    BaseStation[BS_i].table[car_i].stop_trasm = 0;  /* trasmissione di downlink abilitata */
	BaseStation[BS_i].table[car_i].HO_REQ = 0;
	BaseStation[BS_i].table[car_i].assigned = 0;
	BaseStation[BS_i].table[car_i].inf = 0;
	BaseStation[BS_i].table[car_i].sign = 0;
	BaseStation[BS_i].table[car_i].activity = 0;
	BaseStation[BS_i].table[car_i].new_entry = 0;
	BaseStation[BS_i].table[car_i].sent = 0;          
	BaseStation[BS_i].table[car_i].pack_lost = 0;     
	BaseStation[BS_i].table[car_i].pack_lost_x_HO = 0;

    BaseStation[BS_i].table[car_i].SubCarrierOf = utente_i;
	BaseStation[BS_i].table[car_i].kind = status[utente_i].kind_of_service;

	BaseStation[BS_i].newsubcfree = Calcola_prima_libera (BS_i);	

	Svuota_BufRic (BS_i, car_i);

	status[utente_i].asse = 1;
	status[utente_i].NumOfLinks = 1;
	status[utente_i].quality_state [BS_i] = 1;
	status[utente_i].mySubcarrier[BS_i] = car_i;
}


/*-------------------------------------------------------------------------------------------*/

void Inizializza_Vettori (int *Mini_Slot, int *Richiesta_Sottoportante,
						  int *Utente_con_collisione)
{
	int i;

	for (i=0; i<NMAX; i++)
	{
		Mini_Slot[i] = NO_VALIDO;
		Richiesta_Sottoportante[i] = NO;
		Utente_con_collisione[i] = NO;
	}
}

/*-------------------------------------------------------------------------------------------*/

void Decidi_Richieste_In_Questa_Trama (int *Richiesta_Sottoportante) /* PRIMO PASSO: trama i */
                                                                          
{
	int i,j ;
	int intervallo = 10000;
	float x;
	
	for (i=0; i<NMAX; i++)
	{
		if ((status[i].utente_attivo == NON_ATTIVO) &&
			(status[i].Comunicazione != DISATTIVATA) &&
			(status[i].abilitato_al_passo == PRIMO)) 		
		{
			if (i%2 != 0)
				if (Richiesta_Sottoportante[i-1] == SI)
					continue;

			x = (((float) rand()/(float) RAND_MAX) * intervallo);

			Richiesta_Sottoportante[i] = x <= 0.15 ? SI : NO;			
            
			if (Richiesta_Sottoportante[i] == SI)
			{
				Numero_totale_di_richieste ++;                      /* aggiunto */

				Risultati[i].Utente_richiedente_con_successo = SI;  /* aggiunto */

				status[i].abilitato_al_passo = SECONDO;
#ifdef DEBUG

				printf ("\n\nTrama %d: PRIMO PASSO", frame);

				printf ("\nL'utente numero %d appartenente alla BS numero %d ", i,
					     status[i].MyServBS);
				printf ("ha fatto richiesta di\nsottoportante");
				getchar();
#endif
		
				j = (i%2 == 0) ? (i+1) : (i-1);

                Richiesta_Sottoportante[j] = NO;

				status[j].abilitato_al_passo = NESSUNO;

				Risultati[j].Utente_richiedente_con_successo = NO;  /* aggiunto */
			}
		}
	}
}

/*-------------------------------------------------------------------------------------------*/

void Decidi_Minislot (int *Mini_Slot)                      /* SECONDO PASSO: trama i */
{
	int i;
	int fvalue;

	for (i=0; i<NMAX; i++)
	{
		if (status[i].abilitato_al_passo == SECONDO)
		{
			fvalue = (int) (((float) rand() / (float) RAND_MAX) * 19);  /* generazione di un
																		   numero compreso tra
																		   0 e 19 */		
			Mini_Slot[i] = fvalue;
			status[i].abilitato_al_passo = TERZO;

#ifdef DEBUG

			printf ("\n\nTrama %d: SECONDO PASSO", frame);
			printf ("\nL'utente numero %d trasmette la richiesta nel minislot %d", i, fvalue);
			getchar();
#endif
		}
	}
}

/*-------------------------------------------------------------------------------------------*/

void Verifica_Collisioni (int *Mini_Slot, int *Utente_con_collisione)       /* TERZO PASSO: 
                                                                               trama i */
{
	int i, j, x;
	int BS_di_i, BS_di_j;    

	for (i=0; i<NMAX; i++)
	{
		if (status[i].abilitato_al_passo == TERZO)
		{
			x = Mini_Slot[i];

			BS_di_i = status[i].MyServBS;

			for (j=0; j<NMAX; j++)
			{
				BS_di_j = status[j].MyServBS;

				if ((i!=j) && (status[j].abilitato_al_passo == TERZO) &&
					(x == Mini_Slot[j]) && (BS_di_i == BS_di_j))
				{
					Utente_con_collisione[i] = SI;
					Utente_con_collisione[j] = SI;
				}
			}
		}
	}

	for (i=0; i<NMAX; i++)
	{
		if ((status[i].abilitato_al_passo == TERZO) && (Utente_con_collisione[i] == SI))
		{
			status[i].abilitato_al_passo = SECONDO;

#ifdef DEBUG

			printf ("\n\nTrama %d: TERZO PASSO", frame);
			printf ("\nL'utente numero %d ha subito una collisione e quindi viene ", i);
			printf ("riabilitato\nal SECONDO PASSO");
			getchar();
#endif
		}

		else if ((status[i].abilitato_al_passo == TERZO) && (Utente_con_collisione[i] == NO))
		{
			status[i].abilitato_al_passo = QUARTO;
			status[i].trama_di_abilitazione = frame;

#ifdef DEBUG

			printf ("\n\nTrama %d: TERZO PASSO", frame);
			printf ("\nL'utente numero %d non ha subito collisioni e quindi viene ", i);
			printf ("abilitato al\nQUARTO PASSO");
			getchar();
#endif
			
		}
	}
}

/*-------------------------------------------------------------------------------------------*/

/* Tale funzione, eventualmente chiamata durante il QUARTO passo, serve per rimettere nel
   gruppo degli utenti che possono effettuare una richiesta (cio che possono effettuare il
   primo passo) l'utente numero i (ed il suo compagno j). L'utente numero i  un utente che
   era giunto al QUARTO passo e che ha atteso pi di MASSIMA_ATTESA trame (3.6 secondi) */

void Gestisci_utente_che_ha_atteso_troppo (int utente_in_attesa)
{
	int comp;  /* compagno dell'utente numero "utente_in_attesa" */
				
	status[utente_in_attesa].Conta_trame_di_attesa = 0;

	status[utente_in_attesa].abilitato_al_passo = PRIMO;

	Risultati[utente_in_attesa].Utente_richiedente_con_successo = NO;

	Risultati[utente_in_attesa].Richiesta_fallita_x_eccessiva_attesa = SI;

	Risultati[utente_in_attesa].Numero_richieste_fallite_x_eccessiva_attesa ++;

	Numero_totale_di_richieste_fallite_x_eccessiva_attesa ++;

	comp = (utente_in_attesa%2 == 0) ? (utente_in_attesa + 1) : (utente_in_attesa - 1);

	status[comp].abilitato_al_passo = PRIMO;
}

/*-------------------------------------------------------------------------------------------*/

void Gestisci_Richieste ()                   /* QUARTO PASSO: trama i+1 */
{
	int i, j;
	int BS_di_i, BS_di_j;
	int carrier_i, carrier_j;
	int prescelto;	
	int richieste = 0;
    int clust;
	int portanti_libere_in_BS[CLUSTER] = {0,0};

	/* il seguente ciclo for conta il numero di sottoportanti libere nelle due BS */	

	for (clust=0; clust<CLUSTER; clust++)
		portanti_libere_in_BS[clust] = Conta_sottoportanti_libere (clust);
	
	/* il seguente ciclo for conta il numero di utenti che sono in attesa di essere serviti,
	   cio il numero di utenti che hanno fatto richiesta di sottoportante */	
		
    for (i=0; i<NMAX; i++)
		if ((status[i].abilitato_al_passo == QUARTO) && (Utente_soddisfatto[i] == NO)
			&& (frame == (status[i].trama_di_abilitazione + 1)))			

			richieste ++;  /* numero di utenti abilitati al QUARTO passo di tale trama */

	while (((portanti_libere_in_BS[0]>MINIMO) && (portanti_libere_in_BS[1]>MINIMO)) && (richieste>0))
	{
		prescelto = utente_con_tempo_di_attesa_max ();

        if ((status[prescelto].abilitato_al_passo == QUARTO) 
			&& (frame == (status[prescelto].trama_di_abilitazione + 1)))  

			/* la richiesta dell'utente numero i  giunta alla BS servente, cio non ha 
			   subto collisioni */
		{
			BS_di_i = status[prescelto].MyServBS;
			
			/* compagno che sta necessariamente nell'altra BS */
			
			j = (prescelto%2 == 0) ? (prescelto+1) : (prescelto-1);          

			BS_di_j = status[j].MyServBS;

			carrier_i = BaseStation[BS_di_i].newsubcfree;
			carrier_j = BaseStation[BS_di_j].newsubcfree;

			portanti_libere_in_BS[BS_di_i] --;
			portanti_libere_in_BS[BS_di_j] --;

			/* le seguenti funzioni inizializzano sia "BaseStation" sia "state_ps" ma le
			   sottoportanti assegnate rimangono disabilitate e gli utenti rimangono non
			   attivi */

			Assegna_Sottoportanti (prescelto, BS_di_i, carrier_i);
			Assegna_Sottoportanti (j, BS_di_j, carrier_j);
					
			status[prescelto].abilitato_al_passo = ULTIMO;     /* trama i+2 */
            status[prescelto].trama_di_abilitazione = frame;

			Risultati[prescelto].Trame_di_attesa_per_ottenere_sottoportante =
				((status[prescelto].Conta_trame_di_attesa) + 2);

			status[j].abilitato_al_passo = ULTIMO;             /* trama i+2 */
            status[j].trama_di_abilitazione = frame;

			if (status[prescelto].Conta_trame_di_attesa == 0)
				Numero_di_richieste_subito_accolte ++;			

			richieste --;
		}
	}

	/* il seguente ciclo for incrementa di uno il campo "Conta_trame_di_attesa" di quegli
	   utenti che durante l'attuale trama, pur essendo abilitati al QUARTO passo, non sono 
	   stati abilitati all'ULTIMO passo della trama successiva (cio non sono stati 
	   soddisfatti e quindi vengono tenuti o messi in attesa). */

	for (i=0; i<NMAX; i++)
	{
		if((status[i].abilitato_al_passo == QUARTO)
			&& (frame == (status[i].trama_di_abilitazione + 1))
			&& (Utente_soddisfatto[i] == NO))
		{
			status[i].Conta_trame_di_attesa ++;
			status[i].trama_di_abilitazione = frame;

			/* se l'utente numero i sta in coda da pi di MASSIMA_ATTESA trame (3.6 secondi) 
			   allora la sua richiesta viene cancellata e l'utente viene riabilitato al primo
			   passo. Cio la richiesta di sottoportante da parte dell'utente numero i viene
			   considerata fallita */

			if (status[i].Conta_trame_di_attesa > MASSIMA_ATTESA)    /* attesa superiore a 3.6 
				                                                        secondi */			
				Gestisci_utente_che_ha_atteso_troppo (i);
		}			
			
	}
}

/*-------------------------------------------------------------------------------------------*/

void Abilita_Sottoportanti_assegnate ()         /* ULTIMO PASSO: trama i+2 */
{
	int i;
	int BS_di_i;
	int carrier_i;

	for (i=0; i<NMAX; i++)
	{
		if ((status[i].abilitato_al_passo == ULTIMO) 
			&& (frame == (status[i].trama_di_abilitazione + 1)))
		{
			status[i].abilitato_al_passo = NESSUNO;

			BS_di_i = status[i].MyServBS;

            carrier_i = status[i].mySubcarrier[BS_di_i];

			BaseStation[BS_di_i].Sottoportante_abilitata[carrier_i] = SI;

			status[i].utente_attivo = ATTIVO;
			status[i].Comunicazione = ATTIVATA;

			Risultati[i].Comunicazione_iniziata = SI;            /* aggiunto */
			Risultati[i].Trama_di_inizio_comunicazione = frame;  /* aggiunto */
			Risultati[i].durata_comunicazione = 0;               /* aggiunto */

#ifdef DEBUG

			printf ("\n\nTrama %d: ULTIMO PASSO", frame);
			printf ("\nL'utente numero %d ha iniziato una comunicazione", i);
			getchar();
#endif
		}
	}
}

/*-------------------------------------------------------------------------------------------*/

/* Tale funzione viene chiamata all'inizio di ogni trama e gestisce le richieste e le 
   assegnazioni delle sottoportanti di segnalazione agli utenti richiedenti e ad i loro
   compagni */

void Procedura_di_Richiesta_e_Assegnazione_delle_Sottoportanti ()
{
	int Mini_Slot[NMAX], Richiesta_Sottoportante[NMAX], Utente_con_collisione[NMAX];	

	Inizializza_Vettori (Mini_Slot, Richiesta_Sottoportante, Utente_con_collisione);
	
	Decidi_Richieste_In_Questa_Trama (Richiesta_Sottoportante);   /* PRIMO PASSO: trama i */

	Decidi_Minislot (Mini_Slot);                                  /* SECONDO PASSO: trama i */

	Verifica_Collisioni (Mini_Slot, Utente_con_collisione);       /* TERZO PASSO: trama i */

	Gestisci_Richieste ();                                        /* QUARTO PASSO: trama i+1 */

	Abilita_Sottoportanti_assegnate ();                           /* ULTIMO PASSO: trama i+2 */

}
																					    

/*-------------------------------------------------------------------------------------------*/


								/* DICHIARAZIONE DELLE FUNZIONI */


float random_value ()
{
	float random_temp;
  
    random_temp = ran0(&(idum));

    return (random_temp);
}


/*-------------------------------------------------------------------------------------------*/

struct el_buff *AggiungiInCoda (struct el_buff *uscita, struct el_buff *inizio)
  
{
 struct el_buff *appoggio;

	appoggio = inizio;

	while(appoggio->next!=NULL)
			appoggio = appoggio->next;

	appoggio->next = uscita;

	return(inizio);
 }


/*-------------------------------------------------------------------------------------------*/

int Notizie_utenti_new (struct UtentiPresenti *utenti)   /* modificata */
{	
	int lunghezza;
	int nvalue;
	int i, j;
	int Tipo[6] = {0,0,0,0,0,0};
	int Ritorna;
	int da;	
	int flag = 0;
	int utenti_video_totali = 0;
	int utenti_voce_totali = 0;
	char risposta[255];
	char ch;

	utenti_video_collegati = 0;
	utenti_voce_collegati = 0;	 

	printf("\n\t    ******** SIMULAZIONE DI UN SISTEMA CELLULARE ********\n\n");

label4:
	printf ("\nSimulazione a scenario vario, cioe' con la presenza di utenti Voce e Video ? \n(s/n) ");
	scanf ("%s", &ch);

	if (ch == 's')
	{
		strcpy (ScenarioUtenti,TIPO[5]);
		flag = 1;
	}

	else if (ch == 'n')
	{
label0:
	    printf("\n\nSimulazione a scenario unico:\nche tipo di utenti si desidera avere ?");
		printf("\nUtenti Voce (a) oppure utenti Video (b) ? ");
		scanf ("%s", &ch);

		if (ch == 'a')
		{
			strcpy (ScenarioUtenti, TIPO[1]);
			flag = 1;
			goto label2;
		}

		else if (ch == 'b')
		{
			strcpy (ScenarioUtenti, TIPO[2]);
			flag = 2;
			goto label1;
		}

		else goto label0;

	}

	else goto label4;


label1:
	    if (flag == 1)
		{
			printf("\nQual e' il numero di utenti Video abbonati su un totale di %d utenti ? ", NMAX);
			scanf ("%d", &utenti_video_totali);
		} 		
		else if (flag == 2)
		{
			printf("\nCi sono %d utenti Video su un totale di %d utenti abbonati", NMAX, NMAX);
			utenti_video_totali = NMAX;
		}
					
		if (utenti_video_totali%2!=0)
		{
			printf ("\nIl numero di utenti non puo' essere dispari");
			goto label1;
		}
		else if (utenti_video_totali>NMAX)
		{
			printf ("\nIl numero totale di utenti Video abbonati non puo' essere superiore a %d", NMAX);
			goto label1;
		}

label1_2:
		printf ("\nQual e' il numero di utenti Video inizialmente in comunicazione ? ");

		if (utenti_video_totali >= NCARRIER)
	  		printf ("\n(Tale numero deve essere al piu' pari a %d, cioe' al numero di sottoportanti\ndisponibili in ciascuna BS) ", NCARRIER);

		else
			printf ("\n(Tale numero deve essere al piu' pari a %d, cioe' al numero di utenti Video abbonati) ", utenti_video_totali);

		scanf ("%s", &risposta);

		lunghezza = strlen(risposta)-1;

		for (i=0; i<lunghezza; i++)

			if (!isdigit(risposta[i]))
			{
				printf ("\nIntrodurre solo numeri");
				goto label1_2;
			}

		nvalue = atoi (risposta);

		if (nvalue>NCARRIER)
		{
			printf("\nIl numero iniziale di utenti Video non puo' essere superiore a %d", NCARRIER);
			goto label1_2;
		}

		if (nvalue > utenti_video_totali)
		{
			printf ("\nIl numero iniziale di utenti Video non puo' essere superiore al numero totale di ");
			printf ("utenti Video.");
			goto label1;
		}

		if ((nvalue%2) != 0)
		{
			printf("\nIl numero iniziale di utenti video non puo' essere dispari");
			goto label1_2;
		}

		utenti_video_collegati = nvalue;

		if ((utenti_video_collegati == NCARRIER) || (!strcmp (ScenarioUtenti, TIPO[2])))
			goto label3;

label2:

		if (flag == 1)
		{
			utenti_voce_totali = NMAX - utenti_video_totali;
			printf("\nCi sono %d utenti Voce su un totale di %d utenti abbonati", utenti_voce_totali, NMAX);		
		}

		printf ("\nQual e' il numero di utenti Voce inizialmente in comunicazione ? ");
		printf ("\n(Tale numero deve essere al piu' pari a %d, cioe' al numero di sottoportanti\ndisponibili in ciascuna BS) ", 
			     (NCARRIER-utenti_video_collegati));

		scanf ("%s", &risposta);

		lunghezza = strlen(risposta)-1;

		for (i=0; i<lunghezza; i++)

			if (!isdigit(risposta[i]))
			{
				printf ("\nIntrodurre solo numeri");
				goto label2;
			}

		nvalue = atoi (risposta);

		if (nvalue>(NCARRIER-(utenti_video_collegati)))
		{
			printf("\nIl numero iniziale di utenti Voce non puo' essere superiore a %d",
				    (NCARRIER-utenti_video_collegati));
			goto label2;
		}

		if ((nvalue%2) != 0)
		{
			printf("\nIl numero iniziale di utenti Voce non puo' essere dispari");
			goto label2;
		}

		utenti_voce_collegati = nvalue;

label3:
		if ((utenti_video_collegati == 0) && (utenti_voce_collegati == 0))  
		{
			printf ("\nDevono essere presenti almeno due utenti di uno stesso tipo");
			goto label1;
		}

		if (utenti_video_collegati > 0)
			utenti->Video = PRESENTI;

		if (utenti_voce_collegati > 0)
			utenti->Voce = PRESENTI;

		/* Inizializzo con il valore -1 tutte le componenti del vettore vbs[] */

		for (i=0; i<NMAX; i++)
			vbs[i] = -1;

		/* Ogni utente di una BS viene messo in comunicazione con l'utente dell'altra BS */

		for(i=0;i<NMAX;i++)
		{
			if ((i%2) == 0)
				vbs[i] = 0;

			else if ((i%2) == 1)
				vbs[i] = 1;
		}

		printf("\n\nQuante simulazioni vuoi eseguire ? ");
		scanf("\n%d",&(Ritorna));
		getchar();

		if (Ritorna == 1)
		{
			printf("\nPremi INVIO per lanciare la simulazione ");
			getchar();
		}

		else if (Ritorna > 1)
		{
            printf("\nLe %d simulazioni verranno eseguite una dopo l'altra", Ritorna);
			printf("\n\nPremi INVIO per lanciare la prima simulazione ");
			getchar();
		}

		/* Composizione del nome del file di uscita */

		if ((utenti_video_collegati>0) && (utenti_voce_collegati>0))
			strcat (NomeFileUscita, TIPO[5]);

		else if (utenti_video_collegati>0)
			strcat (NomeFileUscita, TIPO[2]);

		else
			strcat (NomeFileUscita, TIPO[1]);


		/* Questo blocco assegna a ciascuna componente del vettore c[] il valore "a,b,c,d" 
		   a seconda che l'utente corrispondente sia rispettivamente voce, video, dati64Kbps,
		   dati2048Kbps (comunque i dati li voglio togliere !) */

		Tipo[1] = utenti_voce_totali;
		Tipo[2] = utenti_video_totali;
		da = Tipo[0];	

		for(j=1;j<=4;j++)
		{
			for(i=da;i<da+Tipo[j];i++)
				c[i]='a'-1+j;
			da += Tipo[j];
		}

		/* la seguente assegnazione serve per i risultati finali */

		numero_di_utenti_collegati_inizialmente = utenti_video_collegati +
			                                      utenti_voce_collegati;    
		
		return(Ritorna);
		
}


/*-------------------------------------------------------------------------------------------*/

int init_tab (struct tab_bs table[], struct state_ps ps[], int clt, int bc_x_Portanti[])
{
  int i;
  int usr = 0;
  int newsubcfree = 0;

  for (i=0; i<NCARRIER; i++)
  {
	  table[i].stop_trasm=0;    /* trasmissione di downlink abilitata */
	  table[i].HO_REQ=0;
	  table[i].assigned=0;
	  table[i].inf=0;
	  table[i].sign=0;
	  table[i].activity=0;
	  table[i].new_entry=0;
	  table[i].sent=0;          /* tot pacchetti inviati dalla bs alla MS */
	  table[i].pack_lost=0;     /* tot pacchetti persi in attesa di servizio nel downlink */
	  table[i].pack_lost_x_HO=0;

	  table[i].kind=NO_KIND;

	  while ((clt != ps[usr].MyServBS) && (usr < NMAX))
		  usr ++;  

	  /* ho aggiunto il controllo sul campo "utente_attivo" */

	  if ((clt == ps[usr].MyServBS) && (ps[usr].utente_attivo == ATTIVO) && (usr < NMAX))
	  {
		  table[i].kind = ps[usr].kind_of_service;
		  table[i].SubCarrierOf = usr;
		  ps[usr].mySubcarrier[clt] = i;
		  bc_x_Portanti[i] = usr; 
		  newsubcfree = i+1;

		  BaseStation[clt].Sottoportante_abilitata[i] = SI;   /* aggiunto */
	  }

	  else
	  {
		  table[i].SubCarrierOf = NO_USER;
		  bc_x_Portanti[i] = NO_USER;
		  BaseStation[clt].Sottoportante_abilitata[i] = NO;   /* aggiunto */
	  }
		
/*    printf("\nBS: %d, subcarrier %d= service %d",clt,i,table[i].kind);	
	  if (table[i].kind!=NO_KIND)
	     printf("\t assigned to %d",table[i].SubCarrierOf);	*/

	  usr ++;
  }

  if (newsubcfree < NCARRIER)  /* sottoportante "prima libera" */
	  return(newsubcfree);
  else
	  return (NCARRIER);
}


/*-------------------------------------------------------------------------------------------*/


void init_infopack ( struct inf infopack[],int dim )
{
  int i;

  for (i=0;i<dim;i++)
  {
		infopack[i].ps = NO_USER;
		infopack[i].info = NO_USE;
  }
}

/*-------------------------------------------------------------------------------------------*/

void init_status (struct state_ps status[],int dim)
{
	int i, j=0, clust, subc, contist;
    float randomix;

	for (i=0; i<(dim); i++)

		if (i<(utenti_video_collegati + utenti_voce_collegati))
		{
			status[i].utente_attivo = ATTIVO;
			status[i].Comunicazione = ATTIVATA;
			status[i].abilitato_al_passo = NESSUNO;          /* aggiunto */

			Risultati[i].Comunicazione_iniziata = SI;        /* aggiunto */
			Risultati[i].Trama_di_inizio_comunicazione = 1;  /* aggiunto */
			Risultati[i].durata_comunicazione = 0;           /* aggiunto */
			Risultati[i].Attivo_da_subito = SI;              /* aggiunto */	    
		}
		else
		{
			status[i].utente_attivo = NON_ATTIVO;
			status[i].Comunicazione = NON_ATTIVATA;
			status[i].abilitato_al_passo = PRIMO;            /* aggiunto */

			Risultati[i].Attivo_da_subito = NO;              /* aggiunto */	
		}

	for (i=0;i<(dim);i++)
	 {
		for (contist=0; contist < DIMISTOGRAMMA; contist++)
		{
			status[i].UpDelIst[contist] = 0;
			status[i].TotDelIst[contist] = 0;
		}

		for (clust=0; clust < CLUSTER; clust++)
		{
			status[i].quality_state[clust] = NO_LINK;
			status[i].mySubcarrier[clust] = NO_USER;
			status[i].pack_sent[clust] = 0;
		}

		for (subc=0; subc < NCARRIER; subc++)
			status[i].MySubcUse[subc] = 0;

		status[i].lastHOreq=0;
		status[i].SoftHOFrames=0;
		status[i].ContTwoLinks = NO_LINK;
		status[i].pack_arrived=0;
		status[i].HO_REQ=0;

        status[i].in_HO = NO;                           /* aggiunto */
        status[i].HO_STEP = NESSUNO;                    /* aggiunto */
	    status[i].Conta_trame_di_attivita = 0;          /* aggiunto */        
        status[i].Conta_trame_di_attesa = 0;            /* aggiunto */
		status[i].trama_di_abilitazione = -1;			/* aggiunto */
		status[i].NumOfLinks = 0;                       /* aggiunto */		

		status[i].PossibleHOR=0; 
		status[i].NewBS=NO_NEW_DESTINATION_BS;
		status[i].destinazione=NO_USER;
		status[i].last_pack_number=0;
		status[i].mean_delay=0.0;
		status[i].whole_mean_delay=0.0;
		status[i].pack_gen=0;
		status[i].max_lenght=0;
		status[i].MySubcarrierUse=0;
		status[i].pack_lost=0;          /* campo modificato in "togli_celle_perse" */
		status[i].NumOfHO=0;
		status[i].HO_Falliti=0;

		randomix = ran0(&(idum));       /* a che serve ? */

		if (c[j]=='a')
			status[i].kind_of_service = VOICE;

		if (c[j]=='b')
			status[i].kind_of_service = VIDEO1MBPS;
		
/*	    printf("\nUser %d, service %d",i,status[i].kind_of_service);	*/

		if(status[i].kind_of_service == VOICE)
		{
		  randomix = ran0(&(idum));

		  if(randomix >= 0.8)
				status[i].state = TALK;
		  else
				status[i].state = SILENT;
		}
		
		if (status[i].kind_of_service == VIDEO1MBPS)
		{
		  randomix = ran0(&(idum));
		  status[i].state = (int)(randomix * QUANTINT);

		  randomix = ran0(&(idum));
		  status[i].cycle_state = (int)(randomix * CYCLE_VIDEO);
		}

		status[i].bit_rest=0.0;
		status[i].buffer_leng_succ_i=0;
		status[i].buffer_leng_i=0;
		status[i].buffer_leng_prec_i=0;
		status[i].last_req=0;

		if (status[i].utente_attivo == ATTIVO)
			status[i].asse = 1;
		else
			status[i].asse = 0;

		if (status[i].kind_of_service == VOICE)              
		{
		  status[i].maximum_del = MAX_DEL_VOICE;
		  status[i].max_clock = (int)(MAX_DEL_VOICE/slot_duration);
		}

		if (status[i].kind_of_service == VIDEO1MBPS)
		{
		  status[i].maximum_del = MAX_DEL_VIDEO1MBPS;
		  status[i].max_clock = (int)(MAX_DEL_VIDEO1MBPS/slot_duration);
		}
		        
		j++;
	};

    /* si suppone che gli utenti all'inizio della simulazione siano nella propria BS */

	for (i=0;i<dim;i++)
	{
		status[i].MyServBS = vbs[i];
		status[i].MyOldBS = NO_NEW_DESTINATION_BS;

		if (status[i].utente_attivo == ATTIVO)
		{
			status[i].NumOfLinks = 1;
			status[i].quality_state[status[i].MyServBS] = 1;
		}
	}

}

/*-------------------------------------------------------------------------------------------*/


/* questa funzione determina la inizializzazione delle coppie di MS in comunicazione */
	
  void init_destination (int serv)
{
	    int ii=0,jj;

		while ((status[ii].kind_of_service != serv) && (ii < NMAX))
		 ii ++;

     /* printf("\nservizio %d:  utente %d serv %d",serv,ii,status[ii].kind_of_service); */

		jj = ii+1;

		while ((ii < NMAX-1) && ( jj <NMAX))  /* ho aggiunto "&&..." */
		{
			if (status[ii].kind_of_service == status[jj].kind_of_service)
			{
				status[ii].destinazione = jj;
				status[jj].destinazione = ii;

             /* printf("\n le coppie in comunicazione sono %d,%d ",status[ii].destinazione,
				       status[jj].destinazione); */

				ii = jj+1;

				while ((status[ii].kind_of_service != serv) && (ii < NMAX))
					ii ++;

			 /*	printf("\n next %d",ii); */

				jj = ii+1;
			}
			else
				jj ++;
		}
}


/*-------------------------------------------------------------------------------------------*/


void initHLR(struct state_ps status[])
{
	int i;

	for (i=0;i<NMAX;i++)
		HomeLocReg[i] = status[i].MyServBS;
}

/*-------------------------------------------------------------------------------------------*/


void initialise (int vett[],int dim)
{
  int i;

  for(i=0;i<dim;i++)
      vett[i] = NO_USER;
}

/*-------------------------------------------------------------------------------------------*/

void inizializza_vettori_globali (int dim)        /* Nuova */
{
	int i;

	for (i=0; i<dim; i++)
	{
		Nuova_Sottoportante[i] = NO_USER;
		HO_Fallito[i] = NO;	
		Utente_soddisfatto[i] = NO;      /* aggiunto */
	}
}


/*-------------------------------------------------------------------------------------------*/


void initialise_sign (int vett[], int dim)
{
  int i;

  for(i=0;i<dim;i++)
	  vett[i] = 0;
}

/*-------------------------------------------------------------------------------------------*/


void initbuffer (struct el_buff *punt[], int dim)
{
  int i;

  for(i=0;i<=(dim-1);i++)
    punt[i] = NULL;
}


/*-------------------------------------------------------------------------------------------*/


void initbufferRic (struct tipoBufInRicez punt[], int dim)
{
  int i;
  
  for(i=0;i<=(dim-1);i++)
  {
	  punt[i].buf = NULL;
	  punt[i].lenght = 0;

  }
}

/*-------------------------------------------------------------------------------------------*/


void init_oper_time (struct operation opr[])
{
  int i;

  for(i=0;i<DIMFRAME;i++)
  {
	  opr[i].reserved = 0;
	  opr[i].assigned = NO_USER;
  }

  /* Riservo il 29-esimo time slot per la ricezione del numero di sottoportante assegnato 
     all'utente vincitore */

  opr[CARRIER_SLOT].reserved = 1;
  opr[CARRIER_SLOT].assigned = SIGN;

  /* Riservo il 33-esimo time slot per la trasmissione delle richieste di assegnazione di
     sottoportanti */

  opr[ACCESS_SLOT].reserved = 1;
  opr[ACCESS_SLOT].assigned = SIGN;

  opr[DOWNLINK-BROADSLOT].reserved = 1;     /* time slot, chiamato Broadcast Slot,  riservato 
										       alla BS per trasmettere la segnalazione (numero
                                               31) */

  opr[DOWNLINK-BROADSLOT].assigned = DOWN;  /* slot numero 31 (32-esimo slot) */

  opr[DOWNLINK].reserved = 1;               /* time slot riservato alla BS per ricevere la 
										       segnalazione (numero 32) */

  opr[DOWNLINK].assigned = SIGN;            /*  slot numero 32 (33-esimo slot) */
}

/*-------------------------------------------------------------------------------------------*/


/* Questa funzione calcola lo stato di qualita' in cui si trova il collegamento. Inizialmente
   un nuovo collegamento e' di qualita' 1 (qualita' ottima), dopo un tempo medio di TIMEOFHO
   trame diventa di qualita' 2 (sufficiente: viene richiesto HO), poi dopo un tempo medio di
   TIMEOFSOFTHO trame diventa di qualita' 3 (scarsa: viene rilasciato il vecchio
   collegamento). */

void CalcPacketQuality (int *state, int usr, int TIMEOFHO, int TIMEOFSOFTHO)
{
	long double q1_q2, q2_q3;	/* frequenze medie di cambio di stato */
	float temp;

	q1_q2 = 1.0 - expl((long double)(-1.0/TIMEOFHO));
	q2_q3 = 1.0 - expl((long double)(-1.0/TIMEOFSOFTHO));

	temp = ran1(&idum1);

	if ((*state == 1) && (temp < q1_q2) && (status[usr].MyOldBS == NO_NEW_DESTINATION_BS))
		*state = 2;

	else if ((*state == 2) && (temp < q2_q3) && (status[usr].NumOfLinks == 2) &&
		     (status[usr].ContTwoLinks >= MIN_SHO))

		   *state = 3;  /* l'ultima condizione serve a garantire l'uso del doppio collegamento
	                       almeno per un fissato numero di trame (15) */
}

/*-------------------------------------------------------------------------------------------*/
				  

/* Questa funzione assegna i time slot dal numero 0 al 31 (escluso il 29) ossia quelli
   riservati al downlink: 
   l'assegnazione viene fatta controllando, per ciascuno dei primi pacchetti di tutti gli  
   utenti, il valore del tempo di attesa di assegnazione del downlink (BSclock) alla fine della
   trama i-1.La Broadcast Cell viene generata in tempo per essere inviata nella trama i in modo
   da assegnare i time slot della trama i+1 */


void CalcBroadCastCell_x_Downlink (struct tipoBufInRicez RicBuf[], struct tab_bs table[],
								   int bc_i[], struct operation oper_time_i[], int BS,
								   struct UtentiPresenti *utenti)
{
	int AlreadyAssigned[NCARRIER]={0}, RealLenght[NCARRIER]={0}, NoServed[NCARRIER]={0};
	int carrindex, sc=0, tslot=0;
	int Tot_request=0, del_req=0, data_req=0;	

	int BroadOcc=0;                   /* variabile di appoggio per sapere se nella trama la BS
									     deve trasmettere la "bc_x_portanti" */	                                       

	int firstpacket[NCARRIER]={0};    /* per utenti video e voce (posizione del primo pacchetto
									     di downlink che deve ancora ricevere l'assegnazione di
										 un time slot) */ 
	int count;
	int maxBSclock, next_all_subc, next_all_clock;
	int subcarr;
	int end=0;
	int AlmenoUnVIDEO=0;

	int appoggiosottoportante = 0;    /* aggiunta */
	int slot_assegnati;               /* aggiunta */	
	
	struct el_buff *puntapp;          /* puntatore al singolo pacchetto */


/*-------------------------------------------------------------------------------------------*/
	
	/* dopo il seguente ciclo for, "firstpacket" conterr, per ciascuna sottoportante assegnata
	   ad un utente video o voce, la posizione del primo pacchetto che deve ancora ricevere 
	   l'assegnazione di un time slot */ 	

	for (subcarr=0; subcarr<NCARRIER; subcarr++)
	{
		if ((BaseStation[BS].vettsubcfree[subcarr] != FREE)
			&& (BaseStation[BS].Sottoportante_abilitata[subcarr] == SI)  /* aggiunto */
			&& (BaseStation[BS].table[subcarr].kind != DATA64KBPS) 
			&& (BaseStation[BS].table[subcarr].kind != DATA512KBPS) 
			&& (BaseStation[BS].BufRic[subcarr].buf != NULL))
		{
			puntapp = RicBuf[subcarr].buf;

            /* al termine del seguente ciclo while, nel puntatore "puntapp" ci sar l'indirizzo
			   del primo pacchetto che, contenuto nel buffer di ricezione dell'utente associato
			   alla sottoportante numero "subcarr", ha un tempo di vita inferiore od uguale a
			   4736 time slot (tempo entro cui il pacchetto non  ancora considerato perso) */
			   
			while ((puntapp != NULL) && (puntapp->clock > 4736))													 
			{
				firstpacket[subcarr] ++;
				puntapp = puntapp->next;
			}
		}
	}

/*-------------------------------------------------------------------------------------------*/
	
	/* tale ciclo for calcola, per ciascuna sottoportante associata ad un utente, il numero di
	   time slot della trama attuale che gi sono stati allocati all'utente e lo pone nella
	   corrispondente componente della variabile locale "AlreadyAssigned[NCARRIER]" */

	for (carrindex=0; carrindex<NCARRIER; carrindex++)
	{
		if((BaseStation[BS].vettsubcfree[carrindex] != FREE)
			&& (BaseStation[BS].Sottoportante_abilitata[carrindex] == SI))  /* aggiunto */
		{
			for(tslot=0; tslot<DOWNLINK-BROADSLOT; tslot++)
			{
				if (oper_time_i[tslot].assigned == carrindex)
					AlreadyAssigned[carrindex] ++;

				if (AlreadyAssigned[carrindex] > firstpacket[carrindex])
					firstpacket[carrindex] = AlreadyAssigned[carrindex];
			}
		}
	}

/*-------------------------------------------------------------------------------------------*/

	/* mediante tale ciclo for vengono calcolate le lunghezze dei buffer di ricezione associati
	   agli utenti serviti dalla Base Station numero BS, cio vengono riempite le componenti
	   della variabile locale "RealLenght[NCARRIER]" (la lunghezza di ciascun buffer non tiene
	   conto dei time slot della trama attuale che gi sono stati allocati, cio non tiene
	   conto della variabile locale "AlreadyAssigned[NCARRIER]", quindi bisogna sottrarli) */

	for (carrindex=0; carrindex<NCARRIER; carrindex++)
	{
		if ((BaseStation[BS].vettsubcfree[carrindex] != FREE)
			&& (BaseStation[BS].Sottoportante_abilitata[carrindex] == SI))  /* aggiunto */
		{
			if (BaseStation[BS].table[carrindex].stop_trasm == 0)  /*  abilitata */
			{
				RealLenght[carrindex] = RicBuf[carrindex].lenght - AlreadyAssigned[carrindex];

				if (RealLenght[carrindex] > maxRealLenght[carrindex])
					maxRealLenght[carrindex] = RealLenght[carrindex]; /* variabile globale */
			}

			else    /* devo azzerare Reallenght se "stop_trasm==1" */
			{
				if (BaseStation[BS].table[carrindex].stop_trasm == 1) /*  bloccata */
					RealLenght[carrindex] = 0;

				else
				{
					printf("\nTrama %d: ERRORE IN stop_trasm: e' diverso da 0 e da 1", frame);
					getchar();
				}
			}

			if (RealLenght[carrindex] < 0)	
				RealLenght[carrindex] = 0;
		}
		else
			RealLenght[carrindex] = 0;
	}

/*-------------------------------------------------------------------------------------------*/

	/* mediante il seguente ciclo for vengono calcolati rispettivamente il numero totale di
	   richieste di time slot ("Tot_request") ed il numero di richieste di time slot da parte
	   di utenti di tipo video e voce ("del_req") */

	for (carrindex=0; carrindex<NCARRIER; carrindex++)

		if ((BaseStation[BS].vettsubcfree[carrindex] != FREE)
			&& (BaseStation[BS].Sottoportante_abilitata[carrindex] == SI))  /* aggiunto */
		{
			if ((RealLenght[carrindex] > 0) && (table[carrindex].kind != NO_KIND))
			{	
				Tot_request += RealLenght[carrindex]; /* numero totale di richieste */

				if((table[carrindex].kind == VOICE)||(table[carrindex].kind == VIDEO1MBPS))

					del_req += RealLenght[carrindex]; /* numero di richieste di time slot da
													     parte di utenti video e voce (utenti
				                                         che non possono attendere pi di 30 
														 ms, pena la perdita del pacchetto) */				                                          
			}
		}

/*-------------------------------------------------------------------------------------------*/

	data_req = Tot_request - del_req;   /* numero di richieste di time slot da parte di utenti
									       dati (utenti che non hanno problemi di tempo) */
	tslot = 0;
	slot_assegnati = 0;

	if ((frame % DIMMULTIFRAME) == 0)
		BroadOcc = 1;	

/*-------------------------------------------------------------------------------------------*/


	  /* Assegnazioni (caso in cui l'insieme delle richieste  superiore alle risorse) */


	if (Tot_request > DOWNLINK-BROADSLOT-1-BroadOcc)  /* l'insieme delle richieste  superiore
   													     alle risorse */
	{    
		
		if (del_req > DOWNLINK-BROADSLOT-1-BroadOcc)   /* anche le richieste video e voce sono 
								                          superiori alle risorse */       		
		{			
		
		   /* si alloca circolarmente uno slot per ogni utente video o voce */
			
			carrindex = BaseStation[BS].firstvideovocenoserved;

			do
			{
				if (tslot != CARRIER_SLOT)  /* slot 29 */
				{
					if (((table[carrindex].kind==VOICE)||(table[carrindex].kind==VIDEO1MBPS)) 
						&& (RealLenght[carrindex]>0) && 
					    (BaseStation[BS].Sottoportante_abilitata[carrindex] == SI))  					
					{
						bc_i[tslot]=carrindex;
					    RealLenght[carrindex]--;
					    del_req--;
					    tslot++;
						slot_assegnati++;                   /* aggiunto */
					    firstpacket[carrindex]++;
					}
					
					carrindex ++;

				    if (carrindex >= NCARRIER)
						carrindex = 0;
				}
				else
					tslot ++;
			}
			while (carrindex != BaseStation[BS].firstvideovocenoserved);
			    
	        /* esco dal ciclo do-while quando torno al numero iniziale di sottoportante, cio
			   quando ho allocato circolarmente uno slot per ogni utente video o voce */

/* I restanti time slot vengono allocati in base ai ritardi di downlink subti dai pacchetti,
   misurati dal campo BSclock (tale campo  massimo per il primo pacchetto in coda e decresce o
   rimane costante andando verso la fine della coda) */			

			while ((slot_assegnati < DOWNLINK - BROADSLOT - 1 - BroadOcc) && (end == 0))  /* ciclo A */			
			{
			  if (tslot != CARRIER_SLOT)   /* slot 29 */
			  {
				carrindex = BaseStation[BS].firstvideovocenoserved;				

				maxBSclock = -1;
				next_all_subc = -1;
				next_all_clock = -1;

				do  /* ciclo "do-while" che serve per trovare la "next_all_subc" */ 
				{					
					if (((table[carrindex].kind==VOICE)||(table[carrindex].kind==VIDEO1MBPS))
						&& (RealLenght[carrindex] > 0) 
						&& (BaseStation[BS].Sottoportante_abilitata[carrindex] == SI))
					{
						/* per ciascuno dei time slot che devo allocare cerco, tra gli utenti
						   video e voce, quello a cui  diretto il pacchetto in coda da pi 
						   tempo (uso il campo "BSclock") */

						puntapp = RicBuf[carrindex].buf;

						for (count=0; count<firstpacket[carrindex]; count++)
						{
							if (puntapp != NULL)
								puntapp = puntapp->next;
							else
								count=firstpacket[carrindex]; /* uscita anticipata dal ciclo:
							                                     pu accadere se sono stati 
							                                     persi alcuni pacchetti */
						}

						if ((puntapp != NULL) && (puntapp->BSclock >= maxBSclock))
						{
							if ((puntapp->BSclock > maxBSclock) 
								|| ((puntapp->BSclock == maxBSclock) 
								&& (puntapp->clock > next_all_clock))) 
							{
								maxBSclock = puntapp->BSclock;

								next_all_subc = carrindex;	/* sottoportante associata alla MS
								                               con il pacchetto da pi tempo 
								                               in attesa (se all'utente a cui 
								                               assegnata tale sottoportante 
															   diretto almeno un pacchetto,
															   allora gli alloco il time slot
															   numero "tslot") */				
														
								next_all_clock = puntapp->clock;
							}
						}
					}        /* fine if */

					carrindex ++;

					if (carrindex >= NCARRIER)
						carrindex = 0;
				
				}
				while (carrindex != BaseStation[BS].firstvideovocenoserved); /* fine ciclo
				                                                                do-while */

		       /* esco dal ciclo do-while quando torno al numero iniziale di sottoportante, 
				  cio quando le ho esplorate tutte */

				if ((next_all_subc >= 0) && (next_all_subc < NCARRIER) /* ne ho trovata una */
					&& (RealLenght[next_all_subc] > 0))
				{
					bc_i[tslot]=next_all_subc;
					RealLenght[next_all_subc]--;
					del_req--;
					tslot++;
					slot_assegnati++;                        /* aggiunto */
					firstpacket[next_all_subc]++;

					appoggiosottoportante = next_all_subc;                          /* agg */					
					
					BaseStation[BS].firstvideovocenoserved =                        /* agg */
						      CercaUtenteVideoVoce(table, appoggiosottoportante, BS);   
					
				/*	if((BaseStation[BS].firstvideovocenoserved == -1)               
						&& ((utenti->Video==PRESENTI) || (utenti->Voce==PRESENTI)))
					{
						printf("\n\n**CalcBroadCastCell_x_Downlink-Trama numero: %d **",frame);
						printf("\n\nNella BS numero %d non ci sono ne' utenti VIDEO ne' ", BS);
						printf("utenti VOCE");
                        printf("\n\nTutti gli utenti VIDEO e VOCE sono nell'altra BS");						
						} 	*/																			      

					if (table[next_all_subc].stop_trasm == 1)  /*  bloccata */
					{
					  printf("\nTrama %d: ERRORE: VIENE TRASMESSO UN PACCHETTO AD UNA MS CON ",
						       frame);
					  printf("stop_trasm pari ad 1");

					  getchar();
					}
				}

				else    /* non  un errore ma indica che si perderanno i pacchetti prima della
					       trasmissione */				
				{				 

				 /* se "del_req>0" alloco comunque gli slots ad utenti con "RealLenght>0" */
					
					if (del_req > DOWNLINK - BROADSLOT - BroadOcc - 1 - slot_assegnati)  
					{						
						carrindex = BaseStation[BS].firstvideovocenoserved;

                    	while ((del_req > 0) && (slot_assegnati < DOWNLINK - BROADSLOT - 1 - BroadOcc)) 
						{
							if (tslot != CARRIER_SLOT)   /* slot 29 */
							{								
								if ((RealLenght[carrindex] > 0) && ((table[carrindex].kind==VOICE)
								    ||(table[carrindex].kind==VIDEO1MBPS)) 
								    && (BaseStation[BS].table[carrindex].stop_trasm == 0) 
								    && (BaseStation[BS].Sottoportante_abilitata[carrindex] == SI))
								{
								
								    bc_i[tslot]=carrindex;
								    RealLenght[carrindex]--;
								    del_req--;
								    tslot++;
									slot_assegnati++;                       /* aggiunto */
								    firstpacket[carrindex]++;
								}
								
								carrindex ++;

								if (carrindex >= NCARRIER)
									carrindex = 0;
							}
							else
								tslot ++;							
						}

						end = 1;    /* esco dal ciclo A */					
					}
					
					else
					{
						printf("\nTrama numero %d: ERRORE IN INGRESSO del_req>31", frame);

						end = 1;   /* esco dal ciclo A */
					}
				
				}  /* fine else */
				
              }   /* fine if (tslot != CARRIER_SLOT) */

			  else tslot ++;  /* caso in cui tslot == CARRIER_SLOT */
			
			}          /* fine ciclo A */
			
			if (del_req <= 0)
			{
				printf("\n\nTrama %d: ERRORE NELLA PROCEDURA DI ASSEGNAZIONE: del_req=%d",
					    frame, del_req);

				printf("\n\nSospendere la simulazione e capire l'errore");

				getchar();
			}
    			
		}	           /* fine if(del_req > DOWNLINK-BROADSLOT-BroadOcc) */
		
		else /* le richieste voce e video non superano i time slot disponibili della trama
			    successiva e quindi tali richieste vengono servite */
		{
			carrindex = BaseStation[BS].firstvideovocenoserved;                      /* agg */

			while ((del_req > 0) && (slot_assegnati < DOWNLINK - BROADSLOT - 1 - BroadOcc))  /* agg */
			{
				if (tslot != CARRIER_SLOT)   /* slot 29 */
				{
					if ((RealLenght[carrindex] > 0) && ((table[carrindex].kind == VOICE)
						||(table[carrindex].kind == VIDEO1MBPS)) 
						&& (BaseStation[BS].table[carrindex].stop_trasm == 0) 
						&& (BaseStation[BS].Sottoportante_abilitata[carrindex] == SI))
					{
						bc_i[tslot]=carrindex;
						RealLenght[carrindex]--;
						del_req--;
						tslot++;
						slot_assegnati++;             /* aggiunto */
					}
					
					carrindex ++;
					
					if (carrindex >= NCARRIER)
						carrindex = 0;
				}
				else
					tslot ++;
			}

			appoggiosottoportante = carrindex;                                      /* agg */			
				
			BaseStation[BS].firstvideovocenoserved =                                /* agg */
						   CercaUtenteVideoVoce(table, appoggiosottoportante, BS);       		
					
		 /* if((BaseStation[BS].firstvideovocenoserved == -1)                       
				&& ((utenti->Video==PRESENTI) || (utenti->Voce==PRESENTI)))
			{
				printf("\n\n**CalcBroadCastCell_x_Downlink-Trama numero: %d **",frame);
				printf("\n\nNella BS numero %d non ci sono ne' utenti VIDEO ne' ", BS);
				printf("utenti VOCE");
				printf("\n\nTutti gli utenti VIDEO e VOCE sono nell'altra BS");			    
			} */

			/* se ci sono ancora slot servo gli utenti dati (se non ci sono slot assegnabili,
			   le richieste dati possono aspettare ad essere servite) */

			if ((slot_assegnati < DOWNLINK - BROADSLOT - 1 - BroadOcc) && (data_req != 0))  /* agg */
			{
				carrindex = BaseStation[BS].firstdatanoserved;                      /* agg */

			    while ((slot_assegnati < DOWNLINK-BROADSLOT - 1- BroadOcc) && (data_req != 0)) /* agg */
				{
					if (tslot != CARRIER_SLOT)   /* slot 29 */
					{
						if (((table[carrindex].kind == DATA64KBPS)
							||(table[carrindex].kind == DATA512KBPS)) 
							&& (RealLenght[carrindex] > 0) 
							&& (BaseStation[BS].Sottoportante_abilitata[carrindex] == SI))
						{
							bc_i[tslot]=carrindex;
							tslot++;
							slot_assegnati++;                    /* aggiunto */
							RealLenght[carrindex]--;
							data_req--;
						}
						
						carrindex ++;
						
						if (carrindex >= NCARRIER)
							carrindex = 0;
					}
					else 
						tslot ++;                                                   /* agg */

				}
					
				appoggiosottoportante = carrindex;                                  /* agg */				
					
				BaseStation[BS].firstdatanoserved=                                  /* agg */  
					              CercaUtenteDati(table, appoggiosottoportante, BS);                          		
					
		    /*  if((BaseStation[BS].firstdatanoserved == -1)                          
					&&((utenti->Dati64KBPS==PRESENTI) || (utenti->Dati2048KBPS==PRESENTI)))
					
				{   
					printf("\n\n**CalcBroadCastCell_x_Downlink-Trama numero: %d **",frame);
					printf("\n\nNella BS numero %d non ci sono utenti DATI", BS);
					printf("\n\nTutti gli utenti DATI sono nell'altra BS");			        
				} */

			}         /* fine if */           

		}       /* fine else */

    }     /* fine if (Tot_request > DOWNLINK-BROADSLOT-BroadOcc) */

/*-------------------------------------------------------------------------------------------*/


      /* Assegnazioni (caso in cui l'insieme delle richieste  adeguato alle risorse) */

		
	else  /* le richieste sono adeguate alle risorse e quindi non faccio distinzioni sulle
		     assegnazioni dei time slot di downlink in quanto posso soddisfarle tutte (video,
			 voce e dati) */
	{		                                    
		carrindex = BaseStation[BS].firstvideovocenoserved; 
		
		/* inizio da un utente video o voce */	

		while ((Tot_request > 0) && (slot_assegnati < DOWNLINK-BROADSLOT-1-BroadOcc))
		{
			if (tslot != CARRIER_SLOT)      /* slot 29 */
			{
			   if ((RealLenght[carrindex] > 0) 
				   && (BaseStation[BS].Sottoportante_abilitata[carrindex] == SI))  
			   
			   /* vengono serviti tutti gli utenti a cui  diretto almeno un pacchetto, cio
			      il cui valore di "RealLenght"  maggiore di 0 */

			   {
				  bc_i[tslot]=carrindex;
				  tslot++;
				  slot_assegnati++;
				  RealLenght[carrindex]--;
				  Tot_request--;
			   }
			   
			   carrindex ++;
			   
			   if (carrindex >= NCARRIER)
				   carrindex = 0;
			}			
			else
				tslot ++;
		}

		appoggiosottoportante = carrindex;                                          /* agg */
        
		BaseStation[BS].firstvideovocenoserved =                                    /* agg */                                
						CercaUtenteVideoVoce(table, appoggiosottoportante, BS);       		
					
	/*	if((BaseStation[BS].firstvideovocenoserved == -1) &&                        
			((utenti->Video==PRESENTI) || (utenti->Voce==PRESENTI)))
		{
			printf("\n\n**CalcBroadCastCell_x_Downlink-Trama numero: %d **",frame);
			printf("\n\nNella BS numero %d non ci sono ne' utenti VIDEO ne' ", BS);
			printf("utenti VOCE");
			printf("\n\nTutti gli utenti VIDEO e VOCE sono nell'altra BS");			
		} */
				
	}  /* fine else */

/*-------------------------------------------------------------------------------------------*/

	                /* Assegnazione random agli utenti di tipo video */

 /* se ci sono ancora time slot da allocare li alloco in modo random tra gli utenti video anche
    se il loro buffer di ricezione non contiene pacchetti (infatti non si tiene conto di
	RealLenght cio si alloca anche agli utenti le cui richieste sono gi state soddisfatte) */
	
	if (slot_assegnati < DOWNLINK-BROADSLOT-1-BroadOcc)  /* c' almeno un time slot disponibile */	
	{  
		/* mediante il seguente ciclo for si stabilisce se, tra gli utenti serviti dalla Base
		   Station numero BS, ce n' almeno uno verso cui non  bloccata la trasmissione dei
		   pacchetti di downlink */

		for (carrindex=0; carrindex<NCARRIER; carrindex++)
		{
			if((BaseStation[BS].vettsubcfree[carrindex] != FREE) 
				&& (BaseStation[BS].Sottoportante_abilitata[carrindex] == SI)) 

				if ((table[carrindex].kind==VIDEO1MBPS) && (table[carrindex].stop_trasm == 0))
				{
					AlmenoUnVIDEO = 1;      
					carrindex = NCARRIER;   /* uscita forzata dal ciclo for */
				}
		}

		if (AlmenoUnVIDEO)      /* c' almeno un utente video da servire */		
		{    			
			carrindex = BaseStation[BS].videonoserved;

			while (slot_assegnati < DOWNLINK - BROADSLOT - 1 - BroadOcc)			
			{
				if (tslot != CARRIER_SLOT)
				{
					if ((BaseStation[BS].vettsubcfree[carrindex] != FREE) 
					     && (BaseStation[BS].Sottoportante_abilitata[carrindex] == SI))					
					{
						if ((table[carrindex].kind==VIDEO1MBPS) && (table[carrindex].stop_trasm==0))
						{
							bc_i[tslot] = carrindex;
					        tslot ++;
							slot_assegnati++;             /* aggiunto */

  					        assigned_random_down[BS] ++;  /* conto i time slot assegnati a caso
													         dalla Base Station numero BS 
															 (serve per i risultati finali) */													   
						}
					}

					carrindex ++;

					if (carrindex >= NCARRIER)
						carrindex = 0;
				}
				else
					tslot ++;			
			} 

			appoggiosottoportante = carrindex;                                      /* agg */

			BaseStation[BS].videonoserved = CercaUtenteVideo(table, appoggiosottoportante, BS);

			if(BaseStation[BS].videonoserved == -1)                                 /* agg */			
			{
				printf("\n\n**CalcBroadCastCell_x_Downlink-Trama numero: %d **",frame);
				printf("\n\nSi e' verificato un errore perche' nella BS numero %d", BS);
				printf("\nnon e' stato trovato alcun utente video, mentre almeno uno ci ");
				printf("deve essere");				 
				printf("\n\nPremere INVIO per proseguire la simulazione");  
				getchar();
			}
		
		}     /* fine if (AlmenoUnVIDEO==1) */			
	
	}      /* fine if (tslot < DOWNLINK-BROADSLOT-BroadOcc) */
}


/*-------------------------------------------------------------------------------------------*/


/* Tale funzione ha il compito di assegnare i time slot di uplink della trama successiva. Ci 
   viene effettuato in base all'algoritmo PAMA */


void calc_broad_succ_i_x_uplink (struct tab_bs table[],struct inf infopack_prec_i[],
								 int sign_vett_prec_i[],int sign_vett_i[],int bc_succ_i[],
								 int clst)
{
  float  pippo;

  int p,usr,VideoNormalizzato=0, stat;
  int total_del_req,total_non_del_req,i;
  int slt = DOWNLINK+UP_RESERV+1;                          /* modificato (aggiunto "+1") */
  int appoggio,count,all_req_served=0,at_least_one_sign=0;

  for (i=DOWNLINK + UP_RESERV + 1; i<DIMFRAME; i++)   /* modificato (aggiunto "+1") */
	 bc_succ_i[i] = NO_USER;

  /* azzero il vettore di broadcast assegnando tutto a No User */

  for (i=0; i<NCARRIER; i++)

	  if ((BaseStation[clst].vettsubcfree[i] != FREE) 
		  && (BaseStation[clst].Sottoportante_abilitata[i] == SI))   /* aggiunto */

		if (table[i].kind != NO_KIND)
		{
		   table[i].sign = sign_vett_i[i];  /* aggiorno il vettore di segnalazione della base
			                                   station */
		   if (table[i].sign)
			   at_least_one_sign = 1;

		   table[i].assigned = 0;	
		}

  for (i=DOWNLINK+UP_RESERV+1; i<DIMFRAME; i++)    /* modificato (aggiunto "+1") */
  {
		if (infopack_prec_i[i].ps != NO_USER)
		{
			usr = infopack_prec_i[i].ps;  /* numero di sottoportante */

			if((usr>=NCARRIER)&&(usr!=NO_USER))
			{
				printf("\nerrore di subc all'interno di calc broad succ i");
				getchar();
			}

			table[usr].inf+=infopack_prec_i[i].info;

			if (table[usr].inf <= 0)
				table[usr].inf = 1;
		}
  }

  for (i=0; i<NCARRIER; i++)

	if ((BaseStation[clst].vettsubcfree[i] != FREE)
		&& (BaseStation[clst].Sottoportante_abilitata[i] == SI))   /* aggiunto */
	{
		if ((table[i].sign == 1) && (table[i].activity == 0))	/* nuovo ingresso */
		{
			table[i].new_entry=1;
			table[i].activity=1;
		}

		if ((table[i].sign == 1) && (table[i].inf == 0) && (table[i].activity == 1))
			table[i].inf = 1;
	}

  for(i=0; i<NCARRIER; i++)

	if ((BaseStation[clst].vettsubcfree[i] != FREE)
		&& (BaseStation[clst].Sottoportante_abilitata[i] == SI))   /* aggiunto */
	{
		if (table[i].new_entry==1)
		{
			table[i].new_entry=0;
			table[i].inf=1;
		}

		else
		{
			if (table[i].sign==0)
			{
				table[i].inf=0;
				table[i].new_entry=0;
				table[i].activity=0;
			}
		}
	}

	 /* ciclo di normalizzazione */

  total_del_req = 0;
  total_non_del_req = 0;

  for (i=0; i<NCARRIER; i++)        /* calcolo la somma delle richieste */

	if ((BaseStation[clst].vettsubcfree[i] != FREE)
		&& (BaseStation[clst].Sottoportante_abilitata[i] == SI))   /* aggiunto */
	{
		if ((table[i].kind == DATA512KBPS) || (table[i].kind == DATA64KBPS))
		{
		  total_non_del_req += table[i].inf;    /* utenti dati */
		}

		if ((table[i].kind == VOICE) || (table[i].kind == VIDEO1MBPS))
		{
		  total_del_req += table[i].inf;    /* utenti video e voce */
		}
	}

  conta_tot_del_req[clst] += total_del_req;

  /* vediamo prima gli utenti video e voce */

  if (total_del_req > 30)        /* le richieste video sono troppe (modificato: era 31) */
  {
	    VideoNormalizzato = 1;

		for (i=0; i<NCARRIER; i++)

			if ((BaseStation[clst].vettsubcfree[i] != FREE)
				&& (BaseStation[clst].Sottoportante_abilitata[i] == SI))   /* aggiunto */
			{
				if ((table[i].kind == VOICE) || (table[i].kind == VIDEO1MBPS))
				{
					pippo = ((float)table[i].inf/((float)total_del_req))*30;  /* modificato:
																			     era 31 */
					
					/* 30  il numero di slot assegnabili */						                                                     

					stat = table[i].SubCarrierOf;   /* utente che usa la sottoportante i */
					
					if (status[stat].utente_attivo == NON_ATTIVO)   /* aggiunto (errore) */
					{
						BaseStation[clst].Sottoportante_abilitata[i] = NO;
						BaseStation[clst].vettsubcfree[i] = FREE;
						table[i].SubCarrierOf = NO_USER;
						Errore_verificato = SI;												
					}

					if (pippo > 1)
					{
						pippo += 0.5;
						table[i].assigned = (int)pippo;
					}

					else 				/* sono tra 0 ed 1 */
					{
						if ((pippo>0) /* && (status[stat].NumOfLinks==1)*/)  /* vedere cosa
																			    succede se per
																				gli utenti con
																				2 collegamenti
																				non garantisco
																				uno slot nella
																				ServBS */
							table[i].assigned = 1;					
					}        

					/* Non servirebbe fare un controllo sull'utente attivo, ma 
					   stato fatto per precauzione */

					if ((BaseStation[clst].tableMS.one_link > MAX_MS_ONE_LINK) 
						&& (status[table[i].SubCarrierOf].NumOfLinks == 2) 
						&& (status[table[i].SubCarrierOf].ContTwoLinks >= 2)
						&& (status[table[i].SubCarrierOf].utente_attivo == ATTIVO))

						table[i].assigned = 0;

					if (((BaseStation[clst].tableMS.one_link + 
						  BaseStation[clst].tableMS.two_links_New + 
						  BaseStation[clst].tableMS.two_links_Old) > MAX_MS_TOT) 
						  && (BaseStation[clst].tableMS.two_links_Old > 0) 
						  && (status[table[i].SubCarrierOf].MyServBS != clst)
						  && (status[table[i].SubCarrierOf].utente_attivo == ATTIVO))

						table[i].assigned = 0;
				}
			}

  }  /* fine if (total_del_req > 30) */

  else
  {
	  for (i=0; i<NCARRIER; i++)

			if ((BaseStation[clst].vettsubcfree[i] != FREE)
				&& (BaseStation[clst].Sottoportante_abilitata[i] == SI))   /* aggiunto */
			{
				if ((table[i].kind == VOICE) || (table[i].kind == VIDEO1MBPS))
					
					table[i].assigned = table[i].inf;
			}
  }

  /* fine parte per video utenti */

  i = 1;

  /* assegnazione degli slot agli utenti di tipo video */

  while ((slt < DIMFRAME) && (!all_req_served))	 
  {
		if ((i+(BaseStation[clst].ciclo_video))<NCARRIER)
			p = i + (BaseStation[clst].ciclo_video);
		else
			p = i + (BaseStation[clst].ciclo_video)-NCARRIER;

		if ((BaseStation[clst].vettsubcfree[p] != FREE)
			&& (BaseStation[clst].Sottoportante_abilitata[p] == SI))   /* aggiunto */

			if ((((table[p].kind==VOICE)||(table[p].kind==VIDEO1MBPS))) && (table[p].assigned))
			{
				table[p].assigned--;
				bc_succ_i[slt]=p;
				slt++;
				conta_del_req_slot_ass[clst]++;

                /* controllo che la BS con piu' di 20 utenti attivi non in SHO non assegni
				   slot a quelli in SHO */

				if ((BaseStation[clst].tableMS.one_link > MAX_MS_ONE_LINK) 
					&& (status[table[p].SubCarrierOf].NumOfLinks == 2) 
					&& (status[table[p].SubCarrierOf].ContTwoLinks >= 2)
					&& (status[table[p].SubCarrierOf].utente_attivo == ATTIVO)) /* aggiunto */

				{
			/*		printf("\nTRAMA %d: LA BS#%d CON %d UTENTI CON 1 LINK ASSEGNA UNO SLOT ALL'UTENTE %d IN SHO", frame, clst, BaseStation[clst].tableMS.one_link, table[p].SubCarrierOf);  */
					       
//					getchar();

					appoggioslot ++;
				}

			}

		appoggio = 0;          

		for (count=0; count<NCARRIER; count++)
			if ((BaseStation[clst].vettsubcfree[count] != FREE)
				&& (BaseStation[clst].Sottoportante_abilitata[count] == SI))   /* aggiunto */
			{
				if ((table[count].kind == VOICE) || (table[count].kind == VIDEO1MBPS))
					appoggio += table[count].assigned;
			}

		if (appoggio == 0)
			all_req_served = 1;

		else if (appoggio < 0)
		{
				printf("\n ERRORE di conta !\nAll'interno di calc broad succ i nella parte ");
				printf("di assegnazione per video e voce");
				getchar();
		}

		else all_req_served = 0;

		i ++;

		if (i > NCARRIER)
			i = 1;

  }  /* fine ciclo while */
  
  BaseStation[clst].ciclo_video = p;

  /* fine assegnazione agli utenti video e voce */

  BaseStation[clst].bc_succ_i_long = slt;

  /* da qui in poi assegno agli utenti dati e poi ancora a caso (se c' ancora spazio lo d
	 agli utenti dati) */

  if (slt < DIMFRAME)
  {
		if (total_non_del_req > (DIMFRAME-BaseStation[clst].bc_succ_i_long))

		/* normalizzo anche le sorgenti dati */

		{
			for (i=0; i<NCARRIER; i++)

				if ((BaseStation[clst].vettsubcfree[i] != FREE)
					&& (BaseStation[clst].Sottoportante_abilitata[i] == SI))   /* aggiunto */
				{
					if ((table[i].kind == DATA512KBPS) || (table[i].kind == DATA64KBPS))
					{
						pippo = ((float)table[i].inf/total_non_del_req) 
							     *(30-BaseStation[clst].bc_succ_i_long);  /* modificato: era
																		     31 */
						/* numero di slot assenabili rimasti */

						if (pippo>1)
						{
							pippo += 0.5;
							table[i].assigned = (int)pippo;
						}

						else    /* sono tra 0 ed 1 */
						{
							if (pippo>0)
								table[i].assigned = 1;
						}
					}
				}
		}

		else
		{
			for (i=0;i<NCARRIER;i++)

				if ((BaseStation[clst].vettsubcfree[i] != FREE)
					&& (BaseStation[clst].Sottoportante_abilitata[i] == SI))   /* aggiunto */
				{
					if ((table[i].kind == DATA512KBPS) || (table[i].kind == DATA64KBPS))
						table[i].assigned = table[i].inf;
				}
		}

	    /* adesso assegna il resto agli utenti dati */

		all_req_served = 0;
		i = 1;

        /* assegnazione degli slot agli utenti dati */

		while ((slt < DIMFRAME) && (!all_req_served))	  
		{
			if ((i+(BaseStation[clst].ciclo_data)) < NCARRIER)
				p = i + (BaseStation[clst].ciclo_data);
			else
				p = i + (BaseStation[clst].ciclo_data) - NCARRIER;

			if ((BaseStation[clst].vettsubcfree[p] != FREE)
				&& (BaseStation[clst].Sottoportante_abilitata[p] == SI))   /* aggiunto */

				if ((((table[p].kind == DATA512KBPS) || (table[p].kind == DATA64KBPS)))
					&& (table[p].assigned))

				{
					table[p].assigned--;
					bc_succ_i[slt]=p;
					slt++;
				}

			appoggio = 0;

			for (count=0; count<NCARRIER; count++)

				if ((BaseStation[clst].vettsubcfree[p] != FREE)
					&& (BaseStation[clst].Sottoportante_abilitata[p] == SI))   /* aggiunto */
				{
					if ((table[count].kind == DATA512KBPS)||(table[count].kind == DATA64KBPS))
						appoggio += table[count].assigned;
				}

			if (appoggio>0)
				all_req_served = 0;
			else
				all_req_served = 1;

			i++;

			if (i > NCARRIER)
				i = 1;
		}

		BaseStation[clst].ciclo_data = p;
  }

     /* fine assegnazione agli utenti dati */

    /* se c'e' ancora spazio lo d a caso: devo pensare bene come darlo */

	 if (frame > 10)
	 {
		i=0;

		while ((slt < DIMFRAME) && (at_least_one_sign))
		{
		  if ((i+(BaseStation[clst].ciclo_random)) < NCARRIER)
			  p = i + (BaseStation[clst].ciclo_random);
		  else
			  p = i + (BaseStation[clst].ciclo_random) - NCARRIER;

		  if ((BaseStation[clst].vettsubcfree[p]!=FREE)
			  && (BaseStation[clst].Sottoportante_abilitata[p] == SI))   /* aggiunto */

			if ((table[p].inf > 0) && (table[p].kind != NO_KIND))
			{
				  bc_succ_i[slt]=p;
				  slt++;

                  /* conto gli slot assegnati a caso */

				  assigned_random_up[clst]++;
				  conta_random_slot_ass[clst]++;
			}

		  i++;

		  if (i >= NCARRIER)
			  i = 0;
		}

		BaseStation[clst].ciclo_random = p;
	}
}

/*-------------------------------------------------------------------------------------------*/


void agg_oper_x_downlink (int bc_i[], struct operation oper_time_succ1_i[], int a_partire)
{
  int i;

  for(i=a_partire; i<DOWNLINK-BROADSLOT; i++)
  {
	  if (i != CARRIER_SLOT)                          /* slot 29 */
		  oper_time_succ1_i[i].assigned = bc_i[i];
  }
}


/*-------------------------------------------------------------------------------------------*/

void HO_Step_1 (int bs1, int bs2, int sign_vett_x_HO_entrante[])
{	

	 /* posto che la MS in HO da bs2 a bs1 abbia settato ad 1 il flag di HO e lo abbia tx a
	    bs1, questa BS inoltra la richiesta del profilo di utente verso la bs2. Siamo nella
		trama "i+1" della procedura di HO */

	int cnt, i, contaHOentranti=0, contasottoportanti=0;

	for (cnt=0;cnt<NCARRIER;cnt++)       /* vettore di segnalazione di HO della bs1 */
	{
		i = BaseStation[bs2].table[cnt].SubCarrierOf;

		if (i != NO_USER)
			if ((sign_vett_x_HO_entrante[cnt] == 1) && (status[i].utente_attivo == ATTIVO)
				&& (BaseStation[bs2].Sottoportante_abilitata[cnt] == SI))   /* controlli
				                                                               aggiunti */
			{
				status[i].HO_STEP = 1;                   /* aggiunto */
			    contaHOentranti ++;
			}
	}

	Numero_totale_di_richieste_di_HO += contaHOentranti;	

	BaseStation[bs2].succ_profile_req[bs1] = contaHOentranti; 

	for (cnt=0; cnt < NCARRIER; cnt++)
	{

		if ((BaseStation[bs2].vettsubcfree[cnt] != FREE)
			&&(BaseStation[bs2].Sottoportante_abilitata[cnt] == SI)) /* aggiunto */

			if (sign_vett_x_HO_entrante[cnt]==1) /* flag HB inviato alla BS numero bs1 dallo
												    utente che nella BS numero bs2  associato
													alla sottoportante numero cnt (tale flag 
													una componente di un campo della BS numero 
													bs1) */

					BaseStation[bs2].ChiStaUscendo[cnt] = bs1;  /* bs1  infatti la BS di 
															       destinazione */
	}

	if (BaseStation[bs1].newsubcfree < NCARRIER)   /* ci sono sottoportanti libere nella BS di
		                                              destinazione */
	{		

		for (cnt=0; cnt < NCARRIER; cnt++)
		{	
			if (BaseStation[bs1].vettsubcfree[cnt] == FREE)
				contasottoportanti ++;              /* quante sono le sottoportanti libere */
		}

		if ((contaHOentranti>0) && (contaHOentranti <= contasottoportanti))

			for (cnt=0; cnt<NCARRIER; cnt++)
			{
				if (sign_vett_x_HO_entrante[cnt] != 1)
					BaseStation[bs2].ChiStaUscendo[cnt] = NO_NEW_DESTINATION_BS;
			}

		if (contaHOentranti > contasottoportanti)
			BaseStation[bs2].HO_non_realizzati += contaHOentranti - contasottoportanti;
	}

	else	/* BaseStation[bs1].newsubcfree == NCARRIER, cio non ci sono sottoportanti libere
		       nella BS di destinazione */

		BaseStation[bs2].HO_non_realizzati += contaHOentranti;
}


/*-------------------------------------------------------------------------------------------*/


void HO_Step_2 (int bs1, int bs2, int carrier, int bc_x_Portanti[])
{

	/*	la BS di origine (bs2) trasmette alla BS di destinazione (bs1) il profilo di utente
	    richiesto. La bs1 crea la bc x gestione sottoportanti relativamente alle nuove
		sottoportanti assegnate ad utenti in HO verso bs1. La bs1 identifica NOT_FREE la nuova
		sottoportante assegnata ed individua la nuova sottoportante "prima libera". MS non 
		disabilitata a trasmettere sul collegamento con la BS numero bs2  */

	int scfr, usr, usrapp, i;
	int j;                        /* aggiunta */

//	printf ("\n\nTrama numero %d: HO STEP 2", frame);

	BaseStation[bs2].profile_req[bs1] --;
	BaseStation[bs2].ChiStaUscendo[carrier] = NO_NEW_DESTINATION_BS;

	if (BaseStation[bs1].newsubcfree < NCARRIER)    /* ci sono sottoportanti libere nella BS
		                                               numero bs1 (nuova BS) */
	{
		scfr = BaseStation[bs1].newsubcfree;        /* sottoportante "prima libera" nella BS
													   numero bs1 (nuova BS) */		

		usr = BaseStation[bs2].table[carrier].SubCarrierOf;  /* l'utente numero usr nella BS
															    numero bs2 (vecchia BS) ha la
																sottoportante numero carrier
		                                                        (usr  l'utente in HO) */

		HO_Fallito[usr] = NO;       /* variabile globale aggiunta */	
	

		bc_x_Portanti[scfr] = usr;  /* creazione della scfr-esima componente della BCGS (la
									   sottoportante numero scfr della BS numero bs1 verr
									   assegnata all'utente numero usr) */

		Nuova_Sottoportante[usr] = scfr;  /* variabile globale aggiunta */

	//	printf ("\n\nTrama numero %d: HO STEP 2", frame);
	//	printf ("\nLa nuova sottoportante assegnata all'utente numero %d dalla BS %d e' ", usr,
	//		    bs1);
	//	printf ("la numero %d", scfr);	
		
		BaseStation[bs1].vettsubcfree[scfr] = NOT_FREE;  /*  una sorta di prenotazione */

		BaseStation[bs1].Sottoportante_abilitata[scfr] = NO;   /* aggiunto (viene posto a SI 
		                                                          nel quarto passo) */

		Risultati[usr].HO_effettuati ++;  /* aggiunto */

		BaseStation[bs1].table[scfr] = BaseStation[bs2].table[carrier]; /* copia l'intera
		                                                                   struttura tab_bs */
		BaseStation[bs1].table[scfr].kind = NO_KIND;

		BaseStation[bs1].table[scfr].sent = 0; /* azzero il numero di pacchetti tx sul downlink
											      del nuovo collegamento. Quando rilascer il
		                                          vecchio collegamento sommer il campo sent
		                                          della tabella della vecchia BS a quello
		                                          contenuto nella nuova BS */

		BaseStation[bs1].table[scfr].pack_lost = 0; /* modificato: al posto di bs2 ho messo bs1
													   e al posto di carrier ho messo scfr */

//      BaseStation[bs2].table[carrier].pack_lost = 0;

		/* questo ciclo for individua la nuova sottoportante libera nella BS numero bs1 */

		BaseStation[bs1].newsubcfree = NCARRIER;

		for (i=0;i<NCARRIER;i++)
		{
			if ((BaseStation[bs1].vettsubcfree[i]) == FREE)         /* sottoportante libera */

				if (BaseStation[bs1].table[i].SubCarrierOf == NO_USER) /* non assegnata ad un 
																	      utente in HO */

					if (i != scfr)     /* scfr individua la sottoportante appena assegnata
						                  (controllo inutile perch scfr  gi NOT_FREE) */
					{
						BaseStation[bs1].newsubcfree = i;

					//	printf("\n\nLa sottoportante libera nella BS %d e'la %d", bs1, i);

						i = NCARRIER;   /* uscita anticipata dal ciclo for */
					}
		}

#ifdef DEBUG

		if (BaseStation[bs1].newsubcfree == NCARRIER) /* il prossimo utente non sar abilitato
			                                             all'HO */
		{
			printf("\n\nHO STEP 2");

			printf("\nTrama numero %d: nessuna sottoportante e' disponibile per la BS %d\n",
			        frame, bs1);
		}
#endif
		                 
	}  /* fine if (BaseStation[bs1].newsubcfree < NCARRIER) */

	else      /* HO fallito per mancanza di sottoportanti libere nella BS numero bs1 */
	{

		/* l'utente numero usrapp ed il suo compagno perdono la comunicazione (data la brevit
		   della simulazione, si suppone che nessuno di questi due utenti possa richiedere 
		   nuovamente una sottoportante di segnalazione) */

		usrapp = BaseStation[bs2].table[carrier].SubCarrierOf;  /* utente in HO */

		HO_Fallito[usrapp] = SI;                        /* variabile globale aggiunta */

#ifdef DEBUG
		
		printf ("\n\nTrama numero %d: l'utente numero %d ha fallito un HO", frame, usrapp);
		printf ("\nTale utente stava abbandonando la BS numero %d ", status[usrapp].MyServBS);
		printf ("e si stava quindi dirigendo verso la BS numero %d", status[usrapp].NewBS);

#endif
		
		Gestisci_Utente_che_ha_fallito_HO (usrapp, bs2, carrier);  /* aggiunta */		

		BaseStation[bs2].table[carrier].kind = status[usrapp].kind_of_service; /* a che serve ?	*/
		
		j = ((usrapp%2) == 0 ? (usrapp+1) : (usrapp-1));   /* numero di utente con cui  
														      accoppiato l'utente numero
		                                                      usrapp */

		Risultati[j].Comunicazione_terminata_x_HO_fallito_dal_compagno = SI;
		Risultati[j].Comunicazione_terminata = SI;

		Gestisci_Compagno (j);
	}
}
	

/*-------------------------------------------------------------------------------------------*/

void HO_Step_3_bis (int bs1, int bs2)   /* nuova */
{	
	/*	Funzione chiamata durante l'ultima trama della multitrama. La bs1 trasmette la bc x
	    gestione sottoportanti per l'assegnazione delle nuove sottoportanti a partire dalla
		prossima trama (prima trama della multitrama successiva). I nuovi pacchetti diretti
		alla MS in HO vengono messi sia nel buffer di ricezione di bs1 (nuova BS) sia in
		quello di bs2 (vecchia BS).  */

	int cnt, usr;
	int i, j;       /* aggiunte */

	for (cnt=0; cnt < NCARRIER; cnt++)

		if (BaseStation[bs1].bc_x_Portanti[cnt] != BaseStation[bs1].bc_prec_x_Portanti[cnt])
		{
			usr = BaseStation[bs1].bc_x_Portanti[cnt];

			if ((status[usr].utente_attivo == ATTIVO) && (usr != NO_USER) 
				&& (BaseStation[bs1].Sottoportante_abilitata[cnt] == NO))  /* aggiunti */
			{
                status[usr].HO_STEP = 3;                 /* aggiunto */
				status[usr].myNextSubcarrier[bs1] = cnt;
			    HomeLocReg[usr] = bs1;                   /* cambio dell'HLR */

			    status[usr].MyOldBS = status[usr].MyServBS;
			    status[usr].MyServBS = status[usr].NewBS;

				i = status[usr].MyOldBS;                /* aggiunto (vecchia BS: bs2) */
				j = status[usr].mySubcarrier[i];        /* aggiunto (vecchia sottoportante) */

				Pacchetti_in_BS_vecchia[usr] = BaseStation[i].BufRic[j].lenght;  /* aggiunto */				
				
				BaseStation[bs1].Portante_in_SHO[cnt].stato = SI;  /* nuova sottoportante */
                BaseStation[bs1].Portante_in_SHO[cnt].utente = usr;
				BaseStation[bs1].Portante_in_SHO[cnt].altra_portante = j;
				BaseStation[bs1].Portante_in_SHO[cnt].altra_BS = bs2;
				BaseStation[bs2].Portante_in_SHO[j].stato = SI;    /* vecchia sottoportante */
				BaseStation[bs2].Portante_in_SHO[j].utente = usr;
				BaseStation[bs2].Portante_in_SHO[j].altra_portante = cnt;
				BaseStation[bs2].Portante_in_SHO[j].altra_BS = bs1;             

				Copia_Buffer_di_ricezione (bs2, bs1, j, cnt);
			
			    status[usr].NumOfHO ++;
			    status[usr].NewBS = NO_NEW_DESTINATION_BS;          

			}  /* fine if ((status[usr].utente_attivo == ATTIVO) && ...) */
		}
}
/*-------------------------------------------------------------------------------------------*/

void HO_Step_4 (int bs1, int bs2, int usr)
{
	/*	Funzione chiamata durante la prima trama della multitrama. La MS in HO legge la bc x 
	    gestione sottoportanti trasmessa nella trama precedente ed acquisisce la sottoportante
		da usare sul nuovo collegamento	*/

	int carrier;   /* aggiunta */
	int j;         /* aggiunta */	

//	printf("\nPrima dell'HO STEP 4 la qualita' del collegamento tra l'utente %d e la BS ",usr);
//	printf("\ndi provenienza (BS %d) e': %d", bs1, status[usr].quality_state[bs2]);
	
	j = status[usr].mySubcarrier[bs2];                                 /* aggiunto */

	Pacchetti_in_BS_vecchia[usr] = BaseStation[bs2].BufRic[j].lenght;  /* aggiunto */	
	
	status[usr].mySubcarrier[bs1] = status[usr].myNextSubcarrier[bs1];
	status[usr].myNextSubcarrier[bs1] = NO_USER;

	carrier = status[usr].mySubcarrier[bs1];   /* aggiunto */

	status[usr].NumOfLinks = 2;    /* rimane a 2 fino a quando l'utente numero usr non perde il
								      collegamento con la BS numero bs2 (HO_STEP_5) */
	status[usr].ContTwoLinks = 0;
	status[usr].quality_state[bs1] = 1;

    BaseStation[bs1].Sottoportante_abilitata[carrier] = SI;       /* aggiunto */

	BaseStation[bs1].table[status[usr].mySubcarrier[bs1]].kind =
		BaseStation[bs2].table[status[usr].mySubcarrier[bs2]].kind;

/* aggiorno il numero di MS presenti nella BS di provenienza (bs2) ed in quella di destinazione
   (bs1) */ 

	BaseStation[bs2].tableMS.one_link --;
	BaseStation[bs2].tableMS.two_links_Old ++;
	BaseStation[bs1].tableMS.two_links_New ++;
	
//	printf ("\nFrame %d: HO STEP 4 per l'utente %d", frame, usr);

/*	printf ("\nTrama %d: Pacchetti trasmessi dall'utente %d sull'uplink alle BS 0 e 1: %ld %ld"
	        , frame, usr, status[usr].pack_sent[0], status[usr].pack_sent[1]);  */

/*	printf ("\n\tNumero di trame passate da quando il flag di HO e' stato posto ad 1: %d",
	         status[usr].lastHOreq);   */

/*	printf ("\n\nPREMI INVIO PER CONTINUARE LA SIMULAZIONE");
	getchar();	*/
}

/*-------------------------------------------------------------------------------------------*/


void HO_Step_5 (int bs, int usr)

{	/* MS numero usr rilascia il collegamento (sottoportante numero subcarr) con bs (vecchia
	   BS) */

	int subcarr, altraBS, altrasubc;
	struct el_buff *puntapp, *da_eliminare;

/*	printf("\nFrame %d: HO STEP 5 per l'utente %d: rilascio del collegamento con la BS %d",
	       frame, usr, bs);  */

//	printf("\n\tNumero di trame trascorse dalla richiesta di HO: %d", status[usr].lastHOreq);

/*	printf("\n\tQualita' dei collegamenti con le BS 0 ed 1 prima del rilascio: %d %d",
	        status[usr].quality_state[0], status[usr].quality_state[1]);   */
	
	subcarr = status[usr].mySubcarrier[bs];          /* sottoportante nella vecchia BS */

	altraBS = status[usr].MyServBS;
	altrasubc = status[usr].mySubcarrier[altraBS];   /* sottoportante nella nuova BS */

	Pacchetti_in_BS_vecchia[usr] = BaseStation[bs].BufRic[subcarr].lenght;  /* aggiunto */

	if (status[usr].MyOldBS != bs)
	{
		printf("\nERRORE nel rilascio della sottoportante");
		getchar();
	}
	
    /* aggiorno il numero di MS presenti nella tabella delle BS */

	BaseStation[bs].tableMS.two_links_Old --;
	BaseStation[altraBS].tableMS.one_link ++;
	BaseStation[altraBS].tableMS.two_links_New --;

	BaseStation[altraBS].Portante_in_SHO[altrasubc].stato = NO;   /* nuova sottoportante */
	BaseStation[altraBS].Portante_in_SHO[altrasubc].utente = NO_USER;
	BaseStation[altraBS].Portante_in_SHO[altrasubc].altra_portante = NO_USER;
	BaseStation[altraBS].Portante_in_SHO[altrasubc].altra_BS =NO_USER;
	BaseStation[bs].Portante_in_SHO[subcarr].stato = NO;          /* vecchia sottoportante */
	BaseStation[bs].Portante_in_SHO[subcarr].utente = NO_USER;
	BaseStation[bs].Portante_in_SHO[subcarr].altra_portante = NO_USER;
	BaseStation[bs].Portante_in_SHO[subcarr].altra_BS = NO_USER;

	if ((BaseStation[bs].BufRic[subcarr].buf != NULL) 
		&& (BaseStation[bs].Sottoportante_abilitata[subcarr] == SI))
	{
		puntapp = BaseStation[bs].BufRic[subcarr].buf;
		
		while (puntapp != NULL)
		{
			da_eliminare = puntapp;
			puntapp = puntapp->next;
			free(da_eliminare);		
		}

		BaseStation[bs].BufRic[subcarr].buf = NULL;
		BaseStation[bs].BufRic[subcarr].lenght = 0;	
	}

	Vecchia_BS[usr] = status[usr].MyOldBS;                       /* aggiunta */
	Vecchia_Sottoportante[usr] = status[usr].mySubcarrier[bs];   /* aggiunta */

	status[usr].quality_state[bs] = NO_LINK;
	status[usr].MyOldBS = NO_NEW_DESTINATION_BS;
	status[usr].NewBS = NO_NEW_DESTINATION_BS;
	status[usr].mySubcarrier[bs] = NO_USER;

	BaseStation[bs].bc_prec_x_Portanti[subcarr] = NO_USER;
	BaseStation[bs].bc_x_Portanti[subcarr] = NO_USER;
	BaseStation[bs].bc_succ_x_Portanti[subcarr] = NO_USER;

	status[usr].NumOfLinks = 1;
	status[usr].ContTwoLinks = NO_LINK;
	status[usr].lastHOreq = 0;

    status[usr].in_HO = NO;                      /* aggiunto */

	BaseStation[bs].table[subcarr].assigned=0;
	BaseStation[bs].table[subcarr].inf=0;
	BaseStation[bs].table[subcarr].sign=0;
	BaseStation[bs].table[subcarr].activity=0;
	BaseStation[bs].table[subcarr].new_entry=0;
	
	BaseStation[altraBS].table[altrasubc].pack_lost += 
		BaseStation[bs].table[subcarr].pack_lost;

	BaseStation[bs].table[subcarr].pack_lost=0;
	BaseStation[bs].table[subcarr].pack_lost_x_HO=0;
	BaseStation[bs].table[subcarr].kind= NO_KIND;
	BaseStation[bs].table[subcarr].SubCarrierOf=NO_USER;

/*	printf("\n\tPacchetti inviati sul downlink del nuovo collegamento mentre e' attivo ");
	printf("anche il vecchio: %d", BaseStation[altraBS].table[altrasubc].sent); */

/*	printf("\n\n\tPacchetti totali inviati sul downlink prima del rilascio (esclusi quelli ");
	printf("sul nuovo collegamento): %d", BaseStation[bs].table[subcarr].sent); */
	
	BaseStation[altraBS].table[altrasubc].sent += BaseStation[bs].table[subcarr].sent;
	BaseStation[bs].sign_vett_succ_i[subcarr] = 0;

	BaseStation[bs].vettsubcfree[subcarr] = FREE;
	BaseStation[bs].Sottoportante_abilitata[subcarr] = NO;   /* aggiunto */

	/* se nella BS numero bs (BS vecchia) non ci sono sottoportanti libere, quella appena
	   liberata (numero subcarr) viene posta come "prima libera" in tale BS */

	if (BaseStation[bs].newsubcfree == NCARRIER)  
		BaseStation[bs].newsubcfree = subcarr;
}

					
/*-------------------------------------------------------------------------------------------*/


void HO_Procedure (int bs1, int bs2, int sign_vett_x_HO_entrante[], int bc_i[],
				   struct operation oper_time_succ_i[], int bc_succ_x_Portanti[],
				   int bc_x_Portanti[], int bc_prec_x_Portanti[])	

{ /* sign_vett_x_HO_entrante[]  l'insieme dei flag HB inviati alla BS numero bs1 dagli utenti
     provenienti dalla BS numero bs2 ( un campo della BS numero bs1) */

	int cnt, usr, i, clust;
	int j;  /* aggiunta */

	for (j=0; j<NMAX; j++)    /* aggiunto */
	{
		if (status[j].utente_attivo == ATTIVO)
			if ((status[j].in_HO == NO) && (status[j].HO_STEP == 5))
				status[j].HO_STEP = NESSUNO;
	}				


	BaseStation[bs2].profile_req[bs1] = BaseStation[bs2].succ_profile_req[bs1];
	
	HO_Step_1 (bs1, bs2, sign_vett_x_HO_entrante);                     /* HO_Step_1 */

	/* condizioni per ingresso in STEP2 (creazione della BCGS) */

	if (BaseStation[bs2].profile_req[bs1] > 0)

		for (cnt=0; cnt<NCARRIER; cnt++)  /* cnt  la generica sottoportante della BS numero
			                                 bs2 (BS di provenienza dell'utente in HO) */
		{
			i = BaseStation[bs2].table[cnt].SubCarrierOf;         /* aggiunto */

			if ((BaseStation[bs2].vettsubcfree[cnt] != FREE) 
				&& (BaseStation[bs2].Sottoportante_abilitata[cnt] == SI) 
				&& (BaseStation[bs2].ChiStaUscendo[cnt] == bs1) 
				&& (status[i].utente_attivo == ATTIVO))           /* controlli aggiunti */
			{				

				if ((frame % DIMMULTIFRAME >= 2) && (frame % DIMMULTIFRAME <= DIMMULTIFRAME-1))

					/* richieste di HO che arrivano alla BS dalla trama 1 alla trama 8 della
					   multitrama */
				{
                    status[i].HO_STEP = 21;
					HO_Step_2 (bs1, bs2, cnt, bc_x_Portanti);         /* HO_Step_2 (21) */					
				}

				else  /* le richieste di HO che arrivano nelle ultime 2 trame della multitrama
					     saranno soddisfatte al termine della multitrama successiva	*/
				{
                    status[i].HO_STEP = 22;
					HO_Step_2 (bs1, bs2, cnt, bc_succ_x_Portanti);    /* HO_Step_2 (22) */					
				}
			}
		}

	if (frame % DIMMULTIFRAME == DIMMULTIFRAME-1)
	{
		for (cnt=0; cnt < NCARRIER; cnt++)
			bc_succ_x_Portanti[cnt] = bc_x_Portanti[cnt];	/* aggiornamento della bc_succ
		                                                       creata dalla BS numero bs1 */
	}
	
	/*	preparazione per ingresso in STEP3	*/

	if ((frame % DIMMULTIFRAME) == DIMMULTIFRAME-1)

	{	/*	penultima trama della multitrama  */

		BaseStation[bs1].trasmetti_bc = 0;

		for (cnt=0; cnt < NCARRIER; cnt++)
		{
			if (bc_x_Portanti[cnt] != bc_prec_x_Portanti[cnt])
				BaseStation[bs1].trasmetti_bc = 1;

		/*	if (BaseStation[bs1].table[cnt].kind == VOICE)
			{
					gestisci la condivisione della stessa
					sottoportante tra 2 utenti voce
				
				BaseStation[bs1].trasmetti_bc = 1;
			}
		*/

		}

		if (BaseStation[bs1].trasmetti_bc == 1)  /* la bs1 deve trasmettere la BCGS */
		{
			oper_time_succ_i[BROADxPORTANTI].reserved = 1;
			oper_time_succ_i[BROADxPORTANTI].assigned = SUBC;
		}
	}

	if ((frame % DIMMULTIFRAME == 0)                                       /* ultima trama */
		&& (BaseStation[bs1].oper_time_i[BROADxPORTANTI].assigned == SUBC))

	{	
		HO_Step_3_bis (bs1, bs2);                                     /* HO_Step_3_bis */

		oper_time_succ_i[BROADxPORTANTI].reserved = 0;
		oper_time_succ_i[BROADxPORTANTI].assigned = NO_USER;
	}

	if (((frame % DIMMULTIFRAME) == 1) && (BaseStation[bs1].trasmetti_bc == 1))

	{	/*  HO_STEP_4 (prima trama della multitrama)  */

		for (usr=0; usr < NMAX; usr++)
		{
			if ((status[usr].myNextSubcarrier[bs1] != NO_USER) &&
				(status[usr].utente_attivo == ATTIVO))
			{

                 status[usr].HO_STEP = 4;                             
				 HO_Step_4 (bs1, bs2, usr);                           /* HO_Step_4 */
			}
		}

		BaseStation[bs1].trasmetti_bc = 0;
	}

	for (usr=0; usr < NMAX; usr++)
	{
		if (status[usr].utente_attivo == ATTIVO)        /* controllo aggiunto */
			
			for (clust=0; clust < CLUSTER; clust++)
				
				if (status[usr].quality_state[clust] == 3)
				{
					if (status[usr].NumOfLinks == 2)    /* controllo precauzionale */
					{
						status[usr].HO_STEP = 5; 						
						HO_Step_5 (clust, usr);                       /* HO_Step_5 */
					}
					
					else
					{
						printf("\n\nTrama %d: ERRORE NEL CHIAMARE HO STEP 5", frame);
					    printf ("\nSospendere la simulazione e capire qual e' la causa ");
					    printf ("di tale errore");
					    getchar();
					}
				}
	}
}


/*-------------------------------------------------------------------------------------------*/


void calc_sign_vett_succ_i (int bs, int leng_i,int bc_prec_i[],int bc_i[], int *val,int stat)
{
  int j=0, k=0, app, subc;

  subc = status[stat].mySubcarrier[bs];

  for(app=DOWNLINK+UP_RESERV+1;app<DIMFRAME;app++)  /* modificato ("+1") */
  {
	  if(bc_prec_i[app] == subc)
		j++;

	  if(bc_i[app] == subc)
		k++;
  }

  if (status[stat].last_req == 3)
	status[stat].last_req = 0;

  *val = (leng_i - j - 3*k);          /* stima della lunghezza del buffer tra 4 trame */

  if((*val)>0)
  {
	  if ((status[stat].last_req == 0)||(leng_i > 1))
	  {
		  *val = 1;
		  status[stat].last_req ++;
		  status[stat].MySubcarrierUse ++;
		  status[stat].MySubcUse[subc] ++;
	  }
	  else
	  {
		  *val = 0;
		  status[stat].last_req ++;
	  }
  }

  else
  {
	  *val = 0;
  }
}

/*-------------------------------------------------------------------------------------------*/


void calc_sign_vett_succ_i_con_due_BS (int leng_i, int stat)
{
	int j=0, k=0, app, clust, appbufleng=0, subc;
	int MSone=0, MStwoNew=0, MStwoOld=0;

	for (clust=0; clust < CLUSTER; clust++)
	{
		for(app=DOWNLINK+UP_RESERV+1; app < DIMFRAME; app++) /* modificato ("+1") */
		{
			if(BaseStation[clust].bc_prec_i[app] == status[stat].mySubcarrier[clust])
				j++;
			
			if(BaseStation[clust].bc_i[app] == status[stat].mySubcarrier[clust])
				k++;

		} /* alla fine del ciclo, j  pari al n di slot assegnati all'utente stat nella
		     trama i; k  pari al n di slot assegnati all'utente stat nella trama i+1 */

		if (status[stat].last_req >= 3)
			status[stat].last_req=0;
	}

	appbufleng = (leng_i-j-3*k);   /* stima della lunghezza del buffer tra 4 trame */

  if(appbufleng > 0)
  {
	  if ((status[stat].last_req == 0) || (leng_i > 1))
	  {
		  for (clust=0; clust < CLUSTER; clust++)
		  {
			  subc = status[stat].mySubcarrier[clust];

			  /* controllo */

			  if ((subc < 0) || (subc >= NCARRIER))
			  {
				 printf("\nTrama %d: ERRORE NEL CALCOLO DEL FLAG DI SEGNALAZIONE PER ", frame);
				 printf("UTENTE IN SHO");
				 getchar();
			  }

			  BaseStation[clust].sign_vett_succ_i[subc] = 1;

/* nuova procedura di Soft HO: per il momento l'abbassamento del flag effettuato dalla BS lo
   faccio qui (da migliorare !!!); aggiungere la condizione che si tratti di MS video e
   migliorare !!!!! */
			  
			  MSone = BaseStation[clust].tableMS.one_link;
			  MStwoNew = BaseStation[clust].tableMS.two_links_New;
			  MStwoOld = BaseStation[clust].tableMS.two_links_Old;

			  if (MSone > MAX_MS_ONE_LINK)
				  BaseStation[clust].sign_vett_succ_i[subc] = 0;
			  else
			  {

/* se il numero di MS one link  <= 8 ma quello di MS totali  > 10, se ce n' almeno una Old
   considero 0 il suo flag */
				  
				  if (((MSone + MStwoNew + MStwoOld) > MAX_MS_TOT) && (MStwoOld > 0))
				  {
					  if (status[stat].MyOldBS == clust)
						  BaseStation[clust].sign_vett_succ_i[subc] = 0;
				  }
			  }
			
			  status[stat].last_req ++;
			  status[stat].MySubcarrierUse ++;
			  status[stat].MySubcUse[subc] ++;
		  }
	  }
	  else

		for (clust=0; clust < CLUSTER; clust++)
		{
			subc = status[stat].mySubcarrier[clust];
			BaseStation[clust].sign_vett_succ_i[subc] = 0;
			status[stat].last_req ++;
		}
  }
  else

	  for (clust=0; clust < CLUSTER; clust++)
	  {
		  subc = status[stat].mySubcarrier[clust];

		  if (subc != NO_USER)
			  BaseStation[clust].sign_vett_succ_i[subc] = 0;
		  else
		  {
			  printf("\nTrama %d: ERRORE NELLA GESTIONE DEL DOPPIO COLLEGAMENTO", frame);
			  getchar();
		  }
	  }
}

/*-------------------------------------------------------------------------------------------*/


void calc_slot_richiesti (int stat)
{
	int appoggio=0, i, clust;
				
	status[stat].slots_to_ask+=
		status[stat].buffer_leng_prec_i-status[stat].buffer_leng_prec2_i;

	for(i=DOWNLINK+UP_RESERV+1;i<DIMFRAME;i++)   /* modificato ("+1") */
		for (clust=0; clust < CLUSTER; clust++)
		{
			if ((BaseStation[clust].bc_i[i] != NO_USER)
				&& (BaseStation[clust].bc_i[i] == status[stat].mySubcarrier[clust]))

			appoggio ++;   /* n di slot di uplink assegnati all'utente stat nella trama i+1 */
		}

	if (appoggio >= 0)
		status[stat].asse = appoggio;
}


/*-------------------------------------------------------------------------------------------*/


void calc_sign_vett_succ_per_HO_entrante (int * flag, int stat, int new_bs, int bs)
{
	if ((status[stat].HO_REQ) && (new_bs == bs)) /* il campo "HO_REQ"  1 se era pari a 2 il
												    campo "quality_state" dell'utente numero
													stat */
	{
		*flag = 1;

        status[stat].in_HO = SI;                 /* aggiunto (verr rimesso a 0 in HO_STEP_5,
						                            cio quando l'utente stat avr finito
						                            l'HO) */
		status[stat].HO_REQ = 0;
		status[stat].PossibleHOR ++;
	}

	else
		*flag = 0;
}


/*-------------------------------------------------------------------------------------------*/


void agg_clock (struct el_buff *punt)
{
  while  (punt!=NULL)
  {
	  punt->clock++;
	  punt=punt->next;
  }
}

/*-------------------------------------------------------------------------------------------*/


void agg_clock_BS (struct el_buff *punt)
{
  while  (punt!=NULL)
  {
	  punt->clock++;
  	  punt->BSclock++;
	  punt=punt->next;
  }
}

/*-------------------------------------------------------------------------------------------*/


struct el_buff *togli_celle_perse (struct el_buff *punt,int *punt_lost, float t_out, int clust,
								   int stat)
{
  struct el_buff *pippo;

  while ((punt != NULL) && (((punt->clock)*slot_duration) > t_out))
  {
	  pippo = punt;
	  punt = punt->next;

	  Risultati[stat].Pacchetti_generati_ma_persi_x_eccessiva_attesa_nel_suo_buffer ++; /* aggiunto */

	  Pacchetti_persi_x_eccessiva_attesa_nel_buffer_di_utente ++;           /* aggiunto */

	  Numero_totale_di_pacchetti_persi ++;                                  /* aggiunto */

	  (*punt_lost) ++;

	  if (status[stat].NumOfLinks == 1)
		  contapacklostup[clust] ++;
	  else
		  if(status[stat].NumOfLinks == 2)
			  contapacklostupMSinSHO ++;

	  if ((status[stat].NumOfLinks!=1) && (status[stat].NumOfLinks!=2))
	  {
			printf("\nERRORE NEL CALCOLO DEI PACCHETTI PERSI");
			getchar();
	  }

	  free (pippo);
  }

  return (punt);
}


/*-------------------------------------------------------------------------------------------*/

struct el_buff *togli_celle_perse_in_downlink_2 (struct el_buff *punt, int *pack_lost,
												 float t_out, int *lung, int stat, int bs,
												 int portante)
{
  struct el_buff *pippo;
  struct el_buff *altro_punt;
  int altra_portante;
  int altra_BS;

  while ((punt != NULL) && (((punt->clock)*slot_duration) > t_out))
  {
	  pippo = punt;
	  punt = punt->next;

	  Risultati[stat].Pacchetti_ad_esso_diretti_ma_persi_x_eccessiva_attesa_nel_buffer_di_ricez ++;

	  Pacchetti_persi_x_eccessiva_attesa_nei_BufRic ++;   /* aggiunto */

	  Numero_totale_di_pacchetti_persi ++;                /* aggiunto */

	  (*pack_lost) ++;
	  (*lung) --;

	  if (punt == NULL)
		  (*lung) = 0;

	  if (status[stat].NumOfLinks == 1)          /* aggiunto */
		  contapacklostdown[bs] ++;
	  else
		  if(status[stat].NumOfLinks == 2)       /* aggiunto */
			  contapacklostdownMSinSHO ++;

	  if (BaseStation[bs].Portante_in_SHO[portante].stato == SI)   /* aggiunto */
	  {
		  altra_portante = BaseStation[bs].Portante_in_SHO[portante].altra_portante;
	      altra_BS = BaseStation[bs].Portante_in_SHO[portante].altra_BS;

	      altro_punt = BaseStation[altra_BS].BufRic[altra_portante].buf;

		  if (altro_punt != NULL)
			  Elimina_eventuale_pacchetto (pippo, altra_portante, altra_BS);	  
	  }

	  free (pippo);
  }  

  return (punt);
}


/*-------------------------------------------------------------------------------------------*/


int generate_pack (int *stato,float *rest,int kind_of_serve,int user)
{
  long double poisson (int n, float lambda_value);    /* funzione dichiarata pi avanti */

  long double on_to_off;
  long double off_to_on;
  long double probab1,distr;

  float temp;
  float generated_bits_per_unit;
  float random,transition;
  float tot_bits;
  float bits;

  int pack_num=0;  
  int j,k;
  int statex;  
  int index;
   
/*-------------------------------------------------------------------------------------------*/

								/* bit generation for VOICE USERS */

  if (kind_of_serve == VOICE)
  {
	  on_to_off = 1.0-expl((long double)(-1.0*slot_duration/s0_on_mean));
	  off_to_on = 1.0-expl((long double)(-1.0*slot_duration/s0_off_mean));

	  temp = random_value();

	  if((*stato==TALK) && (temp<on_to_off))
		  *stato=SILENT;

	  else if((*stato==SILENT) && (temp<=off_to_on))
		  *stato=TALK;

	  if(*stato==TALK)
	  {
		  generated_bits_per_unit=(float)(s0_on_rate*slot_duration);

	      if((*rest=(*rest+generated_bits_per_unit))>PACK_SIZE)
		  {
			  pack_num=(int)(*rest/PACK_SIZE);
		      *rest = (*rest-(pack_num*PACK_SIZE));
		  }
	  }

	  return(pack_num);
  }

/*-------------------------------------------------------------------------------------------*/

							 /* bit generation for video H.263 users */

  if ((kind_of_serve==VIDEO1MBPS)&&(slot==31))  /* suppongo che le celle siano generate a met
												   trama */
  {
	  tot_bits=0.0;
	  index=0;

	  for(;;)
	  {
		  if (status[user].cycle_state==0)
		  {
			  random=ran0(&(idum));
		      j=0;
		      statex=status[user].state;
		      transition=matrix[statex][0];

		      while (random>transition)
			  {
				  j++;
	              transition = transition+matrix[statex][j];
			  }

		      statex=j;

		      if (statex > 20)
				  statex=(statex%20);

		      status[user].state=statex;
		  }

	      for (;status[user].cycle_state<CYCLE_VIDEO;)
		  {
			  random = ran0(&(idum));
		      probab1 = (long double)random;
		      k=0;
		      distr = poisson(k,bitrate_vect[status[user].state]);

		      while (distr<probab1)
			  {
				  if (k == 900)
				  {
				//	  printf("error");   /* cosa vuol dire ? */
			          goto salta;
				  }
				    
			      k=k+1;

		          distr = distr+poisson(k,bitrate_vect[status[user].state]);
			  }
salta:
		      bits=(float)(OSCFACT*k);
		      tot_bits=tot_bits+bits;
		      index++;
		      (status[user].cycle_state)++;

		     if (index==STEPS_PER_TRAN_FRAME)
			 {
				 if((*rest=(*rest+(int)tot_bits))>PACK_SIZE)
				 {
					 pack_num=(int)(*rest/PACK_SIZE);
			         *rest = (*rest-(pack_num*PACK_SIZE));
				 }

		         return(pack_num);
			 }
		  }

	      status[user].cycle_state=0;
	  }
  }

/*-------------------------------------------------------------------------------------------*/

							/* bit generation for DATA USERS a 64KBPS */

  if (kind_of_serve == 3)
  {
	  generated_bits_per_unit=(float)(RATE64KBPS*slot_duration);

	  if((*rest=(*rest+generated_bits_per_unit))>PACK_SIZE)
	  {
		  pack_num=(int)(*rest/PACK_SIZE);
	      *rest = (*rest-(pack_num*PACK_SIZE));
	  }

	  return(pack_num);
  }

/*-------------------------------------------------------------------------------------------*/

							/* bit generation for DATA USERS a 512KBPS */

  if (kind_of_serve == 4)
  {
	  generated_bits_per_unit=(float)(RATE512KBPS*slot_duration);

	  if((*rest=(*rest+generated_bits_per_unit))>PACK_SIZE)
	  {
		  pack_num=(int)(*rest/PACK_SIZE);
	      *rest = (*rest-(pack_num*PACK_SIZE));
	  }

	  return(pack_num);
  }

/*-------------------------------------------------------------------------------------------*/			
	 

  else                           /* no packet generated by anyone */
	 return(pack_num=0);
}

/*-------------------------------------------------------------------------------------------*/


long double poisson (int n, float lambda_value)
{
  long double  prob_gener_n;
  long double lam_per_time;

  lam_per_time = (((lambda_value)*(PICTURE_FRAME_TIME/(float)DIVIDER)));

  prob_gener_n = (powl(lam_per_time,((long double)n))*expl((long double)-lam_per_time))/
				  factorial_vect[(int)n];

  return(prob_gener_n);
}

/*-------------------------------------------------------------------------------------------*/


struct el_buff *agg_pack_x_PS (struct el_buff *punt, int newpack,int from)
{
	struct el_buff *puntapp, *puntapp2;
	int clust;

	if (newpack>0)
	{
		puntapp = punt;

		if (puntapp != NULL)
		{
			while (puntapp->next != NULL)
				puntapp = puntapp->next;

			while (newpack>0)
			{
				puntapp2 = (struct el_buff *)malloc(sizeof(struct el_buff));

				for (clust=0; clust < CLUSTER; clust++)
					puntapp2->quality[clust] = status[from].quality_state[clust];

				puntapp2->clock=0;
				puntapp2->BSclock=0;
				puntapp2->info=-1000;
				puntapp2->num=status[from].last_pack_number;
				puntapp2->dest=status[from].destinazione;

				status[from].last_pack_number ++;

				puntapp2->from=from;
				puntapp2->next=NULL;
				puntapp->next=puntapp2;
				puntapp=puntapp2;

				newpack--;
			}
		}

		else   /* il buffer  vuoto */
		{
			punt=(struct el_buff *)malloc(sizeof(struct el_buff));
			
			for (clust=0; clust < CLUSTER; clust++)
				punt->quality[clust] = status[from].quality_state[clust];

			punt->clock=0;
			punt->BSclock=0;
			punt->from=from;
			punt->info=-1000;
			punt->num=status[from].last_pack_number;
			punt->dest=status[from].destinazione;

			if ( abs(punt->dest-punt->from) != 1 )
			{
				printf("\n\nScambio di coppie.");
				getchar();
			}

			status[from].last_pack_number ++;

			punt->next=NULL;
			puntapp=punt;

			newpack --;

			while(newpack>0)
			{
				puntapp2=(struct el_buff *)malloc(sizeof(struct el_buff));
				
				for (clust=0; clust < CLUSTER; clust++) 
					puntapp2->quality[clust] = status[from].quality_state[clust];

				puntapp2->clock=0;
			    puntapp2->BSclock=0;
				puntapp2->from=from;
				puntapp2->info=-1000;
				puntapp2->num=status[from].last_pack_number;
				puntapp2->dest=status[from].destinazione;

				status[from].last_pack_number ++;

				puntapp2->next=NULL;
				puntapp->next=puntapp2;
				puntapp=puntapp2;

				newpack--;
			}
		}
	}

	return(punt);
}


/*-------------------------------------------------------------------------------------------*/

struct el_buff *agg_pack (struct el_buff *punt, int newpack)
{
  struct el_buff *puntapp, *puntapp2;

  if (newpack>0)
  {
	  puntapp=punt;

	  if (puntapp!=NULL)
	  {
		  while(puntapp->next!=NULL)
			  puntapp=puntapp->next;

	      while(newpack>0)
		  {
			puntapp2=(struct el_buff *)malloc(sizeof(struct el_buff));
			puntapp2->clock=0;
			puntapp2->next=NULL;
			puntapp->next=puntapp2;
			puntapp=puntapp2;
			newpack--;
		  }
	  }
	  else   
	  {
		  punt = (struct el_buff *)malloc(sizeof(struct el_buff));
	      punt->clock=0;
	      punt->next=NULL;
	      puntapp=punt;
	      newpack--;

	      while(newpack>0)
		  {
			  puntapp2 = (struct el_buff *)malloc(sizeof(struct el_buff));
		      puntapp2->clock=0;
		      puntapp2->next=NULL;
		      puntapp->next=puntapp2;
		      puntapp=puntapp2;
		      newpack--;

		  }
	  }
  }

  return(punt);
}


/*-------------------------------------------------------------------------------------------*/

/* Tale funzione trasferisce il pacchetto puntato da puntpacket e destinato all'utente dest
   direttamente dal buffer di utente al buffer di ricezione dell'utente dest. Se l'utente
   dest  in Soft HO, allora la BS numero "destBS" trasferisce tale pacchetto anche nel buffer
   di ricezione della vecchia BS (BS da cui l'utente dest sta uscendo) */	

void Transfert_2 (struct el_buff *puntpacket, int dest)
{
	int destBS, subcarrier;
	int altraBS;
	int altra_sottoportante;
	struct el_buff *puntapp;
	struct el_buff *copia;
	
	destBS = HomeLocReg[dest]; /* se l'utente  in Soft HO (passi 3-5 di HO) allora il buffer
							      di ricezione  quello contenuto nella nuova BS (cio destBS
	                               la nuova BS) */
	subcarrier = 0;
	
	while ((BaseStation[destBS].table[subcarrier].SubCarrierOf != dest) 
		&& (subcarrier < NCARRIER))        
																	      
		subcarrier ++;
		
	if (BaseStation[destBS].BufRic[subcarrier].buf == NULL)   /* anche se "subcarrier" non  
															     attiva */
	
	/* il buffer della BS di destinazione  vuoto */
															      
	{
		BaseStation[destBS].BufRic[subcarrier].buf = puntpacket;
		BaseStation[destBS].BufRic[subcarrier].buf->next = NULL;
		BaseStation[destBS].BufRic[subcarrier].lenght = 1;
	}

	else
		if (BaseStation[destBS].BufRic[subcarrier].buf != NULL)	/* anche se "subcarrier" non  
															       attiva */		

	    /* il buffer della BS non  vuoto (il pacchetto viene aggiunto in coda a BufRic) */

		{			
			puntapp = BaseStation[destBS].BufRic[subcarrier].buf;

		    while(puntapp->next != NULL)
				puntapp = puntapp->next;
		
		    puntapp->next = puntpacket;
		    puntapp->next->next = NULL;

		    BaseStation[destBS].BufRic[subcarrier].lenght ++;

		    puntapp = NULL;
		}

	/* se l'utente  in Soft HO, allora il pacchetto deve essere trasferito anche nel buffer
	   dell'altra BS (altraBS) */

	if (BaseStation[destBS].Portante_in_SHO[subcarrier].stato == SI)  /* utente in Soft HO */
	{
		altraBS = BaseStation[destBS].Portante_in_SHO[subcarrier].altra_BS;
		altra_sottoportante = BaseStation[destBS].Portante_in_SHO[subcarrier].altra_portante;

		if (BaseStation[destBS].Portante_in_SHO[subcarrier].utente != dest)
		{
			printf ("\n\nErrore in Transfert 2");
			getchar ();
		}

		copia = Duplica_pacchetto (puntpacket);

		if (BaseStation[altraBS].BufRic[altra_sottoportante].buf == NULL)  
	
	    /* il buffer della BS di destinazione  vuoto */
															      
		{
			BaseStation[altraBS].BufRic[altra_sottoportante].buf = copia;
		    BaseStation[altraBS].BufRic[altra_sottoportante].buf->next = NULL;
		    BaseStation[altraBS].BufRic[altra_sottoportante].lenght = 1;
		}

	    else if (BaseStation[altraBS].BufRic[altra_sottoportante].buf != NULL)			

	    /* il buffer della BS non  vuoto (il pacchetto viene aggiunto in coda a BufRic) */

		{			
			puntapp = BaseStation[altraBS].BufRic[altra_sottoportante].buf;

		    while (puntapp->next != NULL)
				puntapp = puntapp->next;
		
		    puntapp->next = copia;
		    puntapp->next->next = NULL;

		    BaseStation[altraBS].BufRic[altra_sottoportante].lenght ++;

		    puntapp = NULL;
		}

	} /* fine "if (BaseStation[destBS].Portante_in_SHO[subcarrier].stato == SI)" */	

}

/*-------------------------------------------------------------------------------------------*/


void copy (int vett1[],int vett2[],int dim)
{
  int i;

  for(i=0;i<dim;i++)
  {
      vett2[i] = vett1[i];
  }
}


/*-------------------------------------------------------------------------------------------*/


void agg_oper_x_uplink   (int bc_succ_i[],struct operation oper_time_succ2_i[])
{
  int i;

  for(i=DOWNLINK+UP_RESERV;i<DIMFRAME;i++)
  {
	  if (i != ACCESS_SLOT)                                  /* aggiunto */
		  oper_time_succ2_i[i].assigned = bc_succ_i[i];
  }
}

/*-------------------------------------------------------------------------------------------*/


void copy_opr (struct operation vett1[],struct operation vett2[])
{
  int i;

  for (i=0;i<DIMFRAME;i++)
  {
      vett2[i].reserved = vett1[i].reserved;
      vett2[i].assigned = vett1[i].assigned;
  }
}

/*-------------------------------------------------------------------------------------------*/

void copy_infopack ( struct inf infopack_1[],struct inf infopack_2[])
{
  int i;
  
  for (i=0;i<DIMFRAME;i++)
  {
	  infopack_2[i].ps = infopack_1[i].ps;
      infopack_2[i].info = infopack_1[i].info;
  }
} 


/*-------------------------------------------------------------------------------------------*/

void init_video_generation ()
{
  int i,j;
  long double fact, n=0.00 ;
  float prob,bitrate;
  FILE *point_read,*point_read2;
  
  for (i=0;i<997;i++)
  {
	  if ((i==1)||(i==0))
		  fact=1.00;

      else
	  {
		  fact=1.00;

	      for(n=1.00;n<=i;n=n+1.00)
			  fact=fact*n;
	  } 

      factorial_vect[i]=fact;
  }
  
  point_read = fopen("matrix","r");

  for(i=0;i<QUANTINT;i++)
  {
	  for(j=0;j<QUANTINT;j++)
	  {
		  fscanf(point_read,"%f",&prob);
	      matrix[i][j]=prob;
	  }
  }

  fclose(point_read);

  point_read2 = fopen("lambda","r");

  for(i=0;i<QUANTINT;i++)
  {
	  fscanf(point_read2,"%f",&bitrate);

	  bitrate_vect[i]=bitrate;

   // printf("\n lambda%i = %f",i,bitrate);
  }

// printf("\nvideo generation\n");

}


/*-------------------------------------------------------------------------------------------*/


void calc_infopack_i (int infopunt,int st,int clst)
{
  if (status[st].slots_to_ask==0)
	 BaseStation[clst].infopack_i[infopunt].info=0;

  if (status[st].slots_to_ask>0)
  {
	  BaseStation[clst].infopack_i[infopunt].info=1;
	  status[st].slots_to_ask--;
  }

  if (status[st].slots_to_ask<0)
  {
	  BaseStation[clst].infopack_i[infopunt].info=-1;
	  status[st].slots_to_ask++;
  }

  BaseStation[clst].infopack_i[infopunt].ps = status[st].mySubcarrier[clst];

}


/*-------------------------------------------------------------------------------------------*/


/* Questa funzione elimina il contenuto di tutti i buffer al termine delle singole simulazioni
   eseguite */

void DistruggiTutto()
{
	int i,bs;
	struct el_buff *puntaux; 

/* cominciamo con le MS (buffer di utente) */

	for(i=0;i<NMAX;i++)	
		while(punt_buffer[i]!=NULL)
		{
			puntaux = punt_buffer[i];
			punt_buffer[i] = punt_buffer[i]->next;
			free(puntaux);
		}

/* adesso tocca alle BS (buffer di ricezione) */

	for(bs=0;bs<CLUSTER;bs++)
	{

		for(i=0;i<NCARRIER;i++)
		{
			BaseStation[bs].BufRic[i].lenght = 0;

			while (BaseStation[bs].BufRic[i].buf != NULL)
			{
				puntaux = BaseStation[bs].BufRic[i].buf;
				BaseStation[bs].BufRic[i].buf = BaseStation[bs].BufRic[i].buf->next;
				free(puntaux);
			}
		}
	}
} 


/*-------------------------------------------------------------------------------------------*/


											/* MAIN */


int main()
{
									 /* VARIABILI DEL MAIN */


	int ll, axes, clust, bs, bs1, bs2, utente, contabuf;

	int Pacchetti_generati=0; /* serve per i risultati finali */
	int Pacchetti_ricevuti=0; /* serve per i risultati finali */	
	
	int infopunt[CLUSTER];
	int stat,subcarr;
	int newpack,QuanteSimulazioni;
	int i, simulazione;
	int appsubcarr, appbs, clt, clster;
	int utente_sorg, utente_dest;
	int k, j;
	     
	int mobility;
	int packlostup[CLUSTER], totpacklostup, totpacklostupMSinSHO;  /* per i risultati finali */

	int TIMEOFHO;      /* numero medio di trame che passano tra due successive richieste di HO
					      (ad esempio un TIMEOFHO pari a 667 dovrebbe essere equivalente a una
					      probabilit di HO pari a 1.5*e-3). Dovrei ottenere circa 240 HO
						  realizzati in 10000 trame */
	
	int	TIMEOFSOFTHO;  /* numero medio di trame di permanenza nello stato di qualit 2, pari  
						  al tempo medio di mantenimento del doppio collegamento ( legato alla
						  velocita' delle MS ed all'area di sovrapposizione tra le celle e pu
						  valere ad es. 167) */
	
	int contaMS[CLUSTER], contaMSinSHO[CLUSTER], contawinframes;  /* usate per analizzare il 
																	 legame tra pacchetti persi
																	 ed MS presenti nella 
																	 cella */

	int lastpacknum[NMAX], out_of_seq[NMAX];  /* servono per contare i pacchetti ricevuti fuori
												 sequenza */	

	long int app_pack_sent_down;
    long int appdel;
	long int app_pack_sent;	   /* per calcolare i pacchetti tx in uplink da una MS verso
								  entrambe le BS per il calcolo del ritardo medio di uplink */	

	double del,totdel;
																 
	float meanMS[CLUSTER], meanMSinSHO[CLUSTER];	

	char AuxVetChar[5] = "num";
	char NomeDefinitivo[60];
	char AuxChar[5] = "mob";    

	/* vettore usato per scrivere i risultati finali in funzione del solo numero medio di MS 
	   presenti (una MS in SHO viene considerata come mezza MS) */	

	struct record_tabpacklost global_vett_packlost[2*(NCARRIER+1)];	  /* vettore */	

	struct el_buff *pippo;  /* puntatore ad un pacchetto */		

	FILE *pfile;  /* file in cui, al termine della simulazione, vengono scritti i risultati */


/*-------------------------------------------------------------------------------------------*/


                                 /* NUOVE VARIABILI DEL MAIN */
	

	struct UtentiPresenti utenti;
	struct el_buff *altro_punt;
	
	int altra_portante;
	int altra_BS;
	
	int packlostdown[CLUSTER];
	int totpacklostdownMSinSHO;

	int Utenti_tutti_non_attivi = NO;
	int numero_di_trama = -5;
	int numero = 0;
	int somma_utenti = 0;

	unsigned long int Somma_di_tutti_i_BSclock = 0;
	unsigned long int Somma_dei_pacchetti_che_sono_stati_in_attesa = 0;
	unsigned long int Somma_di_tutti_i_tempi_di_attesa = 0;
	unsigned long int Somma_dei_pacchetti_generati_e_non_persi_in_uplink = 0;
	unsigned long int Somma_dei_pacchetti_generati_e_giunti_a_destinazione = 0;
	unsigned long int Somma_di_tutti_i_ritardi_totali = 0;
	
/*-------------------------------------------------------------------------------------------*/


                                    /* INIZIO ELABORAZIONE */
	

srand((unsigned)time(NULL)); /* tale funzione inizializza, con il tempo di sistema, il seme
								usato dalla funzione "rand()" e serve per rendere pi
								randomico il valore restituito da questa funzione */

init_UtentiPresenti (&utenti);   /* viene inizializzata la variabile del main "utenti" che 
                                    di tipo struct "UtentiPresenti" */

QuanteSimulazioni = Notizie_utenti_new (&utenti);


                                     /* CICLO SIMULAZIONE */

	  
for(simulazione=0; simulazione<QuanteSimulazioni; simulazione++) /* inizio ciclo simulazione */
{
	for(mobility=3; mobility<4; mobility++)   /* inizio ciclo mobility */
	{ 
	  if (mobility == 1)     /* TIMEOFSOFTHO/TIMEOFHO = 1/10 e TIMEOFSOFTHO+TIMEOFHO = 6667  
							    (piccola area di sovrapposizione e mobilit bassa cio
								 probabilit di HO = 0.00015) */
	  {
		  TIMEOFHO = 6061;
		  TIMEOFSOFTHO = 606;
	  }

	  if (mobility == 2)     /* TIMEOFSOFTHO/TIMEOFHO = 1/10 e TIMEOFSOFTHO+TIMEOFHO = 667
							    (piccola area di sovrapposizione e mobilit media cio
								 probabilit di HO = 0.0015) */
	  {
		  TIMEOFHO = 606;
		  TIMEOFSOFTHO = 61;
	  }

	  if (mobility == 3)     /* TIMEOFSOFTHO/TIMEOFHO = 1/4 e TIMEOFSOFTHO+TIMEOFHO = 6667
							    (media area di sovrapposizione e mobilit bassa cio
								 probabilit di HO = 0.00015) */
	  {
		  TIMEOFHO = 5334;
		  TIMEOFSOFTHO = 1333;
	  }

	  if (mobility == 4)     /* TIMEOFSOFTHO/TIMEOFHO = 1/4 e TIMEOFSOFTHO+TIMEOFHO = 667
							    (media area di sovrapposizione e mobilit media cio
								 probabilit di HO = 0.0015) */
	  {
		  TIMEOFHO = 534;
		  TIMEOFSOFTHO = 133;
	  }

	  if (mobility == 5)     /* TIMEOFSOFTHO/TIMEOFHO = 1/4 e TIMEOFSOFTHO+TIMEOFHO = 200
							    (media area di sovrapposizione e mobilit alta cio
								 probabilit di HO = 0.005) */
	  {
		  TIMEOFHO = 160;
		  TIMEOFSOFTHO = 40;
	  }

	  if (mobility == 6)     /* TIMEOFSOFTHO/TIMEOFHO = 1/2 e TIMEOFSOFTHO+TIMEOFHO = 6667
							    (grande area di sovrapposizione e mobilit bassa cio 
								 probabilit di HO = 0.00015) */
	  {
		  TIMEOFHO = 4445;
		  TIMEOFSOFTHO = 2222;
	  }	  

	  if (mobility == 7)     /* TIMEOFSOFTHO/TIMEOFHO = 1/2 e TIMEOFSOFTHO+TIMEOFHO = 667
							    (grande area di sovrapposizione e mobilit media cio
								 probabilit di HO = 0.0015) */
	  {
		  TIMEOFHO = 445;
		  TIMEOFSOFTHO = 222;
	  }
	  

/*-------------------------------------------------------------------------------------------*/
	  

									 /* INIZIALIZZAZIONI */
	

	Inizializza_alcune_variabili_globali ();  /* aggiunta */

	Inizializza_alcune_variabili_del_main (Pacchetti_generati, Pacchetti_ricevuti, 
		                                   Somma_di_tutti_i_BSclock, 
										   Somma_dei_pacchetti_che_sono_stati_in_attesa,
										   Somma_di_tutti_i_tempi_di_attesa,
										   Somma_dei_pacchetti_generati_e_non_persi_in_uplink,
										   Somma_dei_pacchetti_generati_e_giunti_a_destinazione,
										   Somma_di_tutti_i_ritardi_totali, numero_di_trama,
										   Utenti_tutti_non_attivi, numero, somma_utenti);	
	
	AuxVetChar[3]=(char)simulazione +'0';  /* nel quarto elemento del vettore AuxVetChar viene
										      posto un numero pari al valore contenuto nella
											  variabile "simulazione" */
	AuxVetChar[4]='\0'; 

	strcpy(NomeDefinitivo,NomeFileUscita); /* la stringa "NomeFileUscita" viene copiata nel
										      vettore "NomeDefinitivo" */
	  
	AuxChar[3]=(char)mobility + '0';       /* nel quarto elemento del vettore AuxChar viene
										      posto un numero pari al valore contenuto nella
											  variabile "mobility" */
	AuxChar[4]='\0';

	strcat(NomeDefinitivo,AuxChar);        /* alla stringa "NomeDefinitivo" viene aggiunta la
										      stringa "AuxChar" */

	strcat(NomeDefinitivo,AuxVetChar);     /* alla stringa "NomeDefinitivo" viene aggiunta la
										      stringa "AuxVetChar" */

	strcat(NomeDefinitivo,Extention);      /* alla stringa "NomeDefinitivo" viene aggiunta la
										      stringa "Extention" */

	printf("\n%s",NomeDefinitivo);         /* viene stampata la stringa "NomeDefinitivo" */


	/* Inizializzazioni necessarie per i risultati finali */

	Inizializza_Risultati ();                                        /* aggiunta */

	Inizializza_Causa_della_terminazione (collegamenti_terminati);   /* aggiunta */

    /* Inizializzazione delle stazioni mobili (MS) */

	init_status (status,NMAX);
	initbuffer (punt_buffer,NMAX);
	initHLR (status);

	inizializza_vettori_globali (NMAX);   /* aggiunta */


/*-------------------------------------------------------------------------------------------*/

  for (clust=0;clust<CLUSTER;clust++)
  {
	assigned[clust]=0;              /* serve per i risultati finali */
	used[clust]=0;                  /* serve per i risultati finali */
	non_used[clust]=0;              /* serve per i risultati finali */
	assigned_down[clust]=0;         /* serve per i risultati finali */
	used_down[clust]=0;             /* serve per i risultati finali */
	non_used_down[clust]=0;         /* serve per i risultati finali */

    /* Inizializzazione delle stazioni radio base */

	BaseStation[clust].tableMS.one_link = (utenti_video_collegati + utenti_voce_collegati)/2;
	BaseStation[clust].tableMS.two_links_New = 0;
	BaseStation[clust].tableMS.two_links_Old = 0;

	BaseStation[clust].ciclo_video=0;
	BaseStation[clust].ciclo_random=0;
	BaseStation[clust].ciclo_data=0;

	BaseStation[clust].firstvideovocenoserved=0; /* usato in "CalcBroadCastCell_x_Downlink" */
	BaseStation[clust].firstdatanoserved=0;      /* usato in "CalcBroadCastCell_x_Downlink" */
	BaseStation[clust].videonoserved=0;

	BaseStation[clust].HO_non_realizzati=0;
  }

  for (clust=0; clust<CLUSTER; clust++)
  {
	for(bs=0; bs<CLUSTER; bs++)
	{
		initialise (BaseStation[clust].dallaBS[bs].sign_vett_prec_x_HO_entrante,NCARRIER);
		initialise (BaseStation[clust].dallaBS[bs].sign_vett_x_HO_entrante,NCARRIER);
		initialise (BaseStation[clust].dallaBS[bs].sign_vett_succ_x_HO_entrante,NCARRIER);
	};

	initialise (BaseStation[clust].ChiStaUscendo,NCARRIER);
	initialise (BaseStation[clust].bc_prec_i,DIMFRAME);
	initialise (BaseStation[clust].bc_i,DIMFRAME);
	initialise (BaseStation[clust].bc_succ_i,DIMFRAME);

	initialise_sign (BaseStation[clust].sign_vett_prec_i,NCARRIER);
	initialise_sign (BaseStation[clust].sign_vett_i,NCARRIER);
	initialise_sign (BaseStation[clust].sign_vett_succ_i,NCARRIER);
	
	init_oper_time (BaseStation[clust].oper_time_i);
	init_oper_time (BaseStation[clust].oper_time_succ_i);
	init_oper_time (BaseStation[clust].oper_time_succ2_i);

	init_infopack (BaseStation[clust].infopack_prec_i,DIMFRAME);
	init_infopack (BaseStation[clust].infopack_i,DIMFRAME);
		
	BaseStation[clust].newsubcfree = init_tab (BaseStation[clust].table, status, clust,
		                                       BaseStation[clust].bc_succ_x_Portanti);	
	
	copy (BaseStation[clust].bc_succ_x_Portanti, BaseStation[clust].bc_prec_x_Portanti, 
		  NCARRIER);

	copy (BaseStation[clust].bc_succ_x_Portanti, BaseStation[clust].bc_x_Portanti, NCARRIER);
	
	
	for(i=0; i<NCARRIER; i++)
	{
		BaseStation[clust].conta_time_not_free[i] = 0;
		BaseStation[clust].Use_of_subc_gross[i] = 0;

		BaseStation[clust].Portante_in_SHO[i].stato = NO;                 /* aggiunto */
		BaseStation[clust].Portante_in_SHO[i].utente = NO_USER;           /* aggiunto */
		BaseStation[clust].Portante_in_SHO[i].altra_portante = NO_USER;   /* aggiunto */
		BaseStation[clust].Portante_in_SHO[i].altra_BS = NO_USER;         /* aggiunto */

		if(i < BaseStation[clust].newsubcfree)             
			BaseStation[clust].vettsubcfree[i] = NOT_FREE;
		else
			BaseStation[clust].vettsubcfree[i] = FREE;      
	}
	
	initbufferRic (BaseStation[clust].BufRic, NCARRIER);

	for(bs=0; bs<CLUSTER; bs++)
		BaseStation[clust].profile_req[bs] = 0;

  };  /* fine ciclo for */

/*-------------------------------------------------------------------------------------------*/


  /* Altre inizializzazioni */

  init_video_generation ();

  for(i=0;i<NMAX;i++)
		status[i].slots_to_ask = 0;

  for(i=1;i<3;i++)             /* 2 sono i tipi di servizio (Voce e Video) */
		init_destination (i);


/*-------------------------------------------------------------------------------------------*/								   


  /* Ulteriore inizializzazione delle stazioni radio base */

  for (clust=0; clust<CLUSTER; clust++)
  {
        BaseStation[clust].trasmetti_bc = 0;

		for (bs=0; bs<CLUSTER; bs++)
			 BaseStation[clust].succ_profile_req[bs] = 0;

													  
		for (utente=0; utente < NMAX; utente++)
			 status[utente].myNextSubcarrier[clust] = NO_USER; /* inizializzazioni importanti 
																  per HO */
  }

/*-------------------------------------------------------------------------------------------*/


                /* Inizializzazioni necessarie per scrivere i risultati finali */


  for (ll=0; ll<NMAX; ll++)   
  {
		tot_pack_sent[ll] = 0;                       /* variabile globale */		
		lastpacknum[ll] = 0;
		out_of_seq[ll] = 0;                          /* variabile del main */
  }  
	
  for (clust=0; clust<CLUSTER; clust++)
  {
		contaMS[clust] = 0;
		contaMSinSHO[clust] = 0;

		meanMS[clust] = 0.0;
		meanMSinSHO[clust] = 0.0;

		/* nei seguenti due cicli prima c'era NMAX */

		for (k=0; k<=NCARRIER; k++)			/* k = numero di utenti presenti in una cella */
			for (j=0; j<=NCARRIER; j++)	    /* j = numero di utenti in Soft HO */

			{
				table_packlost[clust].single_tabpacklost[k][j].packet_lost = 0.0;
				table_packlost[clust].single_tabpacklost[k][j].time = 0.0;
				table_packlost[clust].single_tabpacklost[k][j].req_assigned = 0.0;
				table_packlost[clust].single_tabpacklost[k][j].random_assigned = 0.0;

				Pacchetti_persi_in_downlink[clust].tabella[k][j].pacchetti_persi = 0.0;
				Pacchetti_persi_in_downlink[clust].tabella[k][j].tempo = 0.0;

				global_table_packlost.single_tabpacklost[k][j].packet_lost = 0.0;
				global_table_packlost.single_tabpacklost[k][j].time = 0.0;
				global_table_packlost.single_tabpacklost[k][j].req_assigned = 0.0;
				global_table_packlost.single_tabpacklost[k][j].random_assigned = 0.0;
			}

		/* nel seguente ciclo prima c'era NMAX */

	    for (k=0; k<=(2*NCARRIER+1); k++)   /* k/2 = numero di utenti presenti in una cella */
		{
			global_vett_packlost[k].packet_lost = 0.0;
			global_vett_packlost[k].time = 0.0;
		}

		contapacklostup[clust] = 0;
		contapacklostdown[clust] = 0;   /* aggiunto */
		packlostup[clust] = 0;
		packlostdown[clust] = 0;        /* aggiunto */

		assigned_random_up[clust] = 0;
		assigned_random_down[clust] = 0;

		conta_tot_del_req[clust] = 0;
		conta_del_req_slot_ass[clust] = 0;
		conta_random_slot_ass[clust] = 0;
  }

  contapacklostupMSinSHO = 0;
  contapacklostdownMSinSHO = 0;         /* aggiunto */
  contawinframes = 0;

  totpacklostup = 0;
  totpacklostupMSinSHO = 0;
  totpacklostdownMSinSHO = 0;           /* aggiunto */

  appoggioslot = 0;   /* variabile globale usata per i risultati finali */


/*-------------------------------------------------------------------------------------------*/


							/* INIZIO EFFETTIVO DELLA SIMULAZIONE */


                                      /* CICLO FRAME */
	

for (frame = 1; frame <= NUMFRAME; frame ++)   /* Primo ciclo temporale (riguarda le azioni
										          compiute trama per trama) */
{
	numero = Controlla_quanti_utenti_sono_attivi (numero_di_trama, Utenti_tutti_non_attivi, &somma_utenti);

	if (frame % 300 == 0)
		printf("\n\nTrama %d", frame);

	if (frame % 4950 == 0)	
		printf ("\n\nTrama numero %d: il numero di utenti attivi e' %d\n", frame, numero);
	
	if ((frame % DIMMULTIFRAME) == 2)         /* inizio della seconda trama della multitrama */

	{   /* l'aggiornamento delle bc x Portanti deve essere fatto alla fine della prima trama 
		   della multitrama (cio all'inizio della seconda trama della multitrama) in modo che
		   la "bc_succ_x_Portanti" gi tenga conto degli utenti che hanno richiesto HO nelle
		   ultime 2 trame della multitrama precedente */			

		for (clust=0; clust < CLUSTER; clust++)
		{
			/* aggiornamento della BCGS inviata dalla BS numero clust */

			copy (BaseStation[clust].bc_x_Portanti, BaseStation[clust].bc_prec_x_Portanti,
				  NCARRIER);

			copy (BaseStation[clust].bc_succ_x_Portanti, BaseStation[clust].bc_x_Portanti,
				  NCARRIER);
		}
	}

	Procedura_di_Richiesta_e_Assegnazione_delle_Sottoportanti ();  /* aggiunta */

	for (clust=0; clust < CLUSTER; clust++)	
		infopunt[clust] = DOWNLINK + UP_RESERV + 1;  /* modificato (aggiunto "+1") */    	

	for (clust=0; clust < CLUSTER; clust++)    /* ciclo for molto importante */
	{		
		CalcBroadCastCell_x_Downlink(BaseStation[clust].BufRic,BaseStation[clust].table,
			                         BaseStation[clust].bc_i,BaseStation[clust].oper_time_i,
									 clust, &utenti);
		
		calc_broad_succ_i_x_uplink(BaseStation[clust].table,BaseStation[clust].infopack_prec_i,
		                           BaseStation[clust].sign_vett_prec_i,
								   BaseStation[clust].sign_vett_i,BaseStation[clust].bc_succ_i,
								   clust);
		
		agg_oper_x_downlink (BaseStation[clust].bc_i,BaseStation[clust].oper_time_succ_i,0);
		
		agg_oper_x_uplink (BaseStation[clust].bc_succ_i,BaseStation[clust].oper_time_succ2_i);
	}

    /* Mediante il seguente ciclo, ciascuna stazione mobile (MS) attiva calcola il valore del
	   flag di segnalazione SB (se una MS ha 2 sottoportanti, calcolo il flag di segnalazione
	   da inviare su entrambi i collegamenti) */

	for (stat=0; stat < NMAX; stat++)

		if ((status[stat].NumOfLinks == 2) && (status[stat].utente_attivo == ATTIVO))		
		
		/* sicuramente sono dopo HO_Step_4, quindi dopo la prima trama della multitrama:
		   prima della terza trama la MS in HO non pu trasmettere il flag */
		{
			/* flag SB */

			calc_sign_vett_succ_i_con_due_BS (status[stat].buffer_leng_i, stat); 
			calc_slot_richiesti (stat);
			
		}

	for (clust=0; clust < CLUSTER; clust++)

		for(stat=0; stat < NMAX; stat++)
		{	
	     /* se una MS ha una sola sottoportante, lascio uguale la procedura */

		 if ((status[stat].MyServBS == clust)
			 && (status[stat].MyOldBS == NO_NEW_DESTINATION_BS)
			 && (status[stat].utente_attivo == ATTIVO))          /* aggiunto */
		 {
			/* flag SB */

			calc_sign_vett_succ_i (clust, status[stat].buffer_leng_i,                
				                   BaseStation[clust].bc_prec_i, BaseStation[clust].bc_i,
								   &(BaseStation[clust].sign_vett_succ_i[status[stat].
								   mySubcarrier[clust]]), stat);                       
			
			calc_slot_richiesti (stat);
		 }
			/* la MS calcola il valore del flag di Hand Over HB */

		 if (((appbs = status[stat].MyServBS) != clust) 
			 && (status[stat].MyOldBS == NO_NEW_DESTINATION_BS)
			 && (status[stat].utente_attivo == ATTIVO))          /* aggiunto */
		 {	
			subcarr = status[stat].mySubcarrier[appbs];

			if (BaseStation[appbs].Sottoportante_abilitata[subcarr] == SI)  /* aggiunto */

				/* flag HB */
				
				calc_sign_vett_succ_per_HO_entrante (&(BaseStation[clust].dallaBS[appbs].
				                                     sign_vett_succ_x_HO_entrante[subcarr]),
												     stat, status[stat].NewBS, clust);
		 }

		}  /* fine ciclo for */


/*-------------------------------------------------------------------------------------------*/


				/* PROCEDURA DI HO DALLA BS NUMERO bs2 VERSO LA BS NUMERO bs1 */


/*	Richiesta del profilo							(STEP 1)
	
	Trasferimento del profilo d'utente richiesto	(STEP 2)
	
	Trasmissione della nuova portante alla MS 
    (durante l'ultima trama della multitrama)
	e cambio di Home Location Register				(STEP 3)
	
	MS riceve la nuova sottoportante				(STEP 4)
	
	MS rilascia la vecchia sottoportante			(STEP 5)  */
		

	for (bs1=0; bs1<CLUSTER; bs1++)
		
		for (bs2=0; bs2<CLUSTER; bs2++)

			if (bs2 != bs1)

				HO_Procedure (bs1, bs2, 
				              BaseStation[bs1].dallaBS[bs2].sign_vett_succ_x_HO_entrante, 
							  BaseStation[bs2].bc_i, 
							  BaseStation[bs1].oper_time_succ_i,
							  BaseStation[bs1].bc_succ_x_Portanti,
							  BaseStation[bs1].bc_x_Portanti,
							  BaseStation[bs1].bc_prec_x_Portanti);


/*-------------------------------------------------------------------------------------------*/
 

			                            /* CICLO SLOT */
			

	for (slot=0; slot<DIMFRAME; slot++) /* secondo ciclo temporale dove si fanno tutte le
										   azioni (rigurda le azioni compiute slot per slot) */									    
	{

		                      /* OPERAZIONI RELATIVE ALL'UPLINK */


		for (stat=0; stat<NMAX; stat++)  /* OPERAZIONI RELATIVE ALL'UPLINK: trasmissione di un 
										    pacchetto nello slot allocato e generazione di 
										    nuovi pacchetti */

			if (status[stat].utente_attivo == ATTIVO)   /* controllo aggiunto */
				
			{                                     
				app_pack_sent = 0;

				for (clust=0; clust<CLUSTER; clust++)
				{

				/* trasmissione del pacchetto di uplink dall'utente numero stat verso la BS
				   numero clust (mediante il time slot di uplink assegnato) */

				if ((status[stat].MyServBS == clust) || (status[stat].MyOldBS == clust))
				{
					if ((slot > DOWNLINK) && (slot != ACCESS_SLOT)              /* slot 33 */
						&& (BaseStation[clust].oper_time_i[slot].reserved == 0)
						&& (BaseStation[clust].oper_time_i[slot].assigned ==
						    status[stat].mySubcarrier[clust]) 
						&& (status[stat].mySubcarrier[clust] != NO_USER))
					{
						assigned[clust] ++; /* variabile globale contenente il numero totale di
											   slot di uplink allocati dalla BS numero clust */

						if (punt_buffer[stat] != NULL)   /* punt_buffer[stat] punta al buffer
														    dell'utente numero stat (il buffer
															dell'utente numero stat non  
															vuoto) */
						{
							pippo = punt_buffer[stat];

							Somma_di_tutti_i_tempi_di_attesa += pippo->clock;
							Somma_dei_pacchetti_generati_e_non_persi_in_uplink ++;

							del = (double)pippo->clock;

							del = (del * slot_duration);   /* secondi di ritardo con cui il
														      pacchetto di uplink trasmesso 
														  	  dall'utente numero stat  giunto
															  alla BS numero clust */
							
							utente_sorg = pippo->from;     /* deve coincidere con stat */
							utente_dest = pippo->dest;	   /*  il "compagno" */
							
							if (status[utente_dest].utente_attivo == NON_ATTIVO)
							{ 
								printf("\n\nOperazioni relative all'uplink");
								printf("\nTrama %d, slot %d:",frame, slot);
								printf("\nERRORE: l'utente numero %d e' attivo, mentre il ",
									     utente_sorg);
								printf("suo compagno (utente numero %d) e' non attivo", 
									     utente_dest);
								printf("\nSospendere la simulazione e capire la ");
								printf("causa di tale errore");
								getchar();
							}

							appdel = (long int) ceil (0.4 + del * 1000);   
																		    
							/* nella variabile appdel viene posta la parte intera superiore
							   (in ms) di "0.4+del*1000", cio la parte intera superiore del
							   tempo che  trascorso dal momento in cui il primo pacchetto del
							   buffer  stato generato al momento in cui tale pacchetto  
							   giunto alla BS (il valore "0.4" ms  pari al tempo necessario a
							   trasmettere tutti i bit del singolo pacchetto e serve a far s
							   che appdel non venga mai 0) */						

							if ((appdel > 0) && (appdel <= DIMISTOGRAMMA-2))

								status[utente_sorg].UpDelIst[appdel] ++;
							else
								if (appdel >= DIMISTOGRAMMA-1)

									status[utente_sorg].UpDelIst[DIMISTOGRAMMA-1] ++;						              

							for (clster=0; clster < CLUSTER; clster++)

								app_pack_sent += status[stat].pack_sent[clster]; 
																					
							    /* numero totale di pacchetti trasmessi dall'utente numero
								   stat prima di quello attuale */	
							
							status[stat].mean_delay = 
								(double)(((status[stat].mean_delay * app_pack_sent) + del) /
								        (app_pack_sent+1));
						
							/* vedo l'ordine di trasmissione ed il ritardo */

					     /* printf("\nutente %d pacchetto %d ritardoup %d", stat, pippo->num,
							        pippo->clock);  */

							punt_buffer[stat] = punt_buffer[stat]->next;
							pippo->next = NULL;
							
							/* il pacchetto trasmesso viene messo in coda al Buffer di
							   ricezione dell'utente numero "dest" nella BS che lo serve */
						
							Transfert_2 (pippo, utente_dest); /* trasmissione utente->buffer */						
							
							status[stat].pack_sent[clust] ++;

							Risultati[stat].Pacchetti_generati_ed_inviati_ad_una_BS ++; 

							used[clust] ++;	/* variabile globale contenente il numero di slot
											   di uplink assegnati ed effettivamente usati */

							calc_infopack_i (infopunt[clust], stat, clust);

							infopunt[clust] ++;
						}

						else	/* il buffer dell'utente numero stat  vuoto: incremento la
								   variabile globale che conta gli slot di uplink non usati */

							non_used[clust] ++;
					}
				}
				
				/*	incremento del clock dei pacchetti contenuti nei Buffer di utente,
				    eliminazione dei pacchetti persi da utenti video o voce e generazione di
				    nuovi pacchetti */				

				if (status[stat].MyServBS == clust)				
				{
					agg_clock (punt_buffer[stat]);

					if ((status[stat].kind_of_service != DATA64KBPS) 
						&& (status[stat].kind_of_service != DATA512KBPS))

						punt_buffer[stat] = togli_celle_perse (punt_buffer[stat], 
						                                       &(status[stat].pack_lost), 
															   (float)status[stat].maximum_del,
															   clust, stat);

					newpack = generate_pack (&(status[stat].state), &(status[stat].bit_rest),
						                     status[stat].kind_of_service, stat);

					Risultati[stat].Pacchetti_generati += newpack;

					status[stat].pack_gen += newpack;

					Pacchetti_generati += newpack;

					punt_buffer[stat] = agg_pack_x_PS (punt_buffer[stat], newpack, stat);
				}
			}
		}    /* fine if (status[stat].utente_attivo == ATTIVO) cio fine delle operazioni 
		        relative al canale di uplink */


				               /* OPERAZIONI RELATIVE AL DOWNLINK */

		/* trasmissione del pacchetto sul downlink nel time slot allocato all'utente associato
		   alla sottoportante numero "subcarr" della BS numero "clust" (il pacchetto da
		   trasmettere, generato dall'utente numero "utente_sorg",  quello che si trova in
		   testa al buffer di ricezione associato, nella BS numero "clust", alla sottoportante
		   numero "subcarr" cio alla sottoportante assegnata all'utente numero "utente" al
		   quale  destinato il pacchetto) */	 
		
		for (clust=0; clust < CLUSTER; clust++)    /* trasferimento di un pacchetto dal buffer
													  di ricezione della BS verso l'utente */
		{
			for (subcarr=0; subcarr < NCARRIER; subcarr++)
			{                
				utente = BaseStation[clust].table[subcarr].SubCarrierOf; /* aggiunto */			

				if (BaseStation[clust].Sottoportante_abilitata[subcarr] == SI)  /* aggiunto */
				{
					if ((slot < DOWNLINK) && (slot != CARRIER_SLOT))	/* slot 29 */				
					{
						/* se si entra nel seguente "if A" vuol dire che la BS numero "clust"
						   ha assegnato il time slot numero "slot" all'utente a cui in tale BS
						    associata la sottoportante numero "subcarr" */

		/* if A */  	if ((BaseStation[clust].oper_time_i[slot].reserved == 0)
							&& (BaseStation[clust].oper_time_i[slot].assigned == subcarr))
						{                                                           
							assigned_down[clust] ++;
							
							/* se si entra nel seguente "if B" vuol dire che nel buffer della
							   BS numero "clust" associato alla sottoportante numero "subcarr"
							    contenuto almeno un pacchetto, cio che all'utente numero
							   "utente"  diretto almeno un pacchetto (tale pacchetto deve
							   essere trasmesso dal buffer di ricezione verso il terminale
							   mobile) */

		      /* if B */	if (BaseStation[clust].BufRic[subcarr].buf != NULL) /* non vuoto */  
							{
								used_down[clust] ++;

								/* nella variabile "pippo" viene posto l'indirizzo del 
								   pacchetto che deve attualmente essere spedito all'utente
								   mobile numero "utente" */

								pippo = BaseStation[clust].BufRic[subcarr].buf;
								
								totdel = (double)pippo->clock;
								totdel *= slot_duration;								
								
								utente_sorg = pippo->from;  /*  il "compagno" di "utente" */								
								
								if (status[utente_sorg].utente_attivo == NON_ATTIVO) /* agg */
									
								{   /* a volte d problemi qui (errore) */

									printf("\n\nOperazioni relative al downlink");
								    printf("\nTrama %d, slot %d:",frame, slot);
								    printf("\nERRORE: l'utente numero %d e' attivo, mentre il",
									       utente);
								    printf(" suo compagno (utente numero %d) e' non attivo", 
									       utente_sorg);
									Errore_verificato = SI;
								}
								
								if (pippo->num < lastpacknum[utente])  /* fuori sequenza */
									out_of_seq[utente] ++;
								
								lastpacknum[utente] = pippo->num;      /* ultimo pacchetto	
																	      trasmesso */
						
							    appdel = (long int) ceil (0.4 + del*1000); /* parte intera
							                                                  superiore in
								                                              ms (ritardo) */

							    if ((appdel > 0) && (appdel <= DIMISTOGRAMMA-2))
									status[utente_sorg].TotDelIst[appdel] ++;
								else
									if (appdel >= DIMISTOGRAMMA-1)
										status[utente_sorg].TotDelIst[DIMISTOGRAMMA-1] ++;
									else
									{
										printf("\nTrama %d ERRORE: ESISTE UN PACCHETTO SUL ",
										         frame);
										printf("DOWNLINK CON RITARDO PARI A 0");
										getchar();
									}
									
								if (status[utente].NumOfLinks == 1) 
								{
									status[utente].whole_mean_delay = 
								        ((status[utente].whole_mean_delay * BaseStation[clust].
								          table[subcarr].sent + totdel) /
										 ((double)(BaseStation[clust].
									               table[subcarr].sent + 1)));
									
									if ((status[utente].mySubcarrier[clust] != subcarr)
										|| (BaseStation[clust].table[subcarr].SubCarrierOf !=
									        utente))	/* controllo */
									{
										printf ("\nTrama %d: ERRORE NEL CALCOLO DEL WHOLE ",
										           frame);
										printf("MEAN DELAY PER L'UTENTE NUMERO %d", utente);
										getchar();
									}
									
									clt = ((clust+1)%2);
									
									if (clt != clust)  /* controllo inutile */
										
										if (status[utente].mySubcarrier[clt] != NO_USER)
										{
											printf ("\n\nTrama %d: ERRORE NEL NUMERO ", frame);
											printf ("DELLE PORTANTI PER L'UTENTE ");
											printf ("NUMERO %d:", utente);
											printf ("\nNEL SUO TERMINALE, INFATTI, RISULTA ");
											printf ("UNA SOTTOPORTANTE CHE NON DOVREBBE AVERE");
										            
											printf ("\nCALCOLO DEL WHOLE MEAN DELAY PER ");
											printf ("L'UTENTE  %d", utente);
											getchar();
										}
								}
								
								else
									if (status[utente].NumOfLinks == 2)
									{
										app_pack_sent_down = 0;
										
										for (clt=0; clt < CLUSTER; clt++)
										{
											appsubcarr = status[utente].mySubcarrier[clt];
											
											if (appsubcarr == NO_USER)
											{
												printf("\n\nTrama %d: ", frame);
												printf("\nERRORE NEL NUMERO DI COLLEGAMENTI ");
												printf ("DI DOWNLINK ");
												printf("PER L'UTENTE NUMERO %d", utente);
												getchar();
											}
											
											app_pack_sent_down += 
												BaseStation[clt].table[appsubcarr].sent;
										}
										
										status[utente].whole_mean_delay =
								           ((status[utente].whole_mean_delay 
										     * app_pack_sent_down + totdel) /
									        ((double)(app_pack_sent_down + 1)));
									}

								/* le seguenti 4 istruzioni simulano la trasmissione del 
								   pacchetto dal buffer di ricezione della BS numero "clust"
								   verso il terminale mobile dell'utente numero "utente", cio
								   dell'utente che in tale BS utilizza la sottoportante di
								   segnalazione numero "subcarr" (buffer->utente) */

								status[pippo->from].pack_arrived ++; /* compagno di "utente" */
									
								BaseStation[clust].BufRic[subcarr].buf =
									BaseStation[clust].BufRic[subcarr].buf->next;
								
								Somma_di_tutti_i_BSclock += pippo->BSclock;
								Somma_dei_pacchetti_che_sono_stati_in_attesa ++;
								
	                            Somma_di_tutti_i_ritardi_totali += pippo->clock;
								Somma_dei_pacchetti_generati_e_giunti_a_destinazione ++;

								/* si deve fare una funzione che, se la sottoportante "subcarr"
								    in Soft HO, controlli la presenza nel buffer dell'altra BS
								   con cui l'utente  collegato del pacchetto appena trasmesso
								   all'utente dalla BS numero "clust". Se questo pacchetto  
								   presente anche nel buffer dell'altra BS, allora esso va
								   eliminato da tale buffer ("pippo"  l'indirizzo del 
								   pacchetto appena trasmesso dalla BS numero "clust") */

		/* aggiunto */			if (BaseStation[clust].Portante_in_SHO[subcarr].stato == SI)   
								{
									altra_portante = BaseStation[clust].Portante_in_SHO[subcarr].altra_portante;
	                                altra_BS = BaseStation[clust].Portante_in_SHO[subcarr].altra_BS;

	                                altro_punt = BaseStation[altra_BS].BufRic[altra_portante].buf;

									if (altro_punt != NULL)
										Elimina_eventuale_pacchetto (pippo, altra_portante, altra_BS);									
								}

								free (pippo);
									
								BaseStation[clust].BufRic[subcarr].lenght --;
									
								if (BaseStation[clust].BufRic[subcarr].buf == NULL)
								{
									BaseStation[clust].BufRic[subcarr].lenght = 0;
										
									if (status[utente].MyServBS != clust) 
									{
										appbs = status[utente].MyServBS;
										appsubcarr = status[utente].mySubcarrier[appbs];

										if (BaseStation[appbs].  
											Sottoportante_abilitata[appsubcarr] == SI)
										{
											if (BaseStation[appbs].table[appsubcarr].
													stop_trasm == 1)
											{
												BaseStation[appbs].table[appsubcarr].
												stop_trasm = 0;
												
											/*  printf("\nTrama numero %d:", frame);      
								                printf("inizia la trasmissione dei pacchetti dalla BS#%d",
                                                        appbs);
									            printf("all'utente numero %d",utente); 
									            printf("\n\tLunghezza del BufRic dell'altra BS: %d",
									                   BaseStation[clust].BufRic[subcarr].lenght);  
										
									            getchar();  */
											}
										}
									}
								}

								Risultati[utente].Pacchetti_ricevuti ++;     /* aggiunto */ 									
								BaseStation[clust].table[subcarr].sent ++;
								Pacchetti_ricevuti ++;
								
							}          /* fine if B */
						
						    else
								if (BaseStation[clust].BufRic[subcarr].buf == NULL) /* vuoto */
								{
									non_used_down[clust] ++;  /* slot assegnato ma non usato */	
								}
						}         /* fine if A */
						
						if ((BaseStation[clust].oper_time_i[slot].reserved == 1)
							&& (BaseStation[clust].oper_time_i[slot].assigned == subcarr))
						{
							printf("\n\nTrama %d, Slot %d: ERRORE:", frame, slot);
							printf("ESISTE UN PACCHETTO RISERVATO ASSEGNATO AD UNA PORTANTE");
							getchar();
						}
					}             /* fine delle operazioni relative al downlink, cio fine
					                 if (slot < DOWNLINK) */
									
                    /* incremento del clock dei pacchetti contenuti nei BufRic ed eliminazione
					   dei pacchetti persi (cio dei pacchetti che sostano nel buffer da un 
					   tempo superiore ai 30 ms) */
				
				    agg_clock_BS (BaseStation[clust].BufRic[subcarr].buf);
					
					if((BaseStation[clust].table[subcarr].kind != DATA64KBPS)
						&& (BaseStation[clust].table[subcarr].kind != DATA512KBPS)
						&& (BaseStation[clust].BufRic[subcarr].buf != NULL))					

					    BaseStation[clust].BufRic[subcarr].buf =
					
					     togli_celle_perse_in_downlink_2 (BaseStation[clust].BufRic[subcarr].buf, 
					                                      &(BaseStation[clust].table[subcarr].
												            pack_lost),
												          (float)status[BaseStation[clust].
												          table[subcarr].SubCarrierOf].
														  maximum_del,
												          &(BaseStation[clust].BufRic[subcarr].
													        lenght),
														  utente, clust, subcarr); 
				}

			}	             /* fine ciclo for "subcarr" */

		}            /* fine ciclo for "clust" */

	}       /* fine del secondo ciclo temporale (ciclo "slot") */

	
/*-------------------------------------------------------------------------------------------*/


    /* azzero stop_trasm nella BS servente (BS in cui l'utente sta andando) per le MS che hanno
	   BufRic vuoto nell'altra BS (BS da cui l'utente sta uscendo) */

	for (clust=0; clust<CLUSTER; clust++)

		for (subcarr=0; subcarr<NCARRIER; subcarr++)
		{
			/* se la trasmissione di downlink  bloccata */

			if ((BaseStation[clust].vettsubcfree[subcarr] != FREE) 
				&& (BaseStation[clust].Sottoportante_abilitata[subcarr] == SI)          
				&& (BaseStation[clust].table[subcarr].stop_trasm == 1)) 
				
				/* se non ci sono stati errori, una sottoportante non libera deve essere 
				   associata ad un utente attivo */
			{
				utente = BaseStation[clust].table[subcarr].SubCarrierOf;

				if (utente == NO_USER)         /* controllo aggiunto */
				{
					printf ("\n\nTrama numero %d (subito dopo la fine del ciclo slot)", frame);
					printf ("\nERRORE: una sottoportante abilitata e occupata risulta ");					 
					printf ("assegnata a nessun utente");
					printf ("\nSospendere la simulazione e ricercare la causa di tale ");
					printf ("problema");
					getchar();
				}

				else
					if (status[utente].utente_attivo == NON_ATTIVO)	 /* controllo aggiunto */			                        
					{
						printf ("\n\nTrama numero %d (subito dopo la fine del ciclo slot)",
							      frame);
					    printf ("\nERRORE: un utente non attivo ha una sottoportante ");
						printf ("abilitata e assegnata");
					    printf ("\nSospendere la simulazione e ricercare la causa di tale ");
					    printf ("problema");
					    getchar();
					}

				if ((status[utente].MyServBS == clust) &&
					(status[utente].MyOldBS != NO_NEW_DESTINATION_BS))
					
				{
					appbs = status[utente].MyOldBS;
					appsubcarr = status[utente].mySubcarrier[appbs];

					if ((BaseStation[appbs].BufRic[appsubcarr].lenght == 0) 
						&& (BaseStation[appbs].Sottoportante_abilitata[appsubcarr] == SI))
					{
						/* la trasmissione di downlink viene abilitata */

						BaseStation[clust].table[subcarr].stop_trasm = 0;
						BaseStation[appbs].BufRic[appsubcarr].buf = NULL;
					}
				}

				else
					if ((status[utente].MyServBS == clust)
						 && (status[utente].MyOldBS == NO_NEW_DESTINATION_BS))
						 
						 /* la trasmissione di downlink viene abilitata */
						  
						 BaseStation[clust].table[subcarr].stop_trasm = 0;
			}
		}


    /* Tramite tale ciclo for si decide quali utenti devono iniziare il Soft HO, cio quali 
	   utenti devono porre il campo "HO_REQ" ad 1 */

	for (stat=0; stat<NMAX; stat++)

		if (status[stat].utente_attivo == ATTIVO)  /* ho aggiunto un controllo */
		{
			status[stat].lastHOreq ++;  /*  trascorsa un'ulteriore trama dall'ultima richiesta
										   di HO dell'utente numero stat */

		    if (status[stat].NumOfLinks == 2)
			{
				status[stat].SoftHOFrames ++;  /* serve per i risultati finali */
			    status[stat].ContTwoLinks ++;
			}

		    if (status[stat].PossibleHOR == 0)  /* vale 0 allora l'utente numero stat, qualora
												   lo stato di qualit del suo collegamento 
												   fosse pari a 2, pu fare richiesta di HO 
												   (infatti se "PossibleHOR" vale 0, vuol dire
												   che dall'ultima richiesta di HO da parte
                                                   dell'utente numero stat sono trascorse 
												   almeno 15 trame e quindi tale utente pu
												   nuovamente richiedere un HO) */												   
			{
				for (clust=0; clust < CLUSTER; clust++)
				{
					if ((status[stat].quality_state[clust] == 2) 
					   && (status[stat].MyOldBS == NO_NEW_DESTINATION_BS))
					   
					   if ((status[stat].NumOfLinks == 1) && (status[stat].MyServBS == clust)) 

					   {          /* le ultime 2 condizioni sono di controllo */

					    status[stat].HO_REQ = 1; /* viene posto ad 1 in quanto, essendo 2 la
											        qualit del collegamento, allora l'utente 
												    numero stat deve richiedere HO */						                         

						status[stat].lastHOreq = -1; /* conta le trame dalla richiesta di HO al
						                                rilascio del vecchio collegamento */
		
						switch(status[stat].MyServBS)  /* riempio il campo "NewBS" */
						{
							case(0):status[stat].NewBS = 1; break;
							case(1):status[stat].NewBS = 0; break;
						}
						
					   }

					   else
					   {
						   printf ("Trama numero %d:", frame);  
					       printf ("ERRORE NELLA GENERAZIONE DEL FLAG DI HO PER L'UTENTE %d",
							       stat);
					       getchar();
					   }
				}
			}

		    else /* il campo "PossibleHOR" non  0 e quindi l'utente numero stat non pu 
				    richiedere HO in quanto, dalla sua ultima richiesta di HO, non sono ancora
					trascorse 15 trame */
			{
				status[stat].PossibleHOR ++;

			    if (status[stat].PossibleHOR > 15) /* numero minimo di trame che devono 
												      trascorrere tra due richieste di HO
													  successive (serve ad evitare una nuova 
													  richiesta quando ancora non  stata 
													  soddisfatta la prima) */
				    status[stat].PossibleHOR = 0;
			}

		}      /* fine if (status[stat].utente_attivo == ATTIVO) */


   /* il seguente ciclo for calcola lo stato di qualit in cui si trova il collegamento degli
	  utenti attivi */

	for (stat=0; stat < NMAX; stat++)

		for (clust=0; clust < CLUSTER; clust++)

			if ((status[stat].quality_state[clust] != NO_LINK) &&  
				(status[stat].utente_attivo == ATTIVO))         /* controllo aggiunto */

				CalcPacketQuality (&(status[stat].quality_state[clust]), stat, TIMEOFHO,
				                   TIMEOFSOFTHO);

	
   /* il seguente ciclo for calcola il numero medio di MS attive presenti in ogni cella */

	for (clust=0; clust < CLUSTER; clust++)
	{
		for (stat=0; stat < NMAX; stat++)
		{
			if ((status[stat].mySubcarrier[clust] != NO_USER) 
				&& (status[stat].utente_attivo == ATTIVO))      /* controllo aggiunto */
			{
				contaMS[clust] ++;

				if (status[stat].NumOfLinks == 2)
					 contaMSinSHO[clust] ++;
			}
		}
	}

	if(contaMSinSHO[0] != contaMSinSHO[1])
	{
		printf("\n\nERRORE NEL CALCOLO DELLE MS IN SOFT HO");
		getchar();
	}


/*-------------------------------------------------------------------------------------------*/


	                /* ANALISI DELLA FINESTRA TEMPORALE APPENA CONCLUSA */

		        
	if ((frame % WINFRAMES) == 0)   /* si  conclusa una finestra temporale e quindi si fa la
									   sua analisi */
	{
		contawinframes ++;  /* dall'inizio della simulazione  trascorsa un'ulteriore finestra
							   temporale */

		for (clust=0; clust < CLUSTER; clust++)
		{
			meanMS[clust] = (float)contaMS[clust]/WINFRAMES; /* Numero medio di MS nella cella
															    durante la finestra temporale 
			                                                    appena conclusa */

			meanMSinSHO[clust] = (float)contaMSinSHO[clust]/WINFRAMES; /* Numero medio di MS in
																	      Soft HO nella cella 
																		  durante la finestra 
			                                                              temporale appena 
			                                                              conclusa */
			contaMS[clust] = 0;
			contaMSinSHO[clust] = 0;   		

			k = (int)(meanMS[clust] + 0.5);      /* valore arrotondato di meanMS[clust] */
			j = (int)(meanMSinSHO[clust] + 0.5); /* valore arrotondato di meanMSinSHO[clust] */

			table_packlost[clust].single_tabpacklost[k][j].packet_lost +=
				(contapacklostup[clust] + contapacklostupMSinSHO/2);

			Pacchetti_persi_in_downlink[clust].tabella[k][j].pacchetti_persi +=  /* aggiunto */
				(contapacklostdown[clust] + contapacklostdownMSinSHO/2);

			packlostup[clust] += (contapacklostup[clust] + contapacklostupMSinSHO/2);			

			packlostdown[clust] += (contapacklostdown[clust] + contapacklostdownMSinSHO/2); /* aggiunto */

			totpacklostupMSinSHO += contapacklostupMSinSHO/2;

			totpacklostdownMSinSHO += contapacklostdownMSinSHO/2;   /* aggiunto */

			global_vett_packlost[2*(k-j)+j].packet_lost +=
				    (contapacklostup[clust] + contapacklostupMSinSHO/2);

			global_vett_packlost[2*(k-j)+j].time ++;		

			if ((contapacklostupMSinSHO%2) == 1)  /* se il numero di pacchetti persi in uplink
												     dalle MS in SHO nel corso della finestra
													 attuale  dispari, considero 1 pacchetto
													 perso in pi nella prima BS */ 
			{
				table_packlost[clust].single_tabpacklost[k][j].packet_lost ++;
				packlostup[clust] ++;
				contapacklostupMSinSHO --;
			}

			if ((contapacklostdownMSinSHO%2) == 1)  /* aggiunto (analogo al precedente ma 
												                 relativo al downlink) */
			{
				Pacchetti_persi_in_downlink[clust].tabella[k][j].pacchetti_persi ++;
				packlostdown[clust] ++;
				contapacklostdownMSinSHO --;
			}

			table_packlost[clust].single_tabpacklost[k][j].time ++;
			contapacklostup[clust] = 0;

			Pacchetti_persi_in_downlink[clust].tabella[k][j].tempo ++;   /* aggiunto */
			contapacklostdown[clust] = 0;                                /* aggiunto */


			table_packlost[clust].single_tabpacklost[k][j].req_assigned +=
				conta_del_req_slot_ass[clust];

			table_packlost[clust].single_tabpacklost[k][j].random_assigned +=
				conta_random_slot_ass[clust];

			conta_del_req_slot_ass[clust] = 0;
			conta_random_slot_ass[clust] = 0;
		}

		contapacklostupMSinSHO = 0;

		contapacklostdownMSinSHO = 0;    /* aggiunto */

	}    /* fine analisi della finestra temporale */

	
/*-------------------------------------------------------------------------------------------*/

	
	for (clust=0; clust < CLUSTER; clust++)
	{
	    /* il seguente ciclo azzera il vettore "infopack_i[DIMFRAME]" nella sua parte non usata 
		   (infopunt[clust] rappresenta il numero del primo time slot della trama che non 
		   stato usato) */

		while(infopunt[clust] < DIMFRAME)  
		{
			BaseStation[clust].infopack_i[infopunt[clust]].ps = NO_USER;
			BaseStation[clust].infopack_i[infopunt[clust]].info = NO_USE;

			infopunt[clust] ++;
		}		

		for (stat=0; stat < NMAX; stat++)

			if ((status[stat].MyServBS == clust) 
				&& (status[stat].MyOldBS == NO_NEW_DESTINATION_BS)
				&&(status[stat].utente_attivo == ATTIVO))           /* controllo aggiunto */

			{	/* se la MS attiva ha una sola sottoportante lascio immutato */

				if (BaseStation[clust].sign_vett_succ_i[status[stat].mySubcarrier[clust]] == 0)
				{
					axes = 0;

					for (ll=DOWNLINK+UP_RESERV+1; ll<DIMFRAME; ll++)  /* modificato ("+1") */
					{
						if (BaseStation[clust].bc_i[ll] == status[stat].mySubcarrier[clust])
							axes ++;

						/* ora la variabile del main "axes" contiene il numero di time slot di
						   uplink della trama successiva che la BS numero clust ha allocato
						   all'utente numero stat */
					}

					status[stat].slots_to_ask = status[stat].buffer_leng_i + 2*axes;

					/* "slots_to_ask"  il numero di time slot di uplink che l'utente numero
					   stat deve richiedere alla BS numero clust */
				}
			}
	}

	/* devo considerare se la MS attiva ha 2 sottoportanti ? */

	for (stat=0; stat < NMAX; stat++)
	{
		if ((status[stat].MyOldBS != NO_NEW_DESTINATION_BS) 
			&& (BaseStation[0].sign_vett_succ_i[status[stat].mySubcarrier[0]]==0) 
			&& (BaseStation[1].sign_vett_succ_i[status[stat].mySubcarrier[1]]==0)
			&& (status[stat].utente_attivo == ATTIVO))
		{
			axes = 0;

			for (clust=0; clust < CLUSTER; clust++)

				for(ll=DOWNLINK+UP_RESERV+1; ll < DIMFRAME; ll++)   /* modificato ("+1") */
				{
					if(BaseStation[clust].bc_i[ll] == status[stat].mySubcarrier[clust])

						axes ++; /* alla fine del ciclo, "axes" contiene il numero di time slot
								    di uplink allocati all'utente stat nella trama successiva
									cio "axes" rappresenta il numero A(i+1) usato nella tesi
					                di Gabriele */
				}

			status[stat].slots_to_ask = status[stat].buffer_leng_i + 2*axes;

			/* "slots_to_ask"  il numero di time slot di uplink che l'utente numero stat deve
			    richiedere alla BS numero clust */
		}
	}

	Procedura_di_fine_Comunicazione_e_Liberazione_Sottoportante ();  /* aggiunta */


/*-------------------------------------------------------------------------------------------*/


	             /* AGGIORNAMENTI DA ESEGUIRE AL TERMINE DELLA TRAMA ATTUALE */


	/* il seguente ciclo for effettua l'aggiornamento della lunghezza del buffer degli utenti
	   che sono attivi */
				
	for (clust=0; clust < CLUSTER; clust++)
	{
		for (stat=0; stat < NMAX; stat++)

			if ((status[stat].MyServBS == clust) && (status[stat].utente_attivo == ATTIVO))
			{                                                    

		    /*  giusto che le prime 2 seguenti assegnazioni le faccia solo se  attivo ? */

				status[stat].buffer_leng_prec2_i = status[stat].buffer_leng_prec_i; /* ? */
				status[stat].buffer_leng_prec_i = status[stat].buffer_leng_i;       /* ? */
				status[stat].buffer_leng_i = status[stat].buffer_leng_succ_i;

				pippo = punt_buffer[stat];  /* indirizzo del buffer dell'utente numero stat */
				contabuf = 0;

				while (pippo != NULL)
				{
					pippo = pippo->next;
					contabuf ++; 
				}

				/* ora nella variabile del main "contabuf"  presente il numero di pacchetti
				   che sono attualmente presenti nel buffer dell'utente numero stat */

				status[stat].buffer_leng_succ_i = contabuf;

				if (status[stat].buffer_leng_i > status[stat].max_lenght)
					status[stat].max_lenght = status[stat].buffer_leng_i;
			}
	} 

    /* il seguente ciclo aggiorna in ciascuna BS i vari vettori di segnalazione (SB ed HB) */

	for (clust=0; clust < CLUSTER; clust++)  /* clust  la BS di destinazione */
	{
		for (bs=0; bs < CLUSTER; bs++) /* bs  la BS di origine */

			if(clust != bs)
			{
				copy (BaseStation[clust].dallaBS[bs].sign_vett_x_HO_entrante,
					  BaseStation[clust].dallaBS[bs].sign_vett_prec_x_HO_entrante, NCARRIER);

				copy (BaseStation[clust].dallaBS[bs].sign_vett_succ_x_HO_entrante,
					  BaseStation[clust].dallaBS[bs].sign_vett_x_HO_entrante, NCARRIER);
			}

		copy (BaseStation[clust].sign_vett_i,BaseStation[clust].sign_vett_prec_i, NCARRIER);
		copy (BaseStation[clust].sign_vett_succ_i,BaseStation[clust].sign_vett_i, NCARRIER);

		/* il seguente ciclo calcola l'uso di ciascuna sottoportante della BS numero clust */

		for (i=0; i<NCARRIER; i++)
		{
			if(BaseStation[clust].sign_vett_i[i] != NO_USER)
			{
				BaseStation[clust].Use_of_subc_gross[i] += BaseStation[clust].sign_vett_i[i];

				if ((BaseStation[clust].vettsubcfree[i] == NOT_FREE) 
					&& (BaseStation[clust].Sottoportante_abilitata[i] == SI))  /* aggiunto */

					BaseStation[clust].conta_time_not_free[i] ++;

				else 
					if ((BaseStation[clust].sign_vett_i[i] == 1) 
						&& (BaseStation[clust].Sottoportante_abilitata[i] == SI))  
						
						BaseStation[clust].conta_time_not_free[i] ++;
			}
		}

		/* aggiornamento della Broadcast Cell inviata dalla BS numero clust */
			
		copy (BaseStation[clust].bc_i, BaseStation[clust].bc_prec_i, DIMFRAME);
		copy (BaseStation[clust].bc_succ_i, BaseStation[clust].bc_i, DIMFRAME);

		/* aggiornamento delle informazioni relative ai time slot della trama */

		copy_opr (BaseStation[clust].oper_time_succ_i, BaseStation[clust].oper_time_i);
		copy_opr (BaseStation[clust].oper_time_succ2_i, BaseStation[clust].oper_time_succ_i);

		/* aggiornamento delle informazioni relative ai pacchetti trasmessi alla BS numero 
		   clust durante la trama */

		copy_infopack (BaseStation[clust].infopack_i, BaseStation[clust].infopack_prec_i);
			
	}

	Aggiorna_contatori (NMAX);   /* aggiunta (incrementa il numero di trame di attivit di
	                                ciascun utente attivo) */	

}           /* fine del primo ciclo temporale (ciclo "frame") */


/*-------------------------------------------------------------------------------------------*/


                   /*  SCRITTURA DEI RISULTATI FINALI SUL FILE DI USCITA  */


Aggiorna_alcuni_dati ();                   /* aggiornamenti per gli utenti ancora attivi */

pfile = fopen(NomeDefinitivo,"wt");        /* apertura del file in scrittura */

Stampa_risultati_iniziali (pfile, TIMEOFHO, TIMEOFSOFTHO, somma_utenti);

Stampa_riga_di_separazione (pfile);

Stampa_dati_sulla_mobility (pfile, mobility);

Stampa_riga_di_separazione (pfile);

Stampa_informazioni_su_HO (pfile);

Stampa_il_numero_medio_di_trame_con_due_collegamenti (pfile, totHOriusciti);

Stampa_riga_di_separazione (pfile);

/*-------------------------------------------------------------------------------------------*/


                                  /* RISULTATI PER OGNI MS */

/* a volte c' un piccolo errore sui pacchetti rimasti nel buffer di ricezione di un utente
   (ci si verifica quando, terminata la comunicazione o terminata la simulazione, il compagno
   di tale utente aveva finito il quarto passo di HO) */

/* Il seguente ciclo for calcola il numero totale di pacchetti persi sull'uplink (coincide con
   l'altro valore solo se "NUMFRAME"  multiplo di "WINFRAME") */

for (clust=0; clust<CLUSTER; clust++)
	totpacklostup += packlostup[clust];   /* variabili del main */

Stampa_risultati_per_ciascuna_MS (pfile, Pacchetti_generati, totpacklostup);  

/*-------------------------------------------------------------------------------------------*/


                                 /*  RISULTATI COMPLESSIVI  */


fprintf(pfile,"\n\n\n\t\t\t\t\t\t\t\t***** RISULTATI COMPLESSIVI *****");

fprintf(pfile,"\n\n\n\t\t\t\t\t\t\t  INFORMAZIONI SUI TIME SLOTS ASSEGNATI");

Stampa_informazioni_sui_time_slots (pfile); 

Stampa_riga_di_separazione (pfile);

Stampa_informazioni_su_utenti_attivi (pfile, numero_di_trama, Utenti_tutti_non_attivi);


/*-------------------------------------------------------------------------------------------*/

fprintf(pfile,"\n\n\n  \t\t\t\t\t\t\t\tINFORMAZIONI SUI PACCHETTI");

Stampa_informazioni_sui_pacchetti (pfile, Pacchetti_generati, Pacchetti_ricevuti, totpacklostup);

Stampa_pacchetti_persi_in_uplink_e_downlink (pfile, totpacklostup, packlostup,
											 totpacklostupMSinSHO, totpacklostdownMSinSHO);                

Stampa_pacchetti_ricevuti_fuori_sequenza (pfile, out_of_seq);  /* numero di pacchetti ricevuti
                                                                  fuori sequenza da ogni 
                                                                  utente */
Stampa_riga_di_separazione (pfile);

Stampa_alcune_percentuali_sui_pacchetti (pfile);

Stampa_riga_di_separazione (pfile);

/*-------------------------------------------------------------------------------------------*/

fprintf(pfile,"\n\n\n  \t\t\t\t\t\t\tTEMPI MEDI DI ATTESA (RITARDI)");

Stampa_tempo_medio_di_attesa_nel_BufRic (pfile, Somma_di_tutti_i_BSclock, Somma_dei_pacchetti_che_sono_stati_in_attesa);

Stampa_tempo_medio_di_attesa_nel_buffer_di_utente (pfile, Somma_di_tutti_i_tempi_di_attesa, Somma_dei_pacchetti_generati_e_non_persi_in_uplink);

Stampa_tempo_medio_di_attesa_totale (pfile, Somma_di_tutti_i_ritardi_totali, Somma_dei_pacchetti_generati_e_giunti_a_destinazione);

Stampa_riga_di_separazione (pfile);

/*-------------------------------------------------------------------------------------------*/

Stampa_durata_media (pfile);              /* durata media di una comunicazione */

Stampa_tempo_di_attesa_medio (pfile);     /* tempo di attesa medio per ottenere una
                                             sottoportante */

Stampa_percentuali (pfile, collegamenti_terminati);  /* percentuali di comunicazioni terminate
													    spontaneamente e a causa di un HO
														fallito e percentuali di pacchetti
                                                        persi */

/*-------------------------------------------------------------------------------------------*/

/* SCRITTURA DELLE MATRICI CONTENENTI IL NUMERO DI PACCHETTI PERSI IN UPLINK E DOWNLINK IN
   FUNZIONE DEL NUMERO DI MS PRESENTI MEDIAMENTE IN UNA CELLA CELLA */         

Stampa_risultati_di_uplink_in_funzione_delle_MS (pfile, contawinframes, packlostup);

Stampa_riga_di_separazione (pfile);

Stampa_risultati_di_downlink_in_funzione_delle_MS (pfile, contawinframes, packlostdown);


/*-------------------------------------------------------------------------------------------*/

Stampa_riga_di_separazione (pfile);                   

Stampa_risultati_globali_di_uplink_in_funzione_delle_MS (pfile, totpacklostup, contawinframes, global_vett_packlost);

Stampa_riga_di_separazione (pfile);

if (Errore_verificato == SI)
{
	fprintf (pfile, "\n\nSI E' VERIFICATO ALMENO UN ERRORE DURANTE LA SIMULAZIONE");
}

if (Errore_verificato == NO)
{
	fprintf (pfile, "\n\nNON SI E' VERIFICATO ALCUN ERRORE DURANTE LA SIMULAZIONE");
}

Stampa_riga_di_separazione (pfile);

/* fine scrittura dei risultati finali */

/*-------------------------------------------------------------------------------------------*/

fclose (pfile);

DistruggiTutto ();

}              /* fine ciclo "mobility" */

}   /* fine ciclo "simulazione" */  
       
return(0);

}									 /* FINE MAIN */


/*-------------------------------------------------------------------------------------------*/
